/*program test;

include "tmapa.h";
include "tscroll.h";

global
enem_grafs[5];
tipo_mapa;
//variables del scroll del mapa
    t_mapa durezas;
    t_mapa nivel;
    tscroll id_tscroll;
    
local
energia;
include "load_tmap.inc";
include "tscroll.inc";
include "tmapa.inc";
begin
end*/

//**************************************************************************************************
//  FUNCIONES AUXILIARES
//**************************************************************************************************
function veo_prota (x,y,veo_dir,veo_distx,veo_disty)
private
    temp;
    dato_a_devolver;
begin
    dato_a_devolver=false;
    if (exists(info_prota.id_prota))
        if (abs(info_prota.id_prota.y2-y) < veo_disty)
            temp=info_prota.id_prota.x2-x;
            if ((veo_dir==1) && (temp>0) && (temp<veo_distx))
                dato_a_devolver=true;
            end
            if ((veo_dir==0) && (temp<0) && (abs(temp)<veo_distx))
                dato_a_devolver=true;
            end
            if ((veo_dir==2) && (abs(temp)<veo_distx))
                dato_a_devolver=true;
            end
        end
    end
    
    return (dato_a_devolver);
end

function veo_prota2 (x,y,veo_distx1,veo_disty1,veo_distx2,veo_disty2)
private
    temp;
    dato_a_devolver;
begin
    dato_a_devolver=false;
    //reordenamos las distancias, para hacerlo todo ms homogeneo
    if (veo_disty2<veo_disty1)
        temp=veo_disty1;
        veo_disty1=veo_disty2;
        veo_disty2=temp;
    end
    if (veo_distx2<veo_distx1)
        temp=veo_distx1;
        veo_distx1=veo_distx2;
        veo_distx2=temp;
    end
    
    //say("lmites x: "+itoa(veo_distx1)+" "+itoa(veo_distx2));
    //say("lmites y: "+itoa(veo_disty1)+" "+itoa(veo_disty2));
    //say(itoa(info_prota.id_prota.x2)+" "+itoa(x));
    //say(itoa(info_prota.id_prota.y2)+" "+itoa(y));
    if (exists(info_prota.id_prota))
        temp=info_prota.id_prota.y2-y;
        if ((temp > veo_disty1) && (temp < veo_disty2))
            temp=info_prota.id_prota.x2-x;
            if ((temp > veo_distx1) && (temp < veo_distx2))
                dato_a_devolver=true;
            end
        end
    end
    
    return (dato_a_devolver);
end

process enem_explos (x2,y2,vel_horiz,vel_vert)
private
    int cont_anim;
begin
    z=father.z-1;
    file=explosion_grafs;
    graph=1;
    while (graph<=6)
        cont_anim++;
        if (cont_anim==3)
            cont_anim=0;
            graph++;
        end
        x2+=vel_horiz;
        y2+=vel_vert;
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        frame;
    end
end

//**************************************************************************************************
//  Efectos auxiliares ENEMIGOS
//**************************************************************************************************

process enem_temblor (enem_id,energia)
private
    cont;
begin
    if (exists(enem_id)) priority=enem_id.priority-1; end
    while (energia>0)
        if (exists(enem_id))
            angle+=90000;
            angle=angle%360000;
            //say(itoa(angle)+" "+itoa(energia*sin(angle)));
            enem_id.x+=energia*sin(angle);
            if (angle==270000) energia--; end
            frame;
        else
            break;
        end
    end
end

process enem_temblor2 (enem_id,energia)      //usar con enemigos estticos
private
    cont;
begin
    if (exists(enem_id))
        priority=enem_id.priority-1;
        x=enem_id.x;
        //y=enem_id.y;
    end
    while (energia>0)
        if (exists(enem_id))
            angle+=90000;
            angle=angle%360000;
            //say(itoa(angle)+" "+itoa(energia*sin(angle)));
            enem_id.x=x+energia*sin(angle);
            if (angle==270000) energia--; end
            frame;
        else
            break;
        end
    end
    if (exists(enem_id)) enem_id.x=x; end
end

process enem_xtemblor (enem_id,energia,resolution)
private
    cont;
begin
    if (exists(enem_id)) priority=enem_id.priority-1; end
    while (energia>0)
        if (exists(enem_id))
            angle+=90000;
            angle=angle%360000;
            //say(itoa(angle)+" "+itoa(energia*sin(angle)));
            enem_id.x+=energia*resolution*sin(angle);
            if (angle==270000) energia--; end
            frame;
        else
            break;
        end
    end
end

process enem_smoke (file,int graph1,int graph2,x2,y2,flags)
private
    cont;
begin
    priority=-99;
    graph=graph1;
    loop
        if (cont==10)
            if (graph < graph2) graph++; end
            cont=0;
        end
        cont++;
        alpha--;
        if (alpha==0) break; end
        
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        frame;
    end
end

process visual_fx (file,graph,x2,y2,cont,flags)
begin
    priority=-99;
    loop
        if (cont==0) break; end
        cont--;
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        frame;
    end
end

//**************************************************************************************************
//  ENEMIGOS (por orden alfabtico)
//**************************************************************************************************
process blobo (int enem_tx, int enem_ty, energia)
private
    int resolution3;
    int x3,y3;
    
    int enem_estado2;       //0: en pausa
                            //1: andando izquierda
                            //2: andando derecha
                            //3: persiguiendo
                            
    int enem_gravedad;
    int enem_max_gravedad;
    int enem_salto;
    
    int vel_horiz,vel_vert;
    int vel_horiz_ant;
    
    int cont_anim;
    int temp;
    int temp_espada;
    
    //variables para la deteccin de durezas
    int enem_dur[2][2];
    int enem_tilex, enem_tiley;
    int enem_offsx, enem_offsy;
    int enem_mover_h, enem_mover_v;
    int enem_p_dir, enem_p_dir_ini;
    int enem_estado;
    int p_libre;
begin
    priority=-99;
    file=enem_grafs[0][cte_blobo];
    z=1;
    enem_gravedad=2;
    enem_max_gravedad=30;
    enem_salto=40;
    
    x2=(enem_tx*id_tscroll.tmapa[0].ancho_tile) + (id_tscroll.tmapa[0].ancho_tile/2);
    y2=(enem_ty*id_tscroll.tmapa[0].alto_tile) + (id_tscroll.tmapa[0].alto_tile-1);
    resolution3=10;
    x3=x2*resolution3;
    y3=y2*resolution3;
    energia=4;
    
    modificar_tile(&nivel,enem_tx,enem_ty,0,0);
    temp=obtener_tile(&durezas,enem_tx,enem_ty,0);
    
    //estableciendo comportamiento inicial
    switch (temp)
    case 255: enem_estado2=0; end
    case 253: enem_estado2=1; end
    case 254: enem_estado2=2; end
    default: enem_estado2=1; end
    end //switch
    
    loop
        //cambios de estado
        switch (enem_estado2)
        case 0:
            if (veo_prota(x2,y2,2,50,20))
                enem_estado2=3;
            end
        end
        case 1:
            vel_horiz--;
            if (vel_horiz<-10) vel_horiz=-10; end
        end
        case 2:
            vel_horiz++;
            if (vel_horiz>10) vel_horiz=10; end
        end
        case 3:
            if (exists(info_prota.id_prota))
                if (info_prota.id_prota.x2<=x2)
                    vel_horiz--;
                    if (vel_horiz<-10) vel_horiz=-10; end
                else
                    vel_horiz++;
                    if (vel_horiz>10) vel_horiz=10; end
                end
                //si llegamos a un borde, damos un salto
                if ((info_prota.id_prota.y2-y2) <= 0)
                    switch (enem_dur[1][2])
                    case 0,50,32,33,34,82,83,84,100,104:
                        if ((enem_estado==0) || (enem_estado==1))
                            vel_vert=-enem_salto;
                            enem_estado=3;
                        end
                    end
                    end //switch
                end
            else
                if (vel_horiz>0) vel_horiz--; end
                if (vel_horiz<0) vel_horiz++; end
            end
        end
        end //switch
        vel_horiz_ant=vel_horiz;
        
        //gravedad
        vel_vert+=enem_gravedad;
        if (vel_vert > enem_max_gravedad) vel_vert=enem_max_gravedad; end
        
        //DETECCION DE DUREZAS
        //localizamos la posicin actual
        enem_tilex= (x3/resolution3)/id_tscroll.tmapa[0].ancho_tile;
        enem_tiley= (y3/resolution3)/id_tscroll.tmapa[0].alto_tile;
        enem_offsx= (x3/resolution3)%id_tscroll.tmapa[0].ancho_tile;
        enem_offsy= (y3/resolution3)%id_tscroll.tmapa[0].alto_tile;
        //leemos durezas de su alrededor
        enem_dur[0][0]=obtener_tile(&durezas,enem_tilex-1,enem_tiley-1,0);
        enem_dur[1][0]=obtener_tile(&durezas,enem_tilex  ,enem_tiley-1,0);
        enem_dur[2][0]=obtener_tile(&durezas,enem_tilex+1,enem_tiley-1,0);
        enem_dur[0][1]=obtener_tile(&durezas,enem_tilex-1,enem_tiley  ,0);
        enem_dur[1][1]=obtener_tile(&durezas,enem_tilex  ,enem_tiley  ,0);
        enem_dur[2][1]=obtener_tile(&durezas,enem_tilex+1,enem_tiley  ,0);
        enem_dur[0][2]=obtener_tile(&durezas,enem_tilex-1,enem_tiley+1,0);
        enem_dur[1][2]=obtener_tile(&durezas,enem_tilex  ,enem_tiley+1,0);
        enem_dur[2][2]=obtener_tile(&durezas,enem_tilex+1,enem_tiley+1,0);
        //comprobamos si cambiamos de tile y en que direccion
        //***************************************************************
        enem_mover_h=0;
        if (((x3+vel_horiz)/(id_tscroll.tmapa[0].ancho_tile*resolution3))!=enem_tilex)
           //comprobamos si pasamos a otro tile lateral y cuan lejos esta
           enem_mover_h=((x3+vel_horiz)/(id_tscroll.tmapa[0].ancho_tile*resolution3))-enem_tilex;
        end
        
        enem_mover_v=0;
        if (((y3+vel_vert)/(id_tscroll.tmapa[0].alto_tile*resolution3))!=enem_tiley)
           //comprobamos si pasamos a otro tile vertical y cuan lejos esta
           enem_mover_v=((y3+vel_vert)/(id_tscroll.tmapa[0].alto_tile*resolution3))-enem_tiley;
        end
         //miramos en que direccion cambiamos
        enem_p_dir=5;
        if (enem_mover_h>0) enem_p_dir++; end
        if (enem_mover_h<0) enem_p_dir--; end
        if (enem_mover_v>0) enem_p_dir-=3; end      //hacia abajo
        if (enem_mover_v<0) enem_p_dir+=3; end      //hacia arriba
        enem_p_dir_ini=enem_p_dir;
        
        include "durezas_check.inc";
        
        //post anlisis
        if ( (vel_horiz!=0) && (enem_estado==0) )
            enem_estado=1;
        end
        if ( (vel_horiz==0) && (enem_estado==1) )
            enem_estado=0;
        end
        
        switch (enem_estado2)
        case 1:                     //andando izquierda
            switch (enem_dur[1][1])
            case 254:
                enem_estado2=2;
                //cont_estado=0;
            end
            case 251:       //flecha hacia arriba (salta)
                if ((enem_estado==1) || (enem_estado==0))
                    vel_vert=-enem_salto;
                    enem_estado=3;
                end
            end
            default:       //choque con pared
                if ((vel_horiz_ant!=0) && (vel_horiz==0)) enem_estado2=2; end
            end
            end //switch
        end
        case 2:                     //andando derecha
            switch (enem_dur[1][1])
            case 253:
                enem_estado2=1;
                //cont_estado=0;
            end
            case 251:       //flecha hacia arriba (salta)
                if ((enem_estado==1) || (enem_estado==0))
                    vel_vert=-enem_salto;
                    enem_estado=3;
                end
            end
            default:       //choque con pared
                if ((vel_horiz_ant!=0) && (vel_horiz==0)) enem_estado2=1; end
            end
            end //switch
        end
        case 3:
            //si se para porque choca con una pared, comprueba si puede seguir con un salto
            if (vel_horiz==0)
                if (vel_horiz_ant>0)
                    switch (enem_dur[2][0])
                    case 1,2,5,14,51,52,55,64:
                        p_libre=false;
                    end
                    default: p_libre=true; end
                    end //switch
                    
                    switch (obtener_tile(&durezas,enem_tilex+1,enem_tiley-2,0))
                    case 1,2,5,14,51,52,55,64:
                        p_libre=(p_libre || false);
                    end
                    default: p_libre=true; end
                    end //switch
                end
                if (vel_horiz_ant<0)
                    switch (enem_dur[0][0])
                    case 1,3,4,16,51,53,54,66:
                        p_libre=false;
                    end
                    default: p_libre=true; end
                    end //switch
                    
                    switch (obtener_tile(&durezas,enem_tilex-1,enem_tiley-2,0))
                    case 1,3,4,16,51,53,54,66:
                        p_libre=(p_libre || false);
                    end
                    default: p_libre=true; end
                    end //switch
                end
                if (vel_horiz_ant==0) p_libre=false; end
            
                // si se puede, pues salta
                if (p_libre && ((enem_estado==1) || (enem_estado==0)))
                    vel_vert=-enem_salto;
                    enem_estado=3;
                end
            end
        end
        end //switch
        
        //zona de grficos
        switch (enem_estado2)
        case 0: graph=1; end
        default:
            if (vel_horiz<0) flags=0; end
            if (vel_horiz>0) flags=1; end
            switch (enem_estado)
            case 0: graph=1; end
            case 1:
                cont_anim++;
                if (cont_anim==5) graph++; cont_anim=0; end
                if (graph>8) graph=2; end
            end
            case 3: 
                if (vel_vert<0) graph=9; else graph=10; end
                cont_anim=4;
            end
            end //switch
        end
        end //switch
        
        //*************************
        //  ZONA DE IMPACTOS
        //*************************
        if (exists(info_prota.id_prota))
            //impacto con las balas
            if ((abs(x-info_prota.id_prota.x)<350) && (abs(y-info_prota.id_prota.y)<350))
                temp=collision(type normal_shot);
                while (temp)
                    energia-=temp.energia;
                    //say("enemigo ("+itoa(enem_tx)+","+itoa(enem_ty)+"): energa: "+itoa(energia));
                    //say("el disparo tena energia: "+itoa(temp.energia));
                    temp.energia=0;
                    if (mi_temblor!=0 && exists(mi_temblor))
                        mi_temblor.energia=3;
                    else
                        mi_temblor=enem_temblor(id,3);
                    end
                    temp=collision(type normal_shot);
                end
            end
            
            if ((abs(x-info_prota.id_prota.x)<50) && (abs(y-info_prota.id_prota.y)<50))
                temp=collision(type espadazo);
                if (temp && (temp!=temp_espada))
                    energia-=temp.energia;
                    if (mi_temblor!=0 && exists(mi_temblor))
                        mi_temblor.energia=3;
                    else
                        mi_temblor=enem_temblor(id,3);
                    end
                    temp_espada=temp;
                end
            end
                
            if (energia<=0) break; end
        
            //impacto con el prota
            if ((abs(x-info_prota.id_prota.x)<50) && (abs(y-info_prota.id_prota.y)<50))
                if (collision(info_prota.id_prota))
                    info_prota.dano_id=id;
                    info_prota.dano_energia=3;
                    info_prota.dano_exp=3;
                    if (info_prota.id_prota.x2>x2) info_prota.dano_vel_horiz=20;
                    else info_prota.dano_vel_horiz=-20;
                    end
                end
            end
        end
        
        x2=x3/resolution3;
        y2=y3/resolution3;
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        frame;
    end
    
    random_item (2,x2,y2-(id_tscroll.tmapa[0].ancho_tile/2));
    enem_explos(x2,y2-8,0,0);
end

process canon (int enem_tx, int enem_ty, file,flags)
private
    int cont_estado;
    int temp_x,temp_y;
    
    int temp;
    int temp_espada;
begin
    priority=-99;
    graph=1;
    z=0;
    
    x2=(enem_tx*id_tscroll.tmapa[0].ancho_tile) + (id_tscroll.tmapa[0].ancho_tile/2);
    y2=(enem_ty*id_tscroll.tmapa[0].alto_tile) + (id_tscroll.tmapa[0].alto_tile-1);
    modificar_tile(&nivel,enem_tx,enem_ty,0,0);
    energia=100;
    
    if (flags==1) temp_x=-16; else temp_x=16; end
    temp_y=-6;
    
    loop
        cont_estado++;
        switch (cont_estado)
        case 150: enem_canon_shot(file,2,x2+temp_x,y2+temp_y,flags,10); end
        case 153,156,159,162,165,168,171,174,177: enem_canon_shot(file,3,x2+temp_x,y2+temp_y,flags,10); end
        case 180: enem_canon_shot(file,4,x2+temp_x,y2+temp_y,flags,10); cont_estado=0; end
        end //switch
        
        //*************************
        //  ZONA DE IMPACTOS
        //*************************
        if (exists(info_prota.id_prota))
            //impacto con las balas
            if ((abs(x-info_prota.id_prota.x)<350) && (abs(y-info_prota.id_prota.y)<350))
                temp=collision(type normal_shot);
                while (temp)
                    energia-=temp.energia;
                    //say("enemigo ("+itoa(enem_tx)+","+itoa(enem_ty)+"): energa: "+itoa(energia));
                    //say("el disparo tena energia: "+itoa(temp.energia));
                    temp.energia=0;
                    if (mi_temblor!=0 && exists(mi_temblor))
                        mi_temblor.energia=1;
                    else
                        mi_temblor=enem_temblor(id,1);
                    end
                    temp=collision(type normal_shot);
                end
            end
            
            if ((abs(x-info_prota.id_prota.x)<50) && (abs(y-info_prota.id_prota.y)<50))
                temp=collision(type espadazo);
                if (temp && (temp!=temp_espada))
                    energia-=temp.energia;
                    if (mi_temblor!=0 && exists(mi_temblor))
                        mi_temblor.energia=1;
                    else
                        mi_temblor=enem_temblor(id,1);
                    end
                    temp_espada=temp;
                end
            end
                
            if (energia<=0) break; end
        end
        
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        frame;
    end
    
    modificar_tile(&durezas,enem_tx,enem_ty,0,0);
    modificar_tile(&durezas,enem_tx,enem_ty-1,0,0);
    if (flags==1)
        modificar_tile(&durezas,enem_tx+1,enem_ty,0,0);
        modificar_tile(&durezas,enem_tx+1,enem_ty-1,0,0);
    else
        modificar_tile(&durezas,enem_tx-1,enem_ty,0,0);
        modificar_tile(&durezas,enem_tx-1,enem_ty-1,0,0);
    end
    
    enem_explos(x2,y2-8,0,0);
    for (temp=0;temp<25;temp++)
        frame;
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
    end
    //frame(2500);
    enem_explos(x2-16,y2-24,0,0);
    for (temp=0;temp<25;temp++)
        frame;
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
    end
    //frame(2500);
    enem_explos(x2+16,y2-16,0,0);
    for (temp=0;temp<25;temp++)
        frame;
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
    end
    //frame(2500);
    enem_explos(x2-8,y2-8,0,0);
    enem_explos(x2,y2,1,1);
    enem_explos(x2,y2-16,1,-1);
    enem_explos(x2-8,y2,-1,1);
    enem_explos(x2-8,y2-16,-1,-1);
end

process corvo (int enem_tx, int enem_ty, file, energia)     //sigue un camino y persigue al prota
private
    int x3, y3;
    int resolution3;
    int enem_estado2;           //0: mover hacia arriba
                                //1: mover hacia abajo
                                //2: mover hacia izquierda
                                //3: mover hacia derecha
                                //4: acercarse a prota
                                //5: atacando a prota
                                //6: vigilando
    
    int vel_horiz, vel_vert;
    int cont_anim;
    int cont_estado;
    int temp;
    int temp_espada;
    
    //variables para la deteccin de durezas
    int enem_dur[2][2];
    int enem_tilex, enem_tiley;
    int enem_offsx, enem_offsy;
    int enem_mover_h, enem_mover_v;
    int enem_p_dir, enem_p_dir_ini;
    int enem_estado;
    int p_libre;
begin
    priority=-99;
    //file=enem_grafs[cte_volador1];
    z=1;
    
    x2=(enem_tx*id_tscroll.tmapa[0].ancho_tile) + (id_tscroll.tmapa[0].ancho_tile/2);
    y2=(enem_ty*id_tscroll.tmapa[0].alto_tile) + (id_tscroll.tmapa[0].alto_tile/2);
    resolution3=10;
    x3=x2*resolution3;
    y3=y2*resolution3;
    //energia=20;
    
    modificar_tile(&nivel,enem_tx,enem_ty,0,0);
    temp=obtener_tile(&durezas,enem_tx,enem_ty,0);
    
    //estableciendo comportamiento inicial
    switch (temp)
    case 251: enem_estado2=0; end       //movemos hacia arriba
    case 252: enem_estado2=1; end       //movemos hacia abajo
    case 253: enem_estado2=2; end       //movemos hacia izquierda
    case 254: enem_estado2=3; end       //movemos hacia derecha
    default:  enem_estado2=6; graph=7; end       //esperamos a que se acerque
    end //switch
    
    //empieza
    loop
        enem_tx= (x3/resolution3)/id_tscroll.tmapa[0].ancho_tile;
        enem_ty= (y3/resolution3)/id_tscroll.tmapa[0].alto_tile;
        
        switch (enem_estado2)
        case 0,1,2,3:
            temp=obtener_tile(&durezas,enem_tx,enem_ty,0);
            switch (temp)
            case 251: enem_estado2=0; end       //movemos hacia arriba
            case 252: enem_estado2=1; end       //movemos hacia abajo
            case 253: enem_estado2=2; end       //movemos hacia izquierda
            case 254: enem_estado2=3; end       //movemos hacia derecha
            end //switch
            //say("veo prota 2: "+itoa(veo_prota2(x3,y3,-100,-100,100,100)));
            if (veo_prota2(x2,y2,-50,-50,50,80))
                enem_estado2=4;
                cont_anim=0;
            end
        end
        case 4:
            if (veo_prota2(x2,y2+64,-10,0,10,100))
                enem_estado2=5;
                cont_anim=0;
                cont_estado=0;
            end
        end
        case 6:
            if (exists(info_prota.id_prota))
                if (veo_prota2(x2,y2,-64,-50,64,50))
                    enem_estado2=4;
                    cont_anim=0;
                end
            end
        end
        end //switch
        
        //establecemos velocidades
        switch (enem_estado2)
        case 0:
            if (vel_horiz<0) vel_horiz++; end
            if (vel_horiz>0) vel_horiz--; end
            if (vel_vert>-7) vel_vert--; end
        end
        case 1:
            if (vel_horiz<0) vel_horiz++; end
            if (vel_horiz>0) vel_horiz--; end
            if (vel_vert<7) vel_vert++; end
        end
        case 2:
            if (vel_vert<0) vel_vert++; end
            if (vel_vert>0) vel_vert--; end
            if (vel_horiz>-7) vel_horiz--; end
        end
        case 3:
            if (vel_vert<0) vel_vert++; end
            if (vel_vert>0) vel_vert--; end
            if (vel_horiz<7) vel_horiz++; end
        end
        case 4:
            if (exists(info_prota.id_prota))
                if (info_prota.id_prota.x2>x2)
                    if (vel_horiz<10) vel_horiz++; end
                else
                    if (vel_horiz>-10) vel_horiz--; end
                end
                if ((info_prota.id_prota.y2-64)<y2)
                    if (vel_vert>-10) vel_vert--; end
                else
                    if (vel_vert<10) vel_vert++; end
                end
            else
                if (vel_horiz<0) vel_horiz++; end
                if (vel_horiz>0) vel_horiz--; end
                if (vel_vert<0) vel_vert++; end
                if (vel_vert>0) vel_vert--; end
            end
        end
        case 5:
            if (cont_estado<50)
                cont_estado++;
                vel_horiz=0;
                vel_vert=0;
            else
                vel_vert=15;
                if (exists(info_prota.id_prota))
                    if (info_prota.id_prota.x2>x2)
                        if (vel_horiz<10) vel_horiz++; end
                    else
                        if (vel_horiz>-10) vel_horiz--; end
                    end
                else
                    vel_horiz=0;
                end
            end
        end
        end //switch
        
        //DETECCION DE DUREZAS
        //localizamos la posicin actual
        enem_tilex= (x3/resolution3)/id_tscroll.tmapa[0].ancho_tile;
        enem_tiley= (y3/resolution3)/id_tscroll.tmapa[0].alto_tile;
        enem_offsx= (x3/resolution3)%id_tscroll.tmapa[0].ancho_tile;
        enem_offsy= (y3/resolution3)%id_tscroll.tmapa[0].alto_tile;
        //leemos durezas de su alrededor
        enem_dur[0][0]=obtener_tile(&durezas,enem_tilex-1,enem_tiley-1,0);
        enem_dur[1][0]=obtener_tile(&durezas,enem_tilex  ,enem_tiley-1,0);
        enem_dur[2][0]=obtener_tile(&durezas,enem_tilex+1,enem_tiley-1,0);
        enem_dur[0][1]=obtener_tile(&durezas,enem_tilex-1,enem_tiley  ,0);
        enem_dur[1][1]=obtener_tile(&durezas,enem_tilex  ,enem_tiley  ,0);
        enem_dur[2][1]=obtener_tile(&durezas,enem_tilex+1,enem_tiley  ,0);
        enem_dur[0][2]=obtener_tile(&durezas,enem_tilex-1,enem_tiley+1,0);
        enem_dur[1][2]=obtener_tile(&durezas,enem_tilex  ,enem_tiley+1,0);
        enem_dur[2][2]=obtener_tile(&durezas,enem_tilex+1,enem_tiley+1,0);
        //comprobamos si cambiamos de tile y en que direccion
        //***************************************************************
        enem_mover_h=0;
        if (((x3+vel_horiz)/(id_tscroll.tmapa[0].ancho_tile*resolution3))!=enem_tilex)
           //comprobamos si pasamos a otro tile lateral y cuan lejos esta
           enem_mover_h=((x3+vel_horiz)/(id_tscroll.tmapa[0].ancho_tile*resolution3))-enem_tilex;
        end
        
        enem_mover_v=0;
        if (((y3+vel_vert)/(id_tscroll.tmapa[0].alto_tile*resolution3))!=enem_tiley)
           //comprobamos si pasamos a otro tile vertical y cuan lejos esta
           enem_mover_v=((y3+vel_vert)/(id_tscroll.tmapa[0].alto_tile*resolution3))-enem_tiley;
        end
         //miramos en que direccion cambiamos
        enem_p_dir=5;
        if (enem_mover_h>0) enem_p_dir++; end
        if (enem_mover_h<0) enem_p_dir--; end
        if (enem_mover_v>0) enem_p_dir-=3; end      //hacia abajo
        if (enem_mover_v<0) enem_p_dir+=3; end      //hacia arriba
        enem_p_dir_ini=enem_p_dir;
        
        include "durezas_check.inc";
        
        
        //zona de grficos
        switch (enem_estado2)
        case 0,1,2,3:
            cont_anim++;
            switch (cont_anim)
            case 10: graph=2; end
            case 20:
                graph=1;
                cont_anim=0;
            end
            end //switch
            if (vel_horiz<0) flags=0; end
            if (vel_horiz>0) flags=1; end
        end
        case 4:
            cont_anim++;
            switch (cont_anim)
            case 5: graph=2; end
            case 10:
                graph=1;
                cont_anim=0;
            end
            end //switch
            if (vel_horiz<0) flags=0; end
            if (vel_horiz>0) flags=1; end
        end
        case 5:
            if (cont_estado<50)
                graph=1;
                cont_estado++;
            else
                flags=0;
                cont_anim++;
                switch (cont_anim)
                case 3: graph=4; end
                case 6: graph=5; end
                case 9: graph=6; end
                case 12:
                    graph=3;
                    cont_anim=0;
                end
                end //switch
                
                if (vel_vert==0)
                    cont_anim=0;
                    cont_estado=0;
                    enem_estado2=4;
                end
            end
        end
        case 6:
            if (exists(info_prota.id_prota))
                if (info_prota.id_prota.x2<x2) flags=0; else flags=1; end
            end
            //graph=7;
        end
        end //switch
        
        //**************************************
        //  ZONA DE IMPACTOS
        //**************************************
        if (exists(info_prota.id_prota))
            //impacto con las balas
            if ((abs(x-info_prota.id_prota.x)<350) && (abs(y-info_prota.id_prota.y)<350))
                temp=collision(type normal_shot);
                while (temp)
                    energia-=temp.energia;
                    //say("enemigo ("+itoa(enem_tx)+","+itoa(enem_ty)+"): energa: "+itoa(energia));
                    //say("el disparo tena energia: "+itoa(temp.energia));
                    temp.energia=0;
                    if (mi_temblor!=0 && exists(mi_temblor))
                        mi_temblor.energia=3;
                    else
                        mi_temblor=enem_temblor(id,3);
                    end
                    temp=collision(type normal_shot);
                end
            end
            
            if ((abs(x-info_prota.id_prota.x)<50) && (abs(y-info_prota.id_prota.y)<50))
                temp=collision(type espadazo);
                if (temp && (temp!=temp_espada))
                    energia-=temp.energia;
                    if (mi_temblor!=0 && exists(mi_temblor))
                        mi_temblor.energia=3;
                    else
                        mi_temblor=enem_temblor(id,3);
                    end
                    temp_espada=temp;
                end
            end
            if (energia<=0) break; end
        
            //impacto con el prota
            if ((abs(x-info_prota.id_prota.x)<50) && (abs(y-info_prota.id_prota.y)<50))
                if (collision(info_prota.id_prota))
                    info_prota.dano_id=id;
                    if (enem_estado2==5)
                        info_prota.dano_energia=4;
                        info_prota.dano_exp=3;
                    else
                        info_prota.dano_energia=2;
                        info_prota.dano_exp=2;
                    end
                    if (info_prota.id_prota.x2>x2) info_prota.dano_vel_horiz=20;
                    else info_prota.dano_vel_horiz=-20;
                    end
                end
            end
        end
        
        x2=x3/resolution3;
        y2=y3/resolution3;
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        frame;
    end
    
    random_item (2,x2,y2-(id_tscroll.tmapa[0].ancho_tile/2));
    enem_explos(x2,y2,0,0);
end

process flozat (int enem_tx, int enem_ty,file,energia)
private
    int x3, y3;
    int resolution3;
    int enem_estado2;
    
    int vel_horiz, vel_vert;
    int cont_anim;
    int cont_disp;
    int temp;
    int temp_espada;
begin
    priority=-99;
    //file=enem_grafs[0][cte_volador1];
    z=1;
    
    x2=(enem_tx*id_tscroll.tmapa[0].ancho_tile) + (id_tscroll.tmapa[0].ancho_tile/2);
    y2=(enem_ty*id_tscroll.tmapa[0].alto_tile) + (id_tscroll.tmapa[0].alto_tile/2);
    resolution3=10;
    x3=x2*resolution3;
    y3=y2*resolution3;
    //energia=20;
    
    modificar_tile(&nivel,enem_tx,enem_ty,0,0);
    temp=obtener_tile(&durezas,enem_tx,enem_ty,0);
    
    //estableciendo comportamiento inicial
    switch (temp)
    case 251: enem_estado2=0; end       //movemos hacia arriba
    case 252: enem_estado2=1; end       //movemos hacia abajo
    case 253: enem_estado2=2; end       //movemos hacia izquierda
    case 254: enem_estado2=3; end       //movemos hacia derecha
    end //switch
    
    //empieza
    loop
        enem_tx= (x3/resolution3)/id_tscroll.tmapa[0].ancho_tile;
        enem_ty= (y3/resolution3)/id_tscroll.tmapa[0].alto_tile;
        
        temp=obtener_tile(&durezas,enem_tx,enem_ty,0);
        switch (temp)
        case 251: enem_estado2=0; end       //movemos hacia arriba
        case 252: enem_estado2=1; end       //movemos hacia abajo
        case 253: enem_estado2=2; end       //movemos hacia izquierda
        case 254: enem_estado2=3; end       //movemos hacia derecha
        end //switch
        
        //establecemos velocidades
        switch (enem_estado2)
        case 0:
            if (vel_horiz<0) vel_horiz++; end
            if (vel_horiz>0) vel_horiz--; end
            if (vel_vert>-7) vel_vert--; end
        end
        case 1:
            if (vel_horiz<0) vel_horiz++; end
            if (vel_horiz>0) vel_horiz--; end
            if (vel_vert<7) vel_vert++; end
        end
        case 2:
            if (vel_vert<0) vel_vert++; end
            if (vel_vert>0) vel_vert--; end
            if (vel_horiz>-7) vel_horiz--; end
        end
        case 3:
            if (vel_vert<0) vel_vert++; end
            if (vel_vert>0) vel_vert--; end
            if (vel_horiz<7) vel_horiz++; end
        end
        end //switch
        
        x3+=vel_horiz;
        y3+=vel_vert;
        x2=x3/resolution3;
        y2=y3/resolution3;
        //disparos
        if (exists(info_prota.id_prota))
            if (abs(info_prota.id_prota.x2-x2)<100)
                cont_disp--;
            end
        end
        if (cont_disp<=0)
            enem_normal_shot2(file,5,5,x2,y2,0,-90000,4,40);
            cont_disp=50;
        end
        
        //zona de grficos
        cont_anim++;
        switch (cont_anim)
        case 10: graph=2; end
        case 20: graph=3; end
        case 30: graph=4; end
        case 40:
            graph=1;
            cont_anim=0;
        end
        end //switch
        if (vel_horiz<0) flags=0; end
        if (vel_horiz>0) flags=1; end
        
        //*****************************
        // ZONA DE IMPACTOS
        //*****************************
        if (exists(info_prota.id_prota))
            //impacto con las balas
            if ((abs(x-info_prota.id_prota.x)<350) && (abs(y-info_prota.id_prota.y)<350))
                temp=collision(type normal_shot);
                while (temp)
                    energia-=temp.energia;
                    temp.energia=0;
                    if (mi_temblor!=0 && exists(mi_temblor))
                        mi_temblor.energia=3;
                    else
                        mi_temblor=enem_temblor(id,3);
                    end
                    temp=collision(type normal_shot);
                end
            end
            
            if ((abs(x-info_prota.id_prota.x)<50) && (abs(y-info_prota.id_prota.y)<50))
                temp=collision(type espadazo);
                if (temp && (temp!=temp_espada))
                    energia-=temp.energia;
                    if (mi_temblor!=0 && exists(mi_temblor))
                        mi_temblor.energia=3;
                    else
                        mi_temblor=enem_temblor(id,3);
                    end
                    temp_espada=temp;
                end
            end
            
            if (energia<=0) break; end
            
            //impacto con el prota
            if ((abs(x-info_prota.id_prota.x)<50) && (abs(y-info_prota.id_prota.y)<50))
                if (collision(info_prota.id_prota))
                    info_prota.dano_id=id;
                    info_prota.dano_energia=3;
                    info_prota.dano_exp=5;
                    if (info_prota.id_prota.x2>x2) info_prota.dano_vel_horiz=20;
                    else info_prota.dano_vel_horiz=-20;
                    end
                end
            end
        end
        
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        frame;
    end
    
    random_item (2,x2,y2-(id_tscroll.tmapa[0].ancho_tile/2));
    enem_explos(x2,y2,0,0);
end

/*process fly (int enem_tx, int enem_ty, int enem_despx)
private
    int vel_horiz;
    int vel_vert;
    int x3,y3;
    int resolution3;
    int ini_x2,fin_x2;
    int ini_y2;
    
    int enem_dur[2][2];
    int enem_tilex, enem_tiley;
    int enem_offsx, enem_offsy;
    int enem_mover_h, enem_mover_v;
    int enem_p_dir, enem_p_dir_ini;
    int enem_estado;
    int p_libre;
begin
    x2=enem_tx*id_tscroll.tmapa[0].ancho_tile;
    y2=enem_ty*id_tscroll.tmapa[0].alto_tile;
    resolution3=10;
    x3=x2*resolution3;
    y3=y2*resolution3;
    energia=15;
    
    file=enem_grafs[0];
    graph=1;
    
    ini_x2=x2;
    fin_x2=x2-(enem_despx*id_tscroll.tmapa[0].ancho_tile);
    ini_y2=y2;
    vel_horiz=-25;
    
    loop
        if ((vel_horiz < 25) && (x2<fin_x2))
            vel_horiz++;
        end
        if ((vel_horiz > -25) && (x2>ini_x2))
            vel_horiz--;
        end
        
        //localizamos la posicin actual
        enem_tilex= (x3/resolution3)/id_tscroll.tmapa[0].ancho_tile;
        enem_tiley= (y3/resolution3)/id_tscroll.tmapa[0].alto_tile;
        enem_offsx= (x3/resolution3)%id_tscroll.tmapa[0].ancho_tile;
        enem_offsy= (y3/resolution3)%id_tscroll.tmapa[0].alto_tile;
        //leemos durezas de su alrededor
        enem_dur[0][0]=obtener_tile(&durezas,enem_tilex-1,enem_tiley-1,0);
        enem_dur[1][0]=obtener_tile(&durezas,enem_tilex  ,enem_tiley-1,0);
        enem_dur[2][0]=obtener_tile(&durezas,enem_tilex+1,enem_tiley-1,0);
        enem_dur[0][1]=obtener_tile(&durezas,enem_tilex-1,enem_tiley  ,0);
        enem_dur[1][1]=obtener_tile(&durezas,enem_tilex  ,enem_tiley  ,0);
        enem_dur[2][1]=obtener_tile(&durezas,enem_tilex+1,enem_tiley  ,0);
        enem_dur[0][2]=obtener_tile(&durezas,enem_tilex-1,enem_tiley+1,0);
        enem_dur[1][2]=obtener_tile(&durezas,enem_tilex  ,enem_tiley+1,0);
        enem_dur[2][2]=obtener_tile(&durezas,enem_tilex+1,enem_tiley+1,0);
        //comprobamos si cambiamos de tile y en que direccion
        //***************************************************************
        enem_mover_h=0;
        if (((x3+vel_horiz)/(id_tscroll.tmapa[0].ancho_tile*resolution3))!=enem_tilex)
           //comprobamos si pasamos a otro tile lateral y cuan lejos esta
           enem_mover_h=((x3+vel_horiz)/(id_tscroll.tmapa[0].ancho_tile*resolution3))-enem_tilex;
        end
        
        enem_mover_v=0;
        if (((y3+vel_vert)/(id_tscroll.tmapa[0].alto_tile*resolution3))!=enem_tiley)
           //comprobamos si pasamos a otro tile vertical y cuan lejos esta
           enem_mover_v=((y3+vel_vert)/(id_tscroll.tmapa[0].alto_tile*resolution3))-enem_tiley;
        end
         //miramos en que direccion cambiamos
        enem_p_dir=5;
        if (enem_mover_h>0) enem_p_dir++; end
        if (enem_mover_h<0) enem_p_dir--; end
        if (enem_mover_v>0) enem_p_dir-=3; end      //hacia abajo
        if (enem_mover_v<0) enem_p_dir+=3; end      //hacia arriba
        enem_p_dir_ini=enem_p_dir;
        
        include "durezas_check.inc";
        
    end
end*/

// ENEMIGO VOLADOR QUE ATRAVIESA LAS PAREDES
process ghost_fly (int enem_tx, int enem_ty, energia)//, int enem_despx)
private
    int enem_despx;
    int vel_horiz;
    int vel_vert;
    int x3,y3;
    int resolution3;
    int ini_x2,fin_x2;
    int ini_y2;
    
    int cont_anim;
    int cont;
    int temp;
    int temp_espada;
begin
    modificar_tile(&nivel,enem_tx,enem_ty,0,0);
    enem_despx=obtener_tile(&durezas,enem_tx,enem_ty,0);
    if ((enem_despx >= 150) && (enem_despx <= 250))
        enem_despx-=150;
    else
        enem_despx=0;
    end
    //say("enemigo ("+itoa(enem_tx)+","+itoa(enem_ty)+"): energa: "+itoa(energia));

    x2=enem_tx*id_tscroll.tmapa[0].ancho_tile;
    y2=enem_ty*id_tscroll.tmapa[0].alto_tile;
    resolution3=10;
    x3=x2*resolution3;
    y3=y2*resolution3;
    //energia=4;
    
    file=enem_grafs[0][cte_ghost_fly];
    graph=1;
    z=1;
    
    ini_x2=x2;
    fin_x2=x2-(enem_despx*id_tscroll.tmapa[0].ancho_tile);
    ini_y2=y2;
    vel_horiz=-25;
    
    loop
        if ((vel_horiz < 25) && (x2<fin_x2))
            vel_horiz++;
            flags=1;
        end
        if ((vel_horiz > -25) && (x2>ini_x2))
            vel_horiz--;
            flags=0;
        end
        
        x3+=vel_horiz;
        y3=(ini_y2*resolution3) + (50*sin(cont*1000));
        cont+=3;
        
        x2=x3/resolution3;
        y2=y3/resolution3;
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        
        cont_anim++;
        switch (cont_anim)
        case 3: graph=2; end
        case 6: graph=1; cont_anim=0; end
        end //switch
        
        //choque con los disparos
        if (exists(info_prota.id_prota))
            if ((abs(x-info_prota.id_prota.x)<350) && (abs(y-info_prota.id_prota.y)<350))
                temp=collision(type normal_shot);
                while (temp)
                    energia-=temp.energia;
                    //say("enemigo ("+itoa(enem_tx)+","+itoa(enem_ty)+"): energa: "+itoa(energia));
                    //say("el disparo tena energia: "+itoa(temp.energia));
                    temp.energia=0;
                    if (mi_temblor!=0 && exists(mi_temblor))
                        mi_temblor.energia=3;
                    else
                        mi_temblor=enem_temblor(id,3);
                    end
                    temp=collision(type normal_shot);
                end
            end
            
            if ((abs(x-info_prota.id_prota.x)<50) && (abs(y-info_prota.id_prota.y)<50))
                temp=collision(type espadazo);
                if (temp && (temp!=temp_espada))
                    energia-=temp.energia;
                    if (mi_temblor!=0 && exists(mi_temblor))
                        mi_temblor.energia=3;
                    else
                        mi_temblor=enem_temblor(id,3);
                    end
                    temp_espada=temp;
                end
            end
            
            //impacto con el prota
            if ((abs(x-info_prota.id_prota.x)<50) && (abs(y-info_prota.id_prota.y)<50))
                if (collision(info_prota.id_prota))
                    info_prota.dano_id=id;
                    info_prota.dano_energia=5;
                    info_prota.dano_exp=5;
                    if (info_prota.id_prota.x2>x2) info_prota.dano_vel_horiz=20;
                    else info_prota.dano_vel_horiz=-20;
                    end
                end
            end
        end
        
        if (energia<=0) break; end
        frame;
    end
    
    //explosion
    //suelta de items
    //shot_exp(x2,y2,5,10);
    random_item (2,x2,y2-(id_tscroll.tmapa[0].ancho_tile/2));
    enem_explos(x2,y2,0,0);
end

// ENEMIGO VOLADOR QUE ATRAVIESA LAS PAREDES Y ES INVENCIBLE
process ghost_fly_invencible (int enem_tx, int enem_ty)//, int enem_despx)
private
    int enem_despx;
    int vel_horiz;
    int vel_vert;
    int x3,y3;
    int resolution3;
    int ini_x2,fin_x2;
    int ini_y2;
    
    int cont_anim;
    int cont;
    int temp;
    int temp_tile;
begin
    temp_tile=obtener_tile(&nivel,enem_tx,enem_ty,0);
    modificar_tile(&nivel,enem_tx,enem_ty,0,0);
    enem_despx=obtener_tile(&durezas,enem_tx,enem_ty,0);
    if ((enem_despx >= 150) && (enem_despx <= 250))
        enem_despx-=150;
    else
        enem_despx=0;
    end
    //say("enemigo ("+itoa(enem_tx)+","+itoa(enem_ty)+"): energa: "+itoa(energia));

    x2=enem_tx*id_tscroll.tmapa[0].ancho_tile;
    y2=enem_ty*id_tscroll.tmapa[0].alto_tile;
    resolution3=10;
    x3=x2*resolution3;
    y3=y2*resolution3;
    energia=4;
    
    file=enem_grafs[0][cte_ghost_fly];
    graph=1;
    flags=4;
    z=-1;
    
    ini_x2=x2;
    fin_x2=x2-(enem_despx*id_tscroll.tmapa[0].ancho_tile);
    ini_y2=y2;
    vel_horiz=-25;
    
    loop
        if ((vel_horiz < 25) && (x2<fin_x2))
            vel_horiz++;
            flags=1+4;
        end
        if ((vel_horiz > -25) && (x2>ini_x2))
            vel_horiz--;
            flags=4;
        end
        
        x3+=vel_horiz;
        y3=(ini_y2*resolution3) + (50*sin(cont*1000));
        cont+=3;
        
        x2=x3/resolution3;
        y2=y3/resolution3;
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        
        cont_anim++;
        switch (cont_anim)
        case 3: graph=2; end
        case 6: graph=1; cont_anim=0; end
        end //switch
        
        //choque con los disparos
        if (exists(info_prota.id_prota))
            if ((abs(x-info_prota.id_prota.x)<350) && (abs(y-info_prota.id_prota.y)<350))
                temp=collision(type normal_shot);
                if (temp)
                    //say("enemigo ("+itoa(enem_tx)+","+itoa(enem_ty)+"): energa: "+itoa(energia));
                    //say("el disparo tena energia: "+itoa(temp.energia));
                    temp.energia=0;
                end
            end
            
            //impacto con el prota
            if ((abs(x-info_prota.id_prota.x)<50) && (abs(y-info_prota.id_prota.y)<50))
                if (collision(info_prota.id_prota))
                    info_prota.dano_id=id;
                    info_prota.dano_energia=5;
                    info_prota.dano_exp=5;
                    if (info_prota.id_prota.x2>x2) info_prota.dano_vel_horiz=20;
                    else info_prota.dano_vel_horiz=-20;
                    end
                end
            end
        end
        
        if ( (abs(id_tscroll.camera_x-x2)>480) || (abs(id_tscroll.camera_y-y2)>360) ) break; end
        frame;
    end
    
    modificar_tile(&nivel,enem_tx,enem_ty,0,temp_tile);
end

process glotz (int enem_tx, int enem_ty, file, energia)
private
    int enem_estado;        //0: mirando a la izquierda
                            //1: mirando a la derecha
                            //2: girando a la derecha
                            //3 :girando a la izquierda
                            //4: disparando
    int cont_estado;
    int cont_anim;
    int temp;
    int temp_espada;
begin
    priority=-99;
    z=1;
    
    x2=(enem_tx*id_tscroll.tmapa[0].ancho_tile) + (id_tscroll.tmapa[0].ancho_tile/2);
    y2=(enem_ty*id_tscroll.tmapa[0].alto_tile) + (id_tscroll.tmapa[0].alto_tile-1);
    
    modificar_tile(&nivel,enem_tx,enem_ty,0,0);
    
    graph=1;
    cont_estado=10;
    loop
        cont_anim++;
        if (cont_anim>=5)
            switch (enem_estado)
            case 0:
                cont_estado--;
                if (cont_estado<=0) enem_estado=2; end
                if (veo_prota2(x2,y2,-120,-48,16,32)) enem_estado=4; cont_estado=0; end
            end
            case 1:
                cont_estado--;
                if (cont_estado<=0) enem_estado=3; end
                if (veo_prota2(x2,y2,-16,-48,120,32)) enem_estado=4; cont_estado=0; end
            end
            case 2:
                if (graph<7)
                    graph++;
                else
                    enem_estado=1;
                    cont_estado=rand(3,30);
                end
            end
            case 3:
                if (graph>1)
                    graph--;
                else
                    enem_estado=0;
                    cont_estado=rand(3,30);
                end
            end
            case 4:
                switch (graph)
                case 1,2,3: graph++; end
                case 7,6,5: graph--; end
                case 4:
                    if (exists(info_prota.id_prota))
                        if (info_prota.id_prota.x2<x2)
                            enem_normal_shot(file,10,10,x2,y2-5,180000,3);
                        else
                            enem_normal_shot(file,10,10,x2,y2-5,0,3);
                        end
                        graph=8;
                        cont_estado=0;
                    end
                end
                case 8:
                    cont_estado++;
                    if (cont_estado==12) graph=9; end
                end
                case 9:
                    graph=4;
                    if (exists(info_prota.id_prota))
                        if (info_prota.id_prota.x2<x2)
                            enem_estado=3;
                        else
                            enem_estado=2;
                        end
                    end
                end
                end //switch
            end
            end //switch
            cont_anim=0;
        end
        
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        
        //choque con los disparos
        if (exists(info_prota.id_prota))
            if ((abs(x-info_prota.id_prota.x)<350) && (abs(y-info_prota.id_prota.y)<350))
                temp=collision(type normal_shot);
                while (temp)
                    energia-=temp.energia;
                    temp.energia=0;
                    if (mi_temblor!=0 && exists(mi_temblor))
                        mi_temblor.energia=3;
                    else
                        mi_temblor=enem_temblor(id,3);
                    end
                    temp=collision(type normal_shot);
                end
            end
            
            if ((abs(x-info_prota.id_prota.x)<50) && (abs(y-info_prota.id_prota.y)<50))
                temp=collision(type espadazo);
                if (temp && (temp!=temp_espada))
                    energia-=temp.energia;
                    if (mi_temblor!=0 && exists(mi_temblor))
                        mi_temblor.energia=3;
                    else
                        mi_temblor=enem_temblor(id,3);
                    end
                    temp_espada=temp;
                end
            end
            
            //impacto con el prota
            if ((abs(x-info_prota.id_prota.x)<50) && (abs(y-info_prota.id_prota.y)<50))
                if (collision(info_prota.id_prota))
                    info_prota.dano_id=id;
                    info_prota.dano_energia=5;
                    info_prota.dano_exp=5;
                    if (info_prota.id_prota.x2>x2) info_prota.dano_vel_horiz=20;
                    else info_prota.dano_vel_horiz=-20;
                    end
                end
            end
        end
        
        if (energia<=0) break; end
        frame;
    end
    
    random_item (2,x2,y2-(id_tscroll.tmapa[0].ancho_tile/2));
    enem_explos(x2,y2-8,0,0);
end

process guerrillero (int enem_tx, int enem_ty, file, flags)
private
    byte enem_estado2;      //0: descansando (fumando)
                            //1: sorprendido (tras fumando)
                            //2: de guardia (no se mueve del sitio, pero te ve antes y ataca antes)
                            //3: andando derecha (patrullando)
                            //4: andando izquierda (patrullando)
                            //5: pausa andando (patrullando)
                            //6: persiguiendo (te ve y se lanza al ataque)
                            //7: en espera (como de guardia, pero si te ve, te persigue)
    int x3,y3;
    int resolution3;
    
    int vel_horiz,vel_vert;
    int enem_gravedad;
    int enem_max_gravedad;
    int enem_salto;
    
    int cont_estado;        //dice el tiempo que queda para cambiar de estado
    int cont_anim;          //cuenta el retardo entre frames
    int pos_anim;           //indica qu grfico de animacin de andar muestra
    byte enem_anim[3]=1,2,1,3;  //animacin andar
    
    int temp;
    int temp_x1,temp_y1;
    int temp_angle;
    int vel_horiz_ant;
    int temp_espada;
    //variables para la deteccin de durezas
    int enem_dur[2][2];
    int enem_tilex, enem_tiley;
    int enem_offsx, enem_offsy;
    int enem_mover_h, enem_mover_v;
    int enem_p_dir, enem_p_dir_ini;
    int enem_estado;
    int p_libre;
begin
    priority=-99;
    //file=enem_grafs[0][cte_guerrillero];
    z=1;
    enem_gravedad=2;
    enem_max_gravedad=30;
    enem_salto=40;
    
    x2=(enem_tx*id_tscroll.tmapa[0].ancho_tile) + (id_tscroll.tmapa[0].ancho_tile/2);
    y2=(enem_ty*id_tscroll.tmapa[0].alto_tile) + (id_tscroll.tmapa[0].alto_tile-1);
    resolution3=10;
    x3=x2*resolution3;
    y3=y2*resolution3;
    energia=5;
    
    modificar_tile(&nivel,enem_tx,enem_ty,0,0);
    temp=obtener_tile(&durezas,enem_tx,enem_ty,0);
    
    //estableciendo comportamiento inicial
    switch (temp)
    case 255: enem_estado2=0; end
    case 252: enem_estado2=2; end
    case 253: enem_estado2=4; end
    case 254: enem_estado2=3; end
    default: enem_estado2=7; end
    end //switch
    
    loop
        //cambios de estado
        switch (enem_estado2)
        case 0:         //descansando
            if (veo_prota(x2,y2,(flags & 1),50,20))
                enem_estado2=1;
                cont_estado=50;
                if ((flags & 1)==1)
                    visual_fx(file,110,x2+5,y2-16,50,flags);
                else
                    visual_fx(file,110,x2-5,y2-16,50,flags);
                end
            else
                cont_estado++;
                if (cont_estado==70)
                    get_real_point(1,&temp_x1,&temp_y1);  //punto de salida
                    //buscamos desplazamiento en pixels
                    temp_x1-=x;
                    temp_y1-=y;
                    enem_smoke(file,100,105,x2+temp_x1,y2+temp_y1,flags);
                end
                if (cont_estado==350) cont_estado=0; end
            end
        end
        case 1:         //sorprendido
            cont_estado--;
            if (cont_estado==0)
                enem_estado2=6;
                //voz_de_alerta();
            end
        end
        case 2:         //de guardia
            if (veo_prota(x2,y2,(flags & 1),100,70))
                if ((abs(info_prota.id_prota.y2-y2) > abs(info_prota.id_prota.x2-x2)) &&
                    (info_prota.id_prota.y2 < y2))
                    temp_angle=90000;
                else
                    if (flags & 1) temp_angle=0; else temp_angle=180000; end
                end
                
                cont_estado++;
                if (cont_estado==80)
                    cont_estado=0;
                    //DISPARAMOS
                    get_real_point(1,&temp_x1,&temp_y1);  //punto de salida
                    //buscamos desplazamiento en pixels
                    temp_x1-=x;
                    temp_y1-=y;
                    //creamos el disparo en coordenadas del scroll
                    enem_normal_shot(file,150,150,x2+temp_x1,y2+temp_y1,temp_angle,1);
                    play_wav(sfx_id[0][cte_sfx_shot],0);
                end
            else
                cont_estado=79;
            end
        end
        case 3:         //andando derecha
            cont_estado++;
            vel_horiz++;
            if (vel_horiz>10) vel_horiz=10; end
            if (veo_prota(x2,y2,1,110,50)) enem_estado2=6; end
        end
        case 4:         //andando izquierda
            cont_estado++;
            vel_horiz--;
            if (vel_horiz<-10) vel_horiz=-10; end
            if (veo_prota(x2,y2,0,110,50)) enem_estado2=6; end
        end
        case 5:         //pausa andando
            if (vel_horiz>0) vel_horiz--; end
            if (vel_horiz<0) vel_horiz++; end
            if (cont_estado==0)
                if (flags==1) enem_estado2=3; else enem_estado2=4; end
            else
                cont_estado--;
            end
        end
        case 6:
            if (exists(info_prota.id_prota))
                //comprobamos distancia con el prota
                temp=info_prota.id_prota.x2-x2;
                //muy cerca, disparamos como cosacos
                if (abs(temp) < 32)
                    //detenemos el movimiento
                    if (vel_horiz>0) vel_horiz--; end
                    if (vel_horiz<0) vel_horiz++; end
                    //comprobamos retardo del disparo
                    if (cont_estado > 30) cont_estado=0; end
                    if (cont_estado <= 0)
                        cont_estado=30;
                    else
                        cont_estado--;
                    end
                else
                    //un poco ms lejos nos acercamos
                    if (temp > 32) 
                        vel_horiz=10;
                    elsif (temp < -32) 
                        vel_horiz=-10;
                    end
                    //si llegamos a un borde, damos un salto
                    if ((info_prota.id_prota.y2-y2) <= 0)
                        switch (enem_dur[1][2])
                        case 0,50,32,33,34,82,83,84,100,104:
                            if ((enem_estado==0) || (enem_estado==1))
                                vel_vert=-enem_salto;
                                enem_estado=3;
                            end
                        end
                        end //switch
                    end
                    //retardo del disparo
                    if (cont_estado <= 0)
                        cont_estado=40;
                    else
                        cont_estado--;
                    end
                end
                
                if (cont_estado <= 0)
                    if ((abs(info_prota.id_prota.y2-y2) > abs(info_prota.id_prota.x2-x2)) &&
                        (info_prota.id_prota.y2 < y2))
                        temp_angle=90000;
                        vel_horiz=0;
                    else
                        if (flags & 1) temp_angle=0; else temp_angle=180000; end
                    end
                
                    //DISPARAMOS
                    get_real_point(1,&temp_x1,&temp_y1);  //punto de salida
                    //buscamos desplazamiento en pixels
                    temp_x1-=x;
                    temp_y1-=y;
                    //creamos el disparo en coordenadas del scroll
                    enem_normal_shot(file,150,150,x2+temp_x1,y2+temp_y1,temp_angle,1);
                    play_wav(sfx_id[0][cte_sfx_shot],0);
                end
            end
        end
        case 7:
            if (veo_prota(x2,y2,(flags & 1),120,60))
                enem_estado2=6;
            end
        end
        end //switch
        vel_horiz_ant=vel_horiz;
        
        //gravedad
        vel_vert+=enem_gravedad;
        if (vel_vert > enem_max_gravedad) vel_vert=enem_max_gravedad; end
        
        //DETECCION DE DUREZAS
        //localizamos la posicin actual
        enem_tilex= (x3/resolution3)/id_tscroll.tmapa[0].ancho_tile;
        enem_tiley= (y3/resolution3)/id_tscroll.tmapa[0].alto_tile;
        enem_offsx= (x3/resolution3)%id_tscroll.tmapa[0].ancho_tile;
        enem_offsy= (y3/resolution3)%id_tscroll.tmapa[0].alto_tile;
        //leemos durezas de su alrededor
        enem_dur[0][0]=obtener_tile(&durezas,enem_tilex-1,enem_tiley-1,0);
        enem_dur[1][0]=obtener_tile(&durezas,enem_tilex  ,enem_tiley-1,0);
        enem_dur[2][0]=obtener_tile(&durezas,enem_tilex+1,enem_tiley-1,0);
        enem_dur[0][1]=obtener_tile(&durezas,enem_tilex-1,enem_tiley  ,0);
        enem_dur[1][1]=obtener_tile(&durezas,enem_tilex  ,enem_tiley  ,0);
        enem_dur[2][1]=obtener_tile(&durezas,enem_tilex+1,enem_tiley  ,0);
        enem_dur[0][2]=obtener_tile(&durezas,enem_tilex-1,enem_tiley+1,0);
        enem_dur[1][2]=obtener_tile(&durezas,enem_tilex  ,enem_tiley+1,0);
        enem_dur[2][2]=obtener_tile(&durezas,enem_tilex+1,enem_tiley+1,0);
        //comprobamos si cambiamos de tile y en que direccion
        //***************************************************************
        enem_mover_h=0;
        if (((x3+vel_horiz)/(id_tscroll.tmapa[0].ancho_tile*resolution3))!=enem_tilex)
           //comprobamos si pasamos a otro tile lateral y cuan lejos esta
           enem_mover_h=((x3+vel_horiz)/(id_tscroll.tmapa[0].ancho_tile*resolution3))-enem_tilex;
        end
        
        enem_mover_v=0;
        if (((y3+vel_vert)/(id_tscroll.tmapa[0].alto_tile*resolution3))!=enem_tiley)
           //comprobamos si pasamos a otro tile vertical y cuan lejos esta
           enem_mover_v=((y3+vel_vert)/(id_tscroll.tmapa[0].alto_tile*resolution3))-enem_tiley;
        end
         //miramos en que direccion cambiamos
        enem_p_dir=5;
        if (enem_mover_h>0) enem_p_dir++; end
        if (enem_mover_h<0) enem_p_dir--; end
        if (enem_mover_v>0) enem_p_dir-=3; end      //hacia abajo
        if (enem_mover_v<0) enem_p_dir+=3; end      //hacia arriba
        enem_p_dir_ini=enem_p_dir;
        
        include "durezas_check.inc";
        
        //post anlisis
        if ( (vel_horiz!=0) && (enem_estado==0) )
            enem_estado=1;
        end
        if ( (vel_horiz==0) && (enem_estado==1) )
            enem_estado=0;
        end
        
        switch (enem_estado2)
        case 3:
            switch (enem_dur[1][1])
            case 253:
                enem_estado2=4;
                cont_estado=0;
            end
            case 252:
                if (cont_estado>=16)
                    enem_estado2=5;
                    cont_estado=100;
                end
            end
            case 251:       //flecha hacia arriba (salta)
                if ((enem_estado==1) || (enem_estado==0))
                    vel_vert=-enem_salto;
                    enem_estado=3;
                end
            end
            end //switch
        end
        case 4:
            switch (enem_dur[1][1])
            case 254:
                enem_estado2=3;
                cont_estado=0;
            end
            case 252:
                if (cont_estado>=16)
                    enem_estado2=5;
                    cont_estado=100;
                end
            end
            case 251:       //flecha hacia arriba (salta)
                if ((enem_estado==1) || (enem_estado==0))
                    vel_vert=-enem_salto;
                    enem_estado=3;
                end
            end
            end //switch
        end
        case 6:
            if (temp > 0) flags=1; else flags=0; end
            
            //si se para porque choca con una pared, comprueba si puede seguir con un salto
            if (vel_horiz==0)
                if (vel_horiz_ant>0)
                    switch (enem_dur[2][0])
                    case 1,2,5,14,51,52,55,64:
                        p_libre=false;
                    end
                    default: p_libre=true; end
                    end //switch
                    
                    switch (obtener_tile(&durezas,enem_tilex+1,enem_tiley-2,0))
                    case 1,2,5,14,51,52,55,64:
                        p_libre=(p_libre || false);
                    end
                    default: p_libre=true; end
                    end //switch
                end
                if (vel_horiz_ant<0)
                    switch (enem_dur[0][0])
                    case 1,3,4,16,51,53,54,66:
                        p_libre=false;
                    end
                    default: p_libre=true; end
                    end //switch
                    
                    switch (obtener_tile(&durezas,enem_tilex-1,enem_tiley-2,0))
                    case 1,3,4,16,51,53,54,66:
                        p_libre=(p_libre || false);
                    end
                    default: p_libre=true; end
                    end //switch
                end
                if (vel_horiz_ant==0) p_libre=false; end
            
                // si se puede, pues salta
                if (p_libre && ((enem_estado==1) || (enem_estado==0)))
                    vel_vert=-enem_salto;
                    enem_estado=3;
                end
            end
        end
        end //switch
        
        
        //zona de grficos
        switch (enem_estado2)
        case 0:         //descansando
            if (cont_estado<50) graph=6; else graph=7; end
        end
        case 1: graph=8; end    //sorprendido
        case 2,7:               //de guardia y en espera
            if (temp_angle==90000) graph=4; else graph=1; end
        end
        case 3,4,5,6:   //patrullando y persiguiendo
            switch (enem_estado)
            case 0:
                if ((enem_estado2==6) && (temp_angle==90000))
                    graph=4;
                    cont_anim=9;
                else
                    graph=1;
                end
            end
            case 1:
                if (vel_horiz>0) flags=1; end
                if (vel_horiz<0) flags=0; end
                cont_anim++;
                if (cont_anim==10)
                    cont_anim=0;
                    if (pos_anim==3) pos_anim=0; else pos_anim++; end
                    graph=enem_anim[pos_anim];
                end
            end
            case 2,3: graph=5; end
            end //switch
        end
        
        
        end //switch
        
        //************************
        //  ZONA DE COLISIONES
        //************************
        //impacto con el prota
        if (exists(info_prota.id_prota))
            if ((abs(x-info_prota.id_prota.x)<50) && (abs(y-info_prota.id_prota.y)<50))
                if (collision(info_prota.id_prota))
                    info_prota.dano_id=id;
                    info_prota.dano_energia=2;
                    info_prota.dano_exp=4;
                    if (info_prota.id_prota.x2>x2) info_prota.dano_vel_horiz=20;
                    else info_prota.dano_vel_horiz=-20;
                    end
                end
            end
        
            //impacto con las balas
            if ((abs(x-info_prota.id_prota.x)<350) && (abs(y-info_prota.id_prota.y)<350))
                temp=collision(type normal_shot);
                while (temp)
                    energia-=temp.energia;
                    //say("enemigo ("+itoa(enem_tx)+","+itoa(enem_ty)+"): energa: "+itoa(energia));
                    //say("el disparo tena energia: "+itoa(temp.energia));
                    temp.energia=0;
                    if (mi_temblor!=0 && exists(mi_temblor))
                        mi_temblor.energia=3;
                    else
                        mi_temblor=enem_temblor(id,3);
                    end
                    temp=collision(type normal_shot);
                end
            end
            
            if ((abs(x-info_prota.id_prota.x)<50) && (abs(y-info_prota.id_prota.y)<50))
                temp=collision(type espadazo);
                if (temp && (temp!=temp_espada))
                    energia-=temp.energia;
                    if (mi_temblor!=0 && exists(mi_temblor))
                        mi_temblor.energia=3;
                    else
                        mi_temblor=enem_temblor(id,3);
                    end
                    temp_espada=temp;
                end
            end
        end
        
        if (energia<=0) break; end
        
        x2=x3/resolution3;
        y2=y3/resolution3;
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        frame;
    end
    
    random_item (2,x2,y2-(id_tscroll.tmapa[0].ancho_tile/2));
    enem_explos(x2,y2-8,0,0);
end

process invencible_enem (int enem_tx, int enem_ty, file)     //sigue un camino
private
    int x3, y3;
    int resolution3;
    int enem_estado2;
    
    int vel_horiz, vel_vert;
    int cont_anim;
    int temp;
begin
    priority=-99;
    //file=enem_grafs[0][cte_volador1];
    z=1;
    
    x2=(enem_tx*id_tscroll.tmapa[0].ancho_tile) + (id_tscroll.tmapa[0].ancho_tile/2);
    y2=(enem_ty*id_tscroll.tmapa[0].alto_tile) + (id_tscroll.tmapa[0].alto_tile/2);
    resolution3=10;
    x3=x2*resolution3;
    y3=y2*resolution3;
    //energia=20;
    
    modificar_tile(&nivel,enem_tx,enem_ty,0,0);
    temp=obtener_tile(&durezas,enem_tx,enem_ty,0);
    
    //estableciendo comportamiento inicial
    switch (temp)
    case 251: enem_estado2=0; end       //movemos hacia arriba
    case 252: enem_estado2=1; end       //movemos hacia abajo
    case 253: enem_estado2=2; end       //movemos hacia izquierda
    case 254: enem_estado2=3; end       //movemos hacia derecha
    end //switch
    
    //empieza
    loop
        enem_tx= (x3/resolution3)/id_tscroll.tmapa[0].ancho_tile;
        enem_ty= (y3/resolution3)/id_tscroll.tmapa[0].alto_tile;
        
        temp=obtener_tile(&durezas,enem_tx,enem_ty,0);
        switch (temp)
        case 251: enem_estado2=0; end       //movemos hacia arriba
        case 252: enem_estado2=1; end       //movemos hacia abajo
        case 253: enem_estado2=2; end       //movemos hacia izquierda
        case 254: enem_estado2=3; end       //movemos hacia derecha
        end //switch
        
        //establecemos velocidades
        switch (enem_estado2)
        case 0:
            if (vel_horiz<0) vel_horiz++; end
            if (vel_horiz>0) vel_horiz--; end
            if (vel_vert>-7) vel_vert--; end
        end
        case 1:
            if (vel_horiz<0) vel_horiz++; end
            if (vel_horiz>0) vel_horiz--; end
            if (vel_vert<7) vel_vert++; end
        end
        case 2:
            if (vel_vert<0) vel_vert++; end
            if (vel_vert>0) vel_vert--; end
            if (vel_horiz>-7) vel_horiz--; end
        end
        case 3:
            if (vel_vert<0) vel_vert++; end
            if (vel_vert>0) vel_vert--; end
            if (vel_horiz<7) vel_horiz++; end
        end
        end //switch
        
        x3+=vel_horiz;
        y3+=vel_vert;
        
        //zona de grficos
        cont_anim++;
        switch (cont_anim)
        case 10: graph=2; end
        case 20:
            graph=1;
            cont_anim=0;
        end
        end //switch
        if (vel_horiz<0) flags=0; end
        if (vel_horiz>0) flags=1; end
        
        //*****************************
        // ZONA DE IMPACTOS
        //*****************************
        if (exists(info_prota.id_prota))
            //impacto con las balas
            if ((abs(x-info_prota.id_prota.x)<350) && (abs(y-info_prota.id_prota.y)<350))
                temp=collision(type normal_shot);
                if (temp)
                    temp.energia=0;
                end
            end
            
            
            //impacto con el prota
            if ((abs(x-info_prota.id_prota.x)<50) && (abs(y-info_prota.id_prota.y)<50))
                if (collision(info_prota.id_prota))
                    info_prota.dano_id=id;
                    info_prota.dano_energia=3;
                    info_prota.dano_exp=4;
                    if (info_prota.id_prota.x2>x2) info_prota.dano_vel_horiz=30;
                    else info_prota.dano_vel_horiz=-30;
                    end
                end
            end
        end
        
        x2=x3/resolution3;
        y2=y3/resolution3;
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        frame;
    end
    
end

process mina (int enem_tx, int enem_ty)
private
    int cont_anim;
    int temp;
    int temp_espada;
begin
    priority=-99;
    file=enem_grafs[0][cte_mina];
    energia=6;
    x2=(enem_tx*id_tscroll.tmapa[0].ancho_tile) + (id_tscroll.tmapa[0].ancho_tile/2);
    y2=(enem_ty*id_tscroll.tmapa[0].alto_tile) + (id_tscroll.tmapa[0].alto_tile-1);
    modificar_tile(&nivel,enem_tx,enem_ty,0,0);
    graph=2;
    loop
        cont_anim++;
        switch (cont_anim)
        case 25: graph=1; end
        case 50: graph=2; cont_anim=0; end
        end //switch
        
        //*****************************
        // ZONA DE IMPACTOS
        //*****************************
        if (exists(info_prota.id_prota))
            //impacto con las balas
            if ((abs(x-info_prota.id_prota.x)<350) && (abs(y-info_prota.id_prota.y)<350))
                temp=collision(type normal_shot);
                while (temp)
                    energia-=temp.energia;
                    temp.energia=0;
                    if (mi_temblor!=0 && exists(mi_temblor))
                        mi_temblor.energia=3;
                    else
                        mi_temblor=enem_temblor(id,3);
                    end
                    temp=collision(type normal_shot);
                end
            end
            
            if ((abs(x-info_prota.id_prota.x)<50) && (abs(y-info_prota.id_prota.y)<50))
                temp=collision(type espadazo);
                if (temp && (temp!=temp_espada))
                    energia-=temp.energia;
                    if (mi_temblor!=0 && exists(mi_temblor))
                        mi_temblor.energia=3;
                    else
                        mi_temblor=enem_temblor(id,3);
                    end
                    temp_espada=temp;
                end
            end
            if (energia<=0) break; end
            
            
            //impacto con el prota
            if ((abs(info_prota.id_prota.x2-x2)<30) && (abs(info_prota.id_prota.y2-y2)<16))
                break;
            end
        end
        
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        frame;
    end
    
    graph=3;
    for (temp=0;temp<50;temp++)
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        frame;
    end
    size=10;
    graph=4;
    z=-1;
    while (size<100)
        size+=2;
        //impacto con el prota
        if (exists(info_prota.id_prota))
            if ((abs(x-info_prota.id_prota.x)<50) && (abs(y-info_prota.id_prota.y)<50))
                if (collision(info_prota.id_prota))
                    info_prota.dano_id=id;
                    info_prota.dano_energia=7;
                    info_prota.dano_exp=5;
                    if (info_prota.id_prota.x2>x2) info_prota.dano_vel_horiz=30;
                    else info_prota.dano_vel_horiz=-30;
                    end
                end
            end
        end
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        frame;
    end
    size=100;
    while (alpha>0)
        alpha-=5;
        //impacto con el prota
        if (exists(info_prota.id_prota))
            if ((abs(x-info_prota.id_prota.x)<50) && (abs(y-info_prota.id_prota.y)<50))
                if (collision(info_prota.id_prota))
                    info_prota.dano_id=id;
                    info_prota.dano_energia=5;
                    info_prota.dano_exp=5;
                    if (info_prota.id_prota.x2>x2) info_prota.dano_vel_horiz=30;
                    else info_prota.dano_vel_horiz=-30;
                    end
                end
            end
        end
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        frame;
    end
    
    if (energia<=0) random_item (3,x2,y2-(id_tscroll.tmapa[0].ancho_tile/2)); end
end

process murcielago (int enem_tx, int enem_ty, energia)     //sigue un camino y persigue al prota
private
    int x3, y3;
    int resolution3;
    int enem_estado2;           //0: dormido
                                //1: despierto
                                //2: acercarse a prota
    
    int vel_horiz, vel_vert;
    int cont_anim;
    int cont_estado;
    int temp;
    int temp_espada;
    
    //variables para la deteccin de durezas
    int enem_dur[2][2];
    int enem_tilex, enem_tiley;
    int enem_offsx, enem_offsy;
    int enem_mover_h, enem_mover_v;
    int enem_p_dir, enem_p_dir_ini;
    int enem_estado;
    int p_libre;
begin
    priority=-99;
    file=enem_grafs[0][cte_murcielago];
    z=1;
    
    x2=(enem_tx*id_tscroll.tmapa[0].ancho_tile) + (id_tscroll.tmapa[0].ancho_tile/2);
    y2=(enem_ty*id_tscroll.tmapa[0].alto_tile) + (id_tscroll.tmapa[0].alto_tile/2);
    resolution3=10;
    x3=x2*resolution3;
    y3=y2*resolution3;
    //energia=20;
    //say("primer "+itoa(y2)+" "+itoa(y3));
    
    modificar_tile(&nivel,enem_tx,enem_ty,0,0);
    
    loop
        //enem_tx= (x3/resolution3)/id_tscroll.tmapa[0].ancho_tile;
        //enem_ty= (y3/resolution3)/id_tscroll.tmapa[0].alto_tile;
        //say("second "+itoa(y2)+" "+itoa(y3));
        
        //cambios de estado y velocidades
        switch (enem_estado2)
        case 0:     //dormido
            if (veo_prota2(x2,y2,-100,-32,100,80)) enem_estado2=1; end
        end
        case 1:     //despierto
            if (!veo_prota2(x2,y2,-100,-32,100,80)) enem_estado2=0; end
            if (veo_prota2(x2,y2,-50,0,50,64))
                enem_estado2=2;
                energia++;      //despierto es un poco ms peligroso
            end
        end
        case 2:
            if (exists(info_prota.id_prota))
                if (info_prota.id_prota.x2>x2)
                    if (vel_horiz<10) vel_horiz++; end
                else
                    if (vel_horiz>-10) vel_horiz--; end
                end
                if (info_prota.id_prota.y2<y2)
                    if (vel_vert>-10) vel_vert--; end
                else
                    if (vel_vert<10) vel_vert++; end
                end
            else
                if (vel_horiz<0) vel_horiz++; end
                if (vel_horiz>0) vel_horiz--; end
                if (vel_vert<0) vel_vert++; end
                if (vel_vert>0) vel_vert--; end
            end
        end
        end //switch
        
        if (enem_estado2==2)
            //DETECCION DE DUREZAS
            //localizamos la posicin actual
            enem_tilex= (x3/resolution3)/id_tscroll.tmapa[0].ancho_tile;
            enem_tiley= (y3/resolution3)/id_tscroll.tmapa[0].alto_tile;
            enem_offsx= (x3/resolution3)%id_tscroll.tmapa[0].ancho_tile;
            enem_offsy= (y3/resolution3)%id_tscroll.tmapa[0].alto_tile;
            //leemos durezas de su alrededor
            enem_dur[0][0]=obtener_tile(&durezas,enem_tilex-1,enem_tiley-1,0);
            enem_dur[1][0]=obtener_tile(&durezas,enem_tilex  ,enem_tiley-1,0);
            enem_dur[2][0]=obtener_tile(&durezas,enem_tilex+1,enem_tiley-1,0);
            enem_dur[0][1]=obtener_tile(&durezas,enem_tilex-1,enem_tiley  ,0);
            enem_dur[1][1]=obtener_tile(&durezas,enem_tilex  ,enem_tiley  ,0);
            enem_dur[2][1]=obtener_tile(&durezas,enem_tilex+1,enem_tiley  ,0);
            enem_dur[0][2]=obtener_tile(&durezas,enem_tilex-1,enem_tiley+1,0);
            enem_dur[1][2]=obtener_tile(&durezas,enem_tilex  ,enem_tiley+1,0);
            enem_dur[2][2]=obtener_tile(&durezas,enem_tilex+1,enem_tiley+1,0);
            //comprobamos si cambiamos de tile y en que direccion
            //***************************************************************
            enem_mover_h=0;
            if (((x3+vel_horiz)/(id_tscroll.tmapa[0].ancho_tile*resolution3))!=enem_tilex)
               //comprobamos si pasamos a otro tile lateral y cuan lejos esta
               enem_mover_h=((x3+vel_horiz)/(id_tscroll.tmapa[0].ancho_tile*resolution3))-enem_tilex;
            end
            
            enem_mover_v=0;
            if (((y3+vel_vert)/(id_tscroll.tmapa[0].alto_tile*resolution3))!=enem_tiley)
               //comprobamos si pasamos a otro tile vertical y cuan lejos esta
               enem_mover_v=((y3+vel_vert)/(id_tscroll.tmapa[0].alto_tile*resolution3))-enem_tiley;
            end
             //miramos en que direccion cambiamos
            enem_p_dir=5;
            if (enem_mover_h>0) enem_p_dir++; end
            if (enem_mover_h<0) enem_p_dir--; end
            if (enem_mover_v>0) enem_p_dir-=3; end      //hacia abajo
            if (enem_mover_v<0) enem_p_dir+=3; end      //hacia arriba
            enem_p_dir_ini=enem_p_dir;
            
            include "durezas_check.inc";
        end    
        
        //zona de grficos
        switch (enem_estado2)
        case 0: graph=3; end
        case 1: graph=4; end
        case 2:
            cont_anim++;
            switch (cont_anim)
            case 5: graph=2; end
            case 10:
                graph=1;
                cont_anim=0;
            end
            end //switch
            if (vel_horiz<0) flags=0; end
            if (vel_horiz>0) flags=1; end
        end
        end //switch
        
        //**************************************
        //  ZONA DE IMPACTOS
        //**************************************
        if (exists(info_prota.id_prota))
            //impacto con las balas
            if ((abs(x-info_prota.id_prota.x)<350) && (abs(y-info_prota.id_prota.y)<350))
                temp=collision(type normal_shot);
                while (temp)
                    energia-=temp.energia;
                    //say("enemigo ("+itoa(enem_tx)+","+itoa(enem_ty)+"): energa: "+itoa(energia));
                    //say("el disparo tena energia: "+itoa(temp.energia));
                    temp.energia=0;
                    if (mi_temblor!=0 && exists(mi_temblor))
                        mi_temblor.energia=3;
                    else
                        mi_temblor=enem_temblor(id,3);
                    end
                    temp=collision(type normal_shot);
                end
            end
            
            if ((abs(x-info_prota.id_prota.x)<50) && (abs(y-info_prota.id_prota.y)<50))
                temp=collision(type espadazo);
                if (temp && (temp!=temp_espada))
                    energia-=temp.energia;
                    if (mi_temblor!=0 && exists(mi_temblor))
                        mi_temblor.energia=3;
                    else
                        mi_temblor=enem_temblor(id,3);
                    end
                    temp_espada=temp;
                end
            end
            if (energia<=0) break; end
            
            //impacto con el prota
            if ((abs(x-info_prota.id_prota.x)<50) && (abs(y-info_prota.id_prota.y)<50))
                if (collision(info_prota.id_prota))
                    info_prota.dano_id=id;
                    info_prota.dano_energia=2;
                    info_prota.dano_exp=2;
                    if (info_prota.id_prota.x2>x2) info_prota.dano_vel_horiz=20;
                    else info_prota.dano_vel_horiz=-20;
                    end
                end
            end
        end
        
        x2=x3/resolution3;
        y2=y3/resolution3;
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        frame;
    end
    
    random_item (2,x2,y2-(id_tscroll.tmapa[0].ancho_tile/2));
    enem_explos(x2,y2,0,0);
end


process spider (int enem_tx, int enem_ty, energia)
private
    int enem_estado2;       //0: suelo, en espera
                            //1: iniciando salto
                            //2: en salto
                            //3: tocando suelo
    int cont_anim;
    int pos_anim;
    int enem_anim[3]=2,3,2,4;
    
    int temp1;
    int temp2;
    int temp_espada;
    
    int enem_gravedad;
    int enem_max_gravedad;
    int enem_salto;
    int resolution3;
    int x3, y3;
    
    int vel_horiz, vel_vert;
    //variables para la deteccin de durezas
    int enem_dur[2][2];
    int enem_tilex, enem_tiley;
    int enem_offsx, enem_offsy;
    int enem_mover_h, enem_mover_v;
    int enem_p_dir, enem_p_dir_ini;
    int enem_estado;
    int p_libre;
begin
    priority=-99;
    file=enem_grafs[0][cte_spider];
    graph=1;
    z=1;
    enem_gravedad=2;
    enem_max_gravedad=20;
    enem_salto=40;
    
    modificar_tile(&nivel,enem_tx,enem_ty,0,0);
    temp1=obtener_tile(&durezas,enem_tx,enem_ty,0);
    //say("modificado tile");
    
    x2=(enem_tx*id_tscroll.tmapa[0].ancho_tile);
    y2=(enem_ty*id_tscroll.tmapa[0].alto_tile);
    switch (temp1)
    case 251:
        x2+=(id_tscroll.tmapa[0].ancho_tile/2);
        angle=180000;
    end
    case 252:
        x2+=(id_tscroll.tmapa[0].ancho_tile/2);
        y2+=(id_tscroll.tmapa[0].alto_tile-1);
    end
    case 253:
        y2+=((id_tscroll.tmapa[0].alto_tile/2)-1);
        angle=-90000;
    end
    case 254:
        x2+=(id_tscroll.tmapa[0].ancho_tile-1);
        y2+=((id_tscroll.tmapa[0].alto_tile/2)-1);
        angle=90000;
    end
    end //switch
    resolution3=10;
    x3=x2*resolution3;
    y3=y2*resolution3;
    //energia=4;
    //say("comienza cdigo");
    
    loop
        x2=x3/resolution3;
        y2=y3/resolution3;
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        if (veo_prota(x2,y2,2,100,100)) break; end
        
        if (exists(info_prota.id_prota))
            if ((abs(x-info_prota.id_prota.x)<350) && (abs(y-info_prota.id_prota.y)<350))
                temp2=collision(type normal_shot);
                while (temp2)
                    energia-=temp2.energia;
                    //say("enemigo ("+itoa(enem_tx)+","+itoa(enem_ty)+"): energa: "+itoa(energia));
                    //say("el disparo tena energia: "+itoa(temp.energia));
                    temp2.energia=0;
                    if (mi_temblor!=0 && exists(mi_temblor))
                        mi_temblor.energia=3;
                    else
                        mi_temblor=enem_temblor(id,3);
                    end
                    temp2=collision(type normal_shot);
                end
            end
            
            if ((abs(x-info_prota.id_prota.x)<50) && (abs(y-info_prota.id_prota.y)<50))
                temp2=collision(type espadazo);
                if (temp2 && (temp2!=temp_espada))
                    energia-=temp2.energia;
                    if (mi_temblor!=0 && exists(mi_temblor))
                        mi_temblor.energia=3;
                    else
                        mi_temblor=enem_temblor(id,3);
                    end
                    temp_espada=temp2;
                end
            end
            
            //impacto con el prota
            if ((abs(x-info_prota.id_prota.x)<50) && (abs(y-info_prota.id_prota.y)<50))
                if (collision(info_prota.id_prota))
                    info_prota.dano_id=id;
                    info_prota.dano_energia=3;
                    info_prota.dano_exp=4;
                    if (info_prota.id_prota.x2>x2) info_prota.dano_vel_horiz=26;
                    else info_prota.dano_vel_horiz=-26;
                    end
                end
            end
        end
        
        if (energia<=0) break; end
        
        frame;
    end
    //say("cayendo");
    
    //iniciamos caida
    if (energia>0)
        //movimiento
        switch (temp1)
        case 253: vel_horiz=10; end
        case 254: vel_horiz=-10; end
        end
        enem_estado=3;
        
        while ((angle!=0) || (enem_estado!=0))
            //say(itoa(temp2)+" "+itoa(vel_horiz));
            angle=near_angle(angle,0,10000);
            
            //gravedad
            vel_vert+=enem_gravedad;
            if (vel_vert > enem_max_gravedad) vel_vert=enem_max_gravedad; end
            
            //DETECCION DE DUREZAS
            //localizamos la posicin actual
            enem_tilex= (x3/resolution3)/id_tscroll.tmapa[0].ancho_tile;
            enem_tiley= (y3/resolution3)/id_tscroll.tmapa[0].alto_tile;
            enem_offsx= (x3/resolution3)%id_tscroll.tmapa[0].ancho_tile;
            enem_offsy= (y3/resolution3)%id_tscroll.tmapa[0].alto_tile;
            //leemos durezas de su alrededor
            enem_dur[0][0]=obtener_tile(&durezas,enem_tilex-1,enem_tiley-1,0);
            enem_dur[1][0]=obtener_tile(&durezas,enem_tilex  ,enem_tiley-1,0);
            enem_dur[2][0]=obtener_tile(&durezas,enem_tilex+1,enem_tiley-1,0);
            enem_dur[0][1]=obtener_tile(&durezas,enem_tilex-1,enem_tiley  ,0);
            enem_dur[1][1]=obtener_tile(&durezas,enem_tilex  ,enem_tiley  ,0);
            enem_dur[2][1]=obtener_tile(&durezas,enem_tilex+1,enem_tiley  ,0);
            enem_dur[0][2]=obtener_tile(&durezas,enem_tilex-1,enem_tiley+1,0);
            enem_dur[1][2]=obtener_tile(&durezas,enem_tilex  ,enem_tiley+1,0);
            enem_dur[2][2]=obtener_tile(&durezas,enem_tilex+1,enem_tiley+1,0);
            //comprobamos si cambiamos de tile y en que direccion
            //***************************************************************
            enem_mover_h=0;
            if (((x3+vel_horiz)/(id_tscroll.tmapa[0].ancho_tile*resolution3))!=enem_tilex)
               //comprobamos si pasamos a otro tile lateral y cuan lejos esta
               enem_mover_h=((x3+vel_horiz)/(id_tscroll.tmapa[0].ancho_tile*resolution3))-enem_tilex;
            end
            
            enem_mover_v=0;
            if (((y3+vel_vert)/(id_tscroll.tmapa[0].alto_tile*resolution3))!=enem_tiley)
               //comprobamos si pasamos a otro tile vertical y cuan lejos esta
               enem_mover_v=((y3+vel_vert)/(id_tscroll.tmapa[0].alto_tile*resolution3))-enem_tiley;
            end
             //miramos en que direccion cambiamos
            enem_p_dir=5;
            if (enem_mover_h>0) enem_p_dir++; end
            if (enem_mover_h<0) enem_p_dir--; end
            if (enem_mover_v>0) enem_p_dir-=3; end      //hacia abajo
            if (enem_mover_v<0) enem_p_dir+=3; end      //hacia arriba
            enem_p_dir_ini=enem_p_dir;
            
            include "durezas_check.inc";
            
            if (exists(info_prota.id_prota))
                //impacto con las armas
                if ((abs(x-info_prota.id_prota.x)<350) && (abs(y-info_prota.id_prota.y)<350))
                    temp2=collision(type normal_shot);
                    while (temp2)
                        energia-=temp2.energia;
                        //say("enemigo ("+itoa(enem_tx)+","+itoa(enem_ty)+"): energa: "+itoa(energia));
                        //say("el disparo tena energia: "+itoa(temp.energia));
                        temp2.energia=0;
                        if (mi_temblor!=0 && exists(mi_temblor))
                            mi_temblor.energia=3;
                        else
                            mi_temblor=enem_temblor(id,3);
                        end
                        temp2=collision(type normal_shot);
                    end
                end
                
                if ((abs(x-info_prota.id_prota.x)<50) && (abs(y-info_prota.id_prota.y)<50))
                    temp2=collision(type espadazo);
                    if (temp2 && (temp2!=temp_espada))
                        energia-=temp2.energia;
                        if (mi_temblor!=0 && exists(mi_temblor))
                            mi_temblor.energia=3;
                        else
                            mi_temblor=enem_temblor(id,3);
                        end
                        temp_espada=temp2;
                    end
                end
                
                //impacto con el prota
                if ((abs(x-info_prota.id_prota.x)<50) && (abs(y-info_prota.id_prota.y)<50))
                    if (collision(info_prota.id_prota))
                        info_prota.dano_id=id;
                        info_prota.dano_energia=3;
                        info_prota.dano_exp=4;
                        if (info_prota.id_prota.x2>x2) info_prota.dano_vel_horiz=26;
                        else info_prota.dano_vel_horiz=-26;
                        end
                    end
                end
            end
            
            if (energia<=0) break; end
            
            x2=x3/resolution3;
            y2=y3/resolution3;
            tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
            frame;
        end
    end
    vel_horiz=0;
    
    //say("actuando");
    //caida finalizada
    if (energia>0)
        enem_estado2=0;
        
        loop
            //gravedad
            vel_vert+=enem_gravedad;
            if (vel_vert > enem_max_gravedad) vel_vert=enem_max_gravedad; end
            
            //DETECCION DE DUREZAS
            //localizamos la posicin actual
            enem_tilex= (x3/resolution3)/id_tscroll.tmapa[0].ancho_tile;
            enem_tiley= (y3/resolution3)/id_tscroll.tmapa[0].alto_tile;
            enem_offsx= (x3/resolution3)%id_tscroll.tmapa[0].ancho_tile;
            enem_offsy= (y3/resolution3)%id_tscroll.tmapa[0].alto_tile;
            //leemos durezas de su alrededor
            enem_dur[0][0]=obtener_tile(&durezas,enem_tilex-1,enem_tiley-1,0);
            enem_dur[1][0]=obtener_tile(&durezas,enem_tilex  ,enem_tiley-1,0);
            enem_dur[2][0]=obtener_tile(&durezas,enem_tilex+1,enem_tiley-1,0);
            enem_dur[0][1]=obtener_tile(&durezas,enem_tilex-1,enem_tiley  ,0);
            enem_dur[1][1]=obtener_tile(&durezas,enem_tilex  ,enem_tiley  ,0);
            enem_dur[2][1]=obtener_tile(&durezas,enem_tilex+1,enem_tiley  ,0);
            enem_dur[0][2]=obtener_tile(&durezas,enem_tilex-1,enem_tiley+1,0);
            enem_dur[1][2]=obtener_tile(&durezas,enem_tilex  ,enem_tiley+1,0);
            enem_dur[2][2]=obtener_tile(&durezas,enem_tilex+1,enem_tiley+1,0);
            //comprobamos si cambiamos de tile y en que direccion
            //***************************************************************
            enem_mover_h=0;
            if (((x3+vel_horiz)/(id_tscroll.tmapa[0].ancho_tile*resolution3))!=enem_tilex)
               //comprobamos si pasamos a otro tile lateral y cuan lejos esta
               enem_mover_h=((x3+vel_horiz)/(id_tscroll.tmapa[0].ancho_tile*resolution3))-enem_tilex;
            end
            
            enem_mover_v=0;
            if (((y3+vel_vert)/(id_tscroll.tmapa[0].alto_tile*resolution3))!=enem_tiley)
               //comprobamos si pasamos a otro tile vertical y cuan lejos esta
               enem_mover_v=((y3+vel_vert)/(id_tscroll.tmapa[0].alto_tile*resolution3))-enem_tiley;
            end
             //miramos en que direccion cambiamos
            enem_p_dir=5;
            if (enem_mover_h>0) enem_p_dir++; end
            if (enem_mover_h<0) enem_p_dir--; end
            if (enem_mover_v>0) enem_p_dir-=3; end      //hacia abajo
            if (enem_mover_v<0) enem_p_dir+=3; end      //hacia arriba
            enem_p_dir_ini=enem_p_dir;
            
            include "durezas_check.inc";
            
            //zona de animaciones y cambio de estado
            switch (enem_estado2)
            case 0:
                if (cont_anim>150) //&& veo_prota(x2,y2,2,100,100))
                    enem_estado2=1;
                    cont_anim=0;
                else
                    cont_anim++;
                end
            end
            case 1:
                if (cont_anim==5)
                    pos_anim++;
                    graph=enem_anim[pos_anim];
                    if (pos_anim==3)
                        enem_estado=2;
                        enem_estado2=2;
                        vel_vert=-enem_salto;
                        if (exists(info_prota.id_prota))
                            if (info_prota.id_prota.x2<x2)
                                vel_horiz=-10;
                            else
                                vel_horiz=10;
                            end
                        end
                    end
                    cont_anim=0;
                else
                    cont_anim++;
                end
            end
            case 2:
                if ((enem_estado!=2) && (enem_estado!=3))
                    vel_horiz=0;
                    enem_estado2=3;
                end
            end
            case 3:
                vel_horiz=0;
                if (cont_anim==5)
                    pos_anim--;
                    graph=enem_anim[pos_anim];
                    if (pos_anim==0)
                        enem_estado2=0;
                    end
                    cont_anim=0;
                else
                    cont_anim++;
                end
            end
            end //switch
            
            //choque con las armas
            if (exists(info_prota.id_prota))
                if ((abs(x-info_prota.id_prota.x)<350) && (abs(y-info_prota.id_prota.y)<350))
                    temp2=collision(type normal_shot);
                    while (temp2)
                        energia-=temp2.energia;
                        //say("enemigo ("+itoa(enem_tx)+","+itoa(enem_ty)+"): energa: "+itoa(energia));
                        //say("el disparo tena energia: "+itoa(temp.energia));
                        temp2.energia=0;
                        if (mi_temblor!=0 && exists(mi_temblor))
                            mi_temblor.energia=3;
                        else
                            mi_temblor=enem_temblor(id,3);
                        end
                        temp2=collision(type normal_shot);
                    end
                end
                
                if ((abs(x-info_prota.id_prota.x)<50) && (abs(y-info_prota.id_prota.y)<50))
                    temp2=collision(type espadazo);
                    if (temp2 && (temp2!=temp_espada))
                        energia-=temp2.energia;
                        if (mi_temblor!=0 && exists(mi_temblor))
                            mi_temblor.energia=3;
                        else
                            mi_temblor=enem_temblor(id,3);
                        end
                        temp_espada=temp2;
                    end
                end
                //impacto con el prota
                if ((abs(x-info_prota.id_prota.x)<50) && (abs(y-info_prota.id_prota.y)<50))
                    if (collision(info_prota.id_prota))
                        info_prota.dano_id=id;
                        info_prota.dano_energia=3;
                        info_prota.dano_exp=4;
                        if (info_prota.id_prota.x2>x2) info_prota.dano_vel_horiz=26;
                        else info_prota.dano_vel_horiz=-26;
                        end
                    end
                end
            end
            
            if (energia<=0) break; end
            
            x2=x3/resolution3;
            y2=y3/resolution3;
            tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
            frame;
        end
        
    end
    
    //explosion
    //shot_exp(x2,y2-(id_tscroll.tmapa[0].ancho_tile/2),2,rand(-15,15));
    random_item (2,x2,y2-(id_tscroll.tmapa[0].ancho_tile/2));
    enem_explos(x2,y2-7,0,0);
end


process super_guerrillero (int enem_tx, int enem_ty, file, flags)
private
    byte enem_estado2;      //0: descansando (fumando)
                            //1: sorprendido (tras fumando)
                            //2: de guardia (no se mueve del sitio, pero te ve antes y ataca antes)
                            //3: andando derecha (patrullando)
                            //4: andando izquierda (patrullando)
                            //5: pausa andando (patrullando)
                            //6: persiguiendo (te ve y se lanza al ataque)
                            //7: en espera (como de guardia, pero si te ve, te persigue)
                            //8: saltando
    int x3,y3;
    int resolution3;
    
    int vel_horiz,vel_vert;
    int enem_gravedad;
    int enem_max_gravedad;
    int enem_salto;
    int enem_salto2;
    
    //int mi_temblor;
    
    int cont_estado;        //dice el tiempo que queda para cambiar de estado
    int cont_anim;          //cuenta el retardo entre frames
    int pos_anim;           //indica qu grfico de animacin de andar muestra
    byte enem_anim[3]=1,2,1,3;  //animacin andar
    
    int temp;
    int temp_x1,temp_y1;
    int temp_angle;
    int vel_horiz_ant;
    int temp_espada;
    //variables para la deteccin de durezas
    int enem_dur[2][2];
    int enem_tilex, enem_tiley;
    int enem_offsx, enem_offsy;
    int enem_mover_h, enem_mover_v;
    int enem_p_dir, enem_p_dir_ini;
    int enem_estado;
    int p_libre;
begin
    priority=-99;
    //file=enem_grafs[0][cte_s_guerrillero];
    z=1;
    enem_gravedad=2;
    enem_max_gravedad=30;
    enem_salto=30;
    enem_salto2=40;
    
    x2=(enem_tx*id_tscroll.tmapa[0].ancho_tile) + (id_tscroll.tmapa[0].ancho_tile/2);
    y2=(enem_ty*id_tscroll.tmapa[0].alto_tile) + (id_tscroll.tmapa[0].alto_tile-1);
    resolution3=10;
    x3=x2*resolution3;
    y3=y2*resolution3;
    energia=20;
    
    modificar_tile(&nivel,enem_tx,enem_ty,0,0);
    temp=obtener_tile(&durezas,enem_tx,enem_ty,0);
    
    //estableciendo comportamiento inicial
    switch (temp)
    case 253: enem_estado2=4; end
    case 254: enem_estado2=3; end
    default: enem_estado2=4; end
    end //switch
    
    loop
        //cambios de estado
        switch (enem_estado2)
        case 2:         //de guardia
            if (veo_prota(x2,y2,(flags & 1),150,70))
                enem_estado2=6;
                cont_estado=0;
            end
        end
        case 3:         //andando derecha
            cont_estado++;
            vel_horiz++;
            if (vel_horiz>10) vel_horiz=10; end
            if (veo_prota(x2,y2,1,150,70))
                enem_estado2=6;
                cont_estado=0;
            end
        end
        case 4:         //andando izquierda
            cont_estado++;
            vel_horiz--;
            if (vel_horiz<-10) vel_horiz=-10; end
            if (veo_prota(x2,y2,0,150,70))
                enem_estado2=6;
                cont_estado=0;
            end
        end
        case 6:
            if (exists(info_prota.id_prota))
                //comprobamos distancia con el prota
                temp=info_prota.id_prota.x2-x2;
                //muy cerca, puetazo
                if ((abs(temp) < 40) || (cont_estado>0))
                    cont_estado++;
                    //**********************
                else
                    //un poco ms lejos saltamos, si no, nos acercamos
                    if (temp > 32) 
                        vel_horiz=10;
                    elsif (temp < -32) 
                        vel_horiz=-10;
                    end
                    if ((abs(temp) < 60) && ((enem_estado==0) || (enem_estado==1)))
                        enem_estado2=8;
                        vel_vert=-enem_salto2;
                        enem_estado=3;
                    end
                    //si llegamos a un borde, damos un salto
                    if ((info_prota.id_prota.y2-y2) <= 0)
                        switch (enem_dur[1][2])
                        case 0,50,32,33,34,82,83,84,100,104:
                            if ((enem_estado==0) || (enem_estado==1))
                                vel_vert=-enem_salto;
                                enem_estado=3;
                            end
                        end
                        end //switch
                    end
                end
                
                if (cont_estado > 0)
                    if (vel_horiz>0) vel_horiz--; end
                    if (vel_horiz<0) vel_horiz++; end
                    if (cont_estado==31) //dispara
                        //say("quiero disparar");
                        //DISPARAMOS
                        get_real_point(1,&temp_x1,&temp_y1);  //punto de salida
                        //buscamos desplazamiento en pixels
                        temp_x1-=x;
                        temp_y1-=y;
                        //creamos el disparo en coordenadas del scroll
                        if ((flags & 1)==1) temp_angle=0; else temp_angle=180000; end
                        enem_short_power_shot(file,150,150,x2+temp_x1,y2+temp_y1,temp_angle,10,500);
                    end
                    if (cont_estado==140) cont_estado=0; end
                end
            end
        end
        case 7:
            if (veo_prota(x2,y2,(flags & 1),300,200))
                enem_estado2=6;
            end
        end
        case 8:
            if ((flags & 1)==1) vel_horiz=10; else vel_horiz=-10; end
        end
        end //switch
        vel_horiz_ant=vel_horiz;
        
        //gravedad
        vel_vert+=enem_gravedad;
        if (vel_vert > enem_max_gravedad) vel_vert=enem_max_gravedad; end
        
        //DETECCION DE DUREZAS
        //localizamos la posicin actual
        enem_tilex= (x3/resolution3)/id_tscroll.tmapa[0].ancho_tile;
        enem_tiley= (y3/resolution3)/id_tscroll.tmapa[0].alto_tile;
        enem_offsx= (x3/resolution3)%id_tscroll.tmapa[0].ancho_tile;
        enem_offsy= (y3/resolution3)%id_tscroll.tmapa[0].alto_tile;
        //leemos durezas de su alrededor
        enem_dur[0][0]=obtener_tile(&durezas,enem_tilex-1,enem_tiley-1,0);
        enem_dur[1][0]=obtener_tile(&durezas,enem_tilex  ,enem_tiley-1,0);
        enem_dur[2][0]=obtener_tile(&durezas,enem_tilex+1,enem_tiley-1,0);
        enem_dur[0][1]=obtener_tile(&durezas,enem_tilex-1,enem_tiley  ,0);
        enem_dur[1][1]=obtener_tile(&durezas,enem_tilex  ,enem_tiley  ,0);
        enem_dur[2][1]=obtener_tile(&durezas,enem_tilex+1,enem_tiley  ,0);
        enem_dur[0][2]=obtener_tile(&durezas,enem_tilex-1,enem_tiley+1,0);
        enem_dur[1][2]=obtener_tile(&durezas,enem_tilex  ,enem_tiley+1,0);
        enem_dur[2][2]=obtener_tile(&durezas,enem_tilex+1,enem_tiley+1,0);
        //comprobamos si cambiamos de tile y en que direccion
        //***************************************************************
        enem_mover_h=0;
        if (((x3+vel_horiz)/(id_tscroll.tmapa[0].ancho_tile*resolution3))!=enem_tilex)
           //comprobamos si pasamos a otro tile lateral y cuan lejos esta
           enem_mover_h=((x3+vel_horiz)/(id_tscroll.tmapa[0].ancho_tile*resolution3))-enem_tilex;
        end
        
        enem_mover_v=0;
        if (((y3+vel_vert)/(id_tscroll.tmapa[0].alto_tile*resolution3))!=enem_tiley)
           //comprobamos si pasamos a otro tile vertical y cuan lejos esta
           enem_mover_v=((y3+vel_vert)/(id_tscroll.tmapa[0].alto_tile*resolution3))-enem_tiley;
        end
         //miramos en que direccion cambiamos
        enem_p_dir=5;
        if (enem_mover_h>0) enem_p_dir++; end
        if (enem_mover_h<0) enem_p_dir--; end
        if (enem_mover_v>0) enem_p_dir-=3; end      //hacia abajo
        if (enem_mover_v<0) enem_p_dir+=3; end      //hacia arriba
        enem_p_dir_ini=enem_p_dir;
        
        include "durezas_check.inc";
        
        //post anlisis
        if ( (vel_horiz!=0) && (enem_estado==0) )
            enem_estado=1;
        end
        if ( (vel_horiz==0) && (enem_estado==1) )
            enem_estado=0;
        end
        
        switch (enem_estado2)
        case 3:
            switch (enem_dur[1][1])
            case 253:
                enem_estado2=4;
                cont_estado=0;
            end
            case 251:       //flecha hacia arriba (salta)
                if ((enem_estado==1) || (enem_estado==0))
                    vel_vert=-enem_salto;
                    enem_estado=3;
                end
            end
            end //switch
        end
        case 4:
            switch (enem_dur[1][1])
            case 254:
                enem_estado2=3;
                cont_estado=0;
            end
            case 251:       //flecha hacia arriba (salta)
                if ((enem_estado==1) || (enem_estado==0))
                    vel_vert=-enem_salto;
                    enem_estado=3;
                end
            end
            end //switch
        end
        case 6:
            if (temp > 0) flags=1; else flags=0; end
            
            //si se para porque choca con una pared, comprueba si puede seguir con un salto
            if (vel_horiz==0)
                if (vel_horiz_ant>0)
                    switch (enem_dur[2][0])
                    case 1,2,5,14,51,52,55,64:
                        p_libre=false;
                    end
                    default: p_libre=true; end
                    end //switch
                    
                end
                if (vel_horiz_ant<0)
                    switch (enem_dur[0][0])
                    case 1,3,4,16,51,53,54,66:
                        p_libre=false;
                    end
                    default: p_libre=true; end
                    end //switch
                end
                if (vel_horiz_ant==0) p_libre=false; end
            
                // si se puede, pues salta
                if (p_libre && ((enem_estado==1) || (enem_estado==0)))
                    enem_estado=8;
                    vel_vert=-enem_salto;
                    enem_estado=3;
                end
            end
        end
        case 8:
            if ((enem_estado==1) || (enem_estado==0))
                enem_estado2=6;
                cont_estado=0;
            end
        end
        end //switch
        
        
        //zona de grficos
        switch (enem_estado2)
        case 2,7:               //de guardia y en espera
            graph=1;
        end
        case 3,4,5,6:   //patrullando y persiguiendo
            switch (enem_estado)
            case 0:
                if (cont_estado==0)
                    graph=1;
                else
                    if (cont_estado < 30) graph=6; else graph=7; end
                end
            end
            case 1:
                if (vel_horiz>0) flags=1; end
                if (vel_horiz<0) flags=0; end
                cont_anim++;
                if (cont_anim==10)
                    cont_anim=0;
                    if (pos_anim==3) pos_anim=0; else pos_anim++; end
                    graph=enem_anim[pos_anim];
                end
            end
            case 2,3: graph=5; end
            end //switch
        end
        case 8:
            graph=5;
        end
        end //switch
        
        //*********************************
        //  ZONA DE COLISIONES
        //*********************************
        //impacto con el prota
        if (exists(info_prota.id_prota))
            if ((abs(x-info_prota.id_prota.x)<65) && (abs(y-info_prota.id_prota.y)<65))
                if (collision(info_prota.id_prota))
                    info_prota.dano_id=id;
                    info_prota.dano_energia=4;
                    info_prota.dano_exp=4;
                    if (info_prota.id_prota.x2>x2) info_prota.dano_vel_horiz=26;
                    else info_prota.dano_vel_horiz=-26;
                    end
                end
            end
            
            //impacto con las balas
            if ((abs(x-info_prota.id_prota.x)<350) && (abs(y-info_prota.id_prota.y)<350))
                temp=collision(type normal_shot);
                while (temp)
                    energia-=temp.energia;
                    //say("enemigo ("+itoa(enem_tx)+","+itoa(enem_ty)+"): energa: "+itoa(energia));
                    //say("el disparo tena energia: "+itoa(temp.energia));
                    temp.energia=0;
                    if (mi_temblor!=0 && exists(mi_temblor))
                        mi_temblor.energia=3;
                    else
                        mi_temblor=enem_temblor(id,3);
                    end
                    temp=collision(type normal_shot);
                end
            end
            
            if ((abs(x-info_prota.id_prota.x)<50) && (abs(y-info_prota.id_prota.y)<50))
                temp=collision(type espadazo);
                if (temp && (temp!=temp_espada))
                    energia-=temp.energia;
                    if (mi_temblor!=0 && exists(mi_temblor))
                        mi_temblor.energia=3;
                    else
                        mi_temblor=enem_temblor(id,3);
                    end
                    temp_espada=temp;
                end
            end
        end
        if (energia<=0) break; end
        
        x2=x3/resolution3;
        y2=y3/resolution3;
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        frame;
    end
    
    random_item (15,x2,y2-(id_tscroll.tmapa[0].ancho_tile/2));
    enem_explos(x2,y2-24,-1,-1);
    enem_explos(x2,y2-24,1,-1);
    enem_explos(x2,y2-8,-1,1);
    enem_explos(x2,y2-8,1,1);
end

process volador1 (int enem_tx, int enem_ty, file, energia)     //sigue un camino
private
    int x3, y3;
    int resolution3;
    int enem_estado2;
    
    int vel_horiz, vel_vert;
    int cont_anim;
    int temp;
    int temp_espada;
begin
    priority=-99;
    //file=enem_grafs[0][cte_volador1];
    z=1;
    
    x2=(enem_tx*id_tscroll.tmapa[0].ancho_tile) + (id_tscroll.tmapa[0].ancho_tile/2);
    y2=(enem_ty*id_tscroll.tmapa[0].alto_tile) + (id_tscroll.tmapa[0].alto_tile-1);
    resolution3=10;
    x3=x2*resolution3;
    y3=y2*resolution3;
    //energia=20;
    
    modificar_tile(&nivel,enem_tx,enem_ty,0,0);
    temp=obtener_tile(&durezas,enem_tx,enem_ty,0);
    
    //estableciendo comportamiento inicial
    switch (temp)
    case 251: enem_estado2=0; end       //movemos hacia arriba
    case 252: enem_estado2=1; end       //movemos hacia abajo
    case 253: enem_estado2=2; end       //movemos hacia izquierda
    case 254: enem_estado2=3; end       //movemos hacia derecha
    end //switch
    
    //empieza
    loop
        enem_tx= (x3/resolution3)/id_tscroll.tmapa[0].ancho_tile;
        enem_ty= (y3/resolution3)/id_tscroll.tmapa[0].alto_tile;
        
        temp=obtener_tile(&durezas,enem_tx,enem_ty,0);
        switch (temp)
        case 251: enem_estado2=0; end       //movemos hacia arriba
        case 252: enem_estado2=1; end       //movemos hacia abajo
        case 253: enem_estado2=2; end       //movemos hacia izquierda
        case 254: enem_estado2=3; end       //movemos hacia derecha
        end //switch
        
        //establecemos velocidades
        switch (enem_estado2)
        case 0:
            if (vel_horiz<0) vel_horiz++; end
            if (vel_horiz>0) vel_horiz--; end
            if (vel_vert>-7) vel_vert--; end
        end
        case 1:
            if (vel_horiz<0) vel_horiz++; end
            if (vel_horiz>0) vel_horiz--; end
            if (vel_vert<7) vel_vert++; end
        end
        case 2:
            if (vel_vert<0) vel_vert++; end
            if (vel_vert>0) vel_vert--; end
            if (vel_horiz>-7) vel_horiz--; end
        end
        case 3:
            if (vel_vert<0) vel_vert++; end
            if (vel_vert>0) vel_vert--; end
            if (vel_horiz<7) vel_horiz++; end
        end
        end //switch
        
        x3+=vel_horiz;
        y3+=vel_vert;
        
        //zona de grficos
        cont_anim++;
        switch (cont_anim)
        case 10: graph=2; end
        case 20:
            graph=1;
            cont_anim=0;
        end
        end //switch
        if (vel_horiz<0) flags=0; end
        if (vel_horiz>0) flags=1; end
        
        //*****************************
        // ZONA DE IMPACTOS
        //*****************************
        if (exists(info_prota.id_prota))
            //impacto con las balas
            if ((abs(x-info_prota.id_prota.x)<350) && (abs(y-info_prota.id_prota.y)<350))
                temp=collision(type normal_shot);
                while (temp)
                    energia-=temp.energia;
                    //say("enemigo ("+itoa(enem_tx)+","+itoa(enem_ty)+"): energa: "+itoa(energia));
                    //say("el disparo tena energia: "+itoa(temp.energia));
                    temp.energia=0;
                    if (mi_temblor!=0 && exists(mi_temblor))
                        mi_temblor.energia=3;
                    else
                        mi_temblor=enem_temblor(id,3);
                    end
                    temp=collision(type normal_shot);
                end
            end
            
            if ((abs(x-info_prota.id_prota.x)<50) && (abs(y-info_prota.id_prota.y)<50))
                temp=collision(type espadazo);
                if (temp && (temp!=temp_espada))
                    energia-=temp.energia;
                    if (mi_temblor!=0 && exists(mi_temblor))
                        mi_temblor.energia=3;
                    else
                        mi_temblor=enem_temblor(id,3);
                    end
                    temp_espada=temp;
                end
            end
            if (energia<=0) break; end
            
            //impacto con el prota
            if ((abs(x-info_prota.id_prota.x)<50) && (abs(y-info_prota.id_prota.y)<50))
                if (collision(info_prota.id_prota))
                    info_prota.dano_id=id;
                    info_prota.dano_energia=2;
                    info_prota.dano_exp=2;
                    if (info_prota.id_prota.x2>x2) info_prota.dano_vel_horiz=20;
                    else info_prota.dano_vel_horiz=-20;
                    end
                end
            end
        end
        
        x2=x3/resolution3;
        y2=y3/resolution3;
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        frame;
    end
    
    random_item (2,x2,y2-(id_tscroll.tmapa[0].ancho_tile/2));
    enem_explos(x2,y2,0,0);
end

process volador2 (int enem_tx, int enem_ty, file, energia)      //sigue un camino, persigue al prota, y ataca en
private                                                         //picado
    int x3, y3;
    int resolution3;
    int enem_estado2;           //0: mover hacia arriba
                                //1: mover hacia abajo
                                //2: mover hacia izquierda
                                //3: mover hacia derecha
                                //4: acercarse a prota
                                //5: atacando a prota
    
    int vel_horiz, vel_vert;
    int cont_anim;
    int cont_estado;
    int temp;
    int temp_espada;
    
    //variables para la deteccin de durezas
    int enem_dur[2][2];
    int enem_tilex, enem_tiley;
    int enem_offsx, enem_offsy;
    int enem_mover_h, enem_mover_v;
    int enem_p_dir, enem_p_dir_ini;
    int enem_estado;
    int p_libre;
begin
    priority=-99;
    //file=enem_grafs[0][cte_volador1];
    z=1;
    
    x2=(enem_tx*id_tscroll.tmapa[0].ancho_tile) + (id_tscroll.tmapa[0].ancho_tile/2);
    y2=(enem_ty*id_tscroll.tmapa[0].alto_tile) + (id_tscroll.tmapa[0].alto_tile-1);
    resolution3=10;
    x3=x2*resolution3;
    y3=y2*resolution3;
    //energia=20;
    
    modificar_tile(&nivel,enem_tx,enem_ty,0,0);
    temp=obtener_tile(&durezas,enem_tx,enem_ty,0);
    
    //estableciendo comportamiento inicial
    switch (temp)
    case 251: enem_estado2=0; end       //movemos hacia arriba
    case 252: enem_estado2=1; end       //movemos hacia abajo
    case 253: enem_estado2=2; end       //movemos hacia izquierda
    case 254: enem_estado2=3; end       //movemos hacia derecha
    end //switch
    
    //empieza
    loop
        enem_tx= (x3/resolution3)/id_tscroll.tmapa[0].ancho_tile;
        enem_ty= (y3/resolution3)/id_tscroll.tmapa[0].alto_tile;
        
        if (enem_estado2<4)
            temp=obtener_tile(&durezas,enem_tx,enem_ty,0);
            switch (temp)
            case 251: enem_estado2=0; end       //movemos hacia arriba
            case 252: enem_estado2=1; end       //movemos hacia abajo
            case 253: enem_estado2=2; end       //movemos hacia izquierda
            case 254: enem_estado2=3; end       //movemos hacia derecha
            end //switch
            //say("veo prota 2: "+itoa(veo_prota2(x3,y3,-100,-100,100,100)));
            if (veo_prota2(x2,y2,-50,-50,50,50))
                enem_estado2=4;
                cont_anim=0;
            end
        elsif (enem_estado2==4)
            if (veo_prota2(x2,y2+64,-10,0,10,100))
                enem_estado2=5;
                cont_anim=0;
                cont_estado=0;
            end
        end
        
        //establecemos velocidades
        switch (enem_estado2)
        case 0:
            if (vel_horiz<0) vel_horiz++; end
            if (vel_horiz>0) vel_horiz--; end
            if (vel_vert>-7) vel_vert--; end
        end
        case 1:
            if (vel_horiz<0) vel_horiz++; end
            if (vel_horiz>0) vel_horiz--; end
            if (vel_vert<7) vel_vert++; end
        end
        case 2:
            if (vel_vert<0) vel_vert++; end
            if (vel_vert>0) vel_vert--; end
            if (vel_horiz>-7) vel_horiz--; end
        end
        case 3:
            if (vel_vert<0) vel_vert++; end
            if (vel_vert>0) vel_vert--; end
            if (vel_horiz<7) vel_horiz++; end
        end
        case 4:
            if (exists(info_prota.id_prota))
                if (info_prota.id_prota.x2>x2)
                    if (vel_horiz<10) vel_horiz++; end
                else
                    if (vel_horiz>-10) vel_horiz--; end
                end
                if ((info_prota.id_prota.y2-64)<y2)
                    if (vel_vert>-10) vel_vert--; end
                else
                    if (vel_vert<10) vel_vert++; end
                end
            else
                if (vel_horiz<0) vel_horiz++; end
                if (vel_horiz>0) vel_horiz--; end
                if (vel_vert<0) vel_vert++; end
                if (vel_vert>0) vel_vert--; end
            end
        end
        case 5:
            if (cont_estado<50)
                cont_estado++;
                vel_horiz=0;
                vel_vert=0;
            else
                vel_vert=15;
                if (exists(info_prota.id_prota))
                    if (info_prota.id_prota.x2>x2)
                        if (vel_horiz<10) vel_horiz++; end
                    else
                        if (vel_horiz>-10) vel_horiz--; end
                    end
                else
                    vel_horiz=0;
                end
            end
        end
        end //switch
        
        //DETECCION DE DUREZAS
        //localizamos la posicin actual
        enem_tilex= (x3/resolution3)/id_tscroll.tmapa[0].ancho_tile;
        enem_tiley= (y3/resolution3)/id_tscroll.tmapa[0].alto_tile;
        enem_offsx= (x3/resolution3)%id_tscroll.tmapa[0].ancho_tile;
        enem_offsy= (y3/resolution3)%id_tscroll.tmapa[0].alto_tile;
        //leemos durezas de su alrededor
        enem_dur[0][0]=obtener_tile(&durezas,enem_tilex-1,enem_tiley-1,0);
        enem_dur[1][0]=obtener_tile(&durezas,enem_tilex  ,enem_tiley-1,0);
        enem_dur[2][0]=obtener_tile(&durezas,enem_tilex+1,enem_tiley-1,0);
        enem_dur[0][1]=obtener_tile(&durezas,enem_tilex-1,enem_tiley  ,0);
        enem_dur[1][1]=obtener_tile(&durezas,enem_tilex  ,enem_tiley  ,0);
        enem_dur[2][1]=obtener_tile(&durezas,enem_tilex+1,enem_tiley  ,0);
        enem_dur[0][2]=obtener_tile(&durezas,enem_tilex-1,enem_tiley+1,0);
        enem_dur[1][2]=obtener_tile(&durezas,enem_tilex  ,enem_tiley+1,0);
        enem_dur[2][2]=obtener_tile(&durezas,enem_tilex+1,enem_tiley+1,0);
        //comprobamos si cambiamos de tile y en que direccion
        //***************************************************************
        enem_mover_h=0;
        if (((x3+vel_horiz)/(id_tscroll.tmapa[0].ancho_tile*resolution3))!=enem_tilex)
           //comprobamos si pasamos a otro tile lateral y cuan lejos esta
           enem_mover_h=((x3+vel_horiz)/(id_tscroll.tmapa[0].ancho_tile*resolution3))-enem_tilex;
        end
        
        enem_mover_v=0;
        if (((y3+vel_vert)/(id_tscroll.tmapa[0].alto_tile*resolution3))!=enem_tiley)
           //comprobamos si pasamos a otro tile vertical y cuan lejos esta
           enem_mover_v=((y3+vel_vert)/(id_tscroll.tmapa[0].alto_tile*resolution3))-enem_tiley;
        end
         //miramos en que direccion cambiamos
        enem_p_dir=5;
        if (enem_mover_h>0) enem_p_dir++; end
        if (enem_mover_h<0) enem_p_dir--; end
        if (enem_mover_v>0) enem_p_dir-=3; end      //hacia abajo
        if (enem_mover_v<0) enem_p_dir+=3; end      //hacia arriba
        enem_p_dir_ini=enem_p_dir;
        
        include "durezas_check.inc";
        
        
        //zona de grficos
        switch (enem_estado2)
        case 0,1,2,3:
            cont_anim++;
            switch (cont_anim)
            case 10: graph=2; end
            case 20:
                graph=1;
                cont_anim=0;
            end
            end //switch
            if (vel_horiz<0) flags=0; end
            if (vel_horiz>0) flags=1; end
        end
        case 4:
            cont_anim++;
            switch (cont_anim)
            case 5: graph=2; end
            case 10:
                graph=1;
                cont_anim=0;
            end
            end //switch
            if (vel_horiz<0) flags=0; end
            if (vel_horiz>0) flags=1; end
        end
        case 5:
            if (cont_estado<50)
                graph=1;
                cont_estado++;
            else
                flags=0;
                cont_anim++;
                switch (cont_anim)
                case 3: graph=4; end
                case 6: graph=5; end
                case 9: graph=6; end
                case 12:
                    graph=3;
                    cont_anim=0;
                end
                end //switch
                
                if (vel_vert==0)
                    cont_anim=0;
                    cont_estado=0;
                    enem_estado2=4;
                end
            end
        end
        end //switch
        
        //**************************************
        //  ZONA DE IMPACTOS
        //**************************************
        if (exists(info_prota.id_prota))
            //impacto con las balas
            if ((abs(x-info_prota.id_prota.x)<350) && (abs(y-info_prota.id_prota.y)<350))
                temp=collision(type normal_shot);
                while (temp)
                    energia-=temp.energia;
                    //say("enemigo ("+itoa(enem_tx)+","+itoa(enem_ty)+"): energa: "+itoa(energia));
                    //say("el disparo tena energia: "+itoa(temp.energia));
                    temp.energia=0;
                    if (mi_temblor!=0 && exists(mi_temblor))
                        mi_temblor.energia=3;
                    else
                        mi_temblor=enem_temblor(id,3);
                    end
                    temp=collision(type normal_shot);
                end
            end
            
            if ((abs(x-info_prota.id_prota.x)<50) && (abs(y-info_prota.id_prota.y)<50))
                temp=collision(type espadazo);
                if (temp && (temp!=temp_espada))
                    energia-=temp.energia;
                    if (mi_temblor!=0 && exists(mi_temblor))
                        mi_temblor.energia=3;
                    else
                        mi_temblor=enem_temblor(id,3);
                    end
                    temp_espada=temp;
                end
            end
            if (energia<=0) break; end
            
            //impacto con el prota
            if ((abs(x-info_prota.id_prota.x)<50) && (abs(y-info_prota.id_prota.y)<50))
                if (collision(info_prota.id_prota))
                    info_prota.dano_id=id;
                    if (enem_estado2==5)
                        info_prota.dano_energia=4;
                        info_prota.dano_exp=3;
                    else
                        info_prota.dano_energia=2;
                        info_prota.dano_exp=2;
                    end
                    if (info_prota.id_prota.x2>x2) info_prota.dano_vel_horiz=20;
                    else info_prota.dano_vel_horiz=-20;
                    end
                end
            end
        end
        
        x2=x3/resolution3;
        y2=y3/resolution3;
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        frame;
    end
    
    random_item (2,x2,y2-(id_tscroll.tmapa[0].ancho_tile/2));
    enem_explos(x2,y2,0,0);
end

process volador3 (int enem_tx, int enem_ty, file)     //sigue un camino y es invencible
private
    int x3, y3;
    int resolution3;
    int enem_estado2;
    
    int vel_horiz, vel_vert;
    int cont_anim;
    int temp;
    int temp_espada;
begin
    priority=-99;
    //file=enem_grafs[0][cte_volador1];
    z=1;
    
    x2=(enem_tx*id_tscroll.tmapa[0].ancho_tile) + (id_tscroll.tmapa[0].ancho_tile/2);
    y2=(enem_ty*id_tscroll.tmapa[0].alto_tile) + (id_tscroll.tmapa[0].alto_tile-1);
    resolution3=10;
    x3=x2*resolution3;
    y3=y2*resolution3;
    //energia=20;
    
    modificar_tile(&nivel,enem_tx,enem_ty,0,0);
    temp=obtener_tile(&durezas,enem_tx,enem_ty,0);
    
    //estableciendo comportamiento inicial
    switch (temp)
    case 251: enem_estado2=0; end       //movemos hacia arriba
    case 252: enem_estado2=1; end       //movemos hacia abajo
    case 253: enem_estado2=2; end       //movemos hacia izquierda
    case 254: enem_estado2=3; end       //movemos hacia derecha
    end //switch
    
    //empieza
    loop
        enem_tx= (x3/resolution3)/id_tscroll.tmapa[0].ancho_tile;
        enem_ty= (y3/resolution3)/id_tscroll.tmapa[0].alto_tile;
        
        temp=obtener_tile(&durezas,enem_tx,enem_ty,0);
        switch (temp)
        case 251: enem_estado2=0; end       //movemos hacia arriba
        case 252: enem_estado2=1; end       //movemos hacia abajo
        case 253: enem_estado2=2; end       //movemos hacia izquierda
        case 254: enem_estado2=3; end       //movemos hacia derecha
        end //switch
        
        //establecemos velocidades
        switch (enem_estado2)
        case 0:
            if (vel_horiz<0) vel_horiz++; end
            if (vel_horiz>0) vel_horiz--; end
            if (vel_vert>-7) vel_vert--; end
        end
        case 1:
            if (vel_horiz<0) vel_horiz++; end
            if (vel_horiz>0) vel_horiz--; end
            if (vel_vert<7) vel_vert++; end
        end
        case 2:
            if (vel_vert<0) vel_vert++; end
            if (vel_vert>0) vel_vert--; end
            if (vel_horiz>-7) vel_horiz--; end
        end
        case 3:
            if (vel_vert<0) vel_vert++; end
            if (vel_vert>0) vel_vert--; end
            if (vel_horiz<7) vel_horiz++; end
        end
        end //switch
        
        x3+=vel_horiz;
        y3+=vel_vert;
        
        //zona de grficos
        cont_anim++;
        switch (cont_anim)
        case 10: graph=2; end
        case 20:
            graph=1;
            cont_anim=0;
        end
        end //switch
        if (vel_horiz<0) flags=0; end
        if (vel_horiz>0) flags=1; end
        
        //*****************************
        // ZONA DE IMPACTOS
        //*****************************
        if (!out_region(id,0))
        
            if (exists(info_prota.id_prota))
                //impacto con las balas
                if ((abs(x-info_prota.id_prota.x)<350) && (abs(y-info_prota.id_prota.y)<350))
                    temp=collision(type normal_shot);
                    if (temp)
                        temp.energia=0;
                    end
                end
            
            
                //impacto con el prota
                if ((abs(x-info_prota.id_prota.x)<50) && (abs(y-info_prota.id_prota.y)<50))
                    if (collision(info_prota.id_prota))
                        info_prota.dano_id=id;
                        info_prota.dano_energia=2;
                        info_prota.dano_exp=2;
                        if (info_prota.id_prota.x2>x2) info_prota.dano_vel_horiz=30;
                        else info_prota.dano_vel_horiz=-30;
                        end
                    end
                end
            end
            
        end
        
        x2=x3/resolution3;
        y2=y3/resolution3;
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        frame;
    end
end
