process logos ()
private
    int temp;
    int cont;
begin
    fade(0,0,0,255);
    frame;
    
    temp=load_png("grafs/gph.png");
    put_screen(0,temp);
    fade(100,100,100,3);
    while (fading) frame; end
    for (cont=0;cont<150;cont++)
        if ((teclas[k_enter][2]==1)  || (teclas[k_fire][2]==1))
            if (file_exists("game.sav")) break; end
        end
        frame;
    end
    fade(0,0,0,3);
    while (fading) frame; end
    unload_map(0,temp);
    
    temp=load_png("grafs/bennugd.png");
    put_screen(0,temp);
    fade(100,100,100,3);
    while (fading) frame; end
    for (cont=0;cont<150;cont++)
        if ((teclas[k_enter][2]==1)  || (teclas[k_fire][2]==1))
            if (file_exists("game.sav")) break; end
        end
        frame;
    end
    fade(0,0,0,3);
    while (fading) frame; end
    unload_map(0,temp);
    
    temp=load_png("grafs/jpc.png");
    put_screen(0,temp);
    fade(100,100,100,3);
    while (fading) frame; end
    for (cont=0;cont<150;cont++)
        if ((teclas[k_enter][2]==1)  || (teclas[k_fire][2]==1))
            if (file_exists("game.sav")) break; end
        end
        frame;
    end
    fade(0,0,0,3);
    while (fading) frame; end
    unload_map(0,temp);
    
    signal(father,s_wakeup);
end

//************************************************************************************
//      MENU PRINCIPAL
//************************************************************************************

process portada_img (file,graph,x,y,z)
begin
    signal(id,s_freeze);
    frame;
end

process portada_flecha1 (file,graph2,x2,y2)
private
    int angle2;
begin
    x=60;
    y=200;
    graph=graph2;
    loop
        angle2+=8000;
        x=x2-14*sin(angle2);
        frame;
    end
end

process portada_flecha2 (file,graph2,x2,y2)
private
    int angle2;
begin
    x=260;
    y=200;
    graph=graph2;
    loop
        angle2+=8000;
        x=x2+14*sin(angle2);
        frame;
    end
end

process portada ()
private
    int port_let;
    int port_opt_id;
    int port_menu;
    
    int vel_vert;
    int vel_rebote;
    
    int opt_mask[4]=true,false,false,false,true;
    //int opt_mask[4]=true,true,true,true,true;
    int opt_select;
    
    int portada_flecha[1];
    
    int portada_salir;
    
    int cont;
begin
    enem_grafs[0][cte_event]=load_fpg("grafs/mmenu.fpg");
    enem_grafs[1][cte_event]=true;
    put_screen(enem_grafs[0][cte_event],1);
    set_fps(25,cte_frameskip);
    level_song=50;
    fade(100,100,100,1);
    while (fading) frame; end
    set_fps(50,cte_frameskip);
    frame(10000);
    
    port_let=portada_img(enem_grafs[0][cte_event],2,1600,-150,0);
    port_let.resolution=10;
    vel_vert=80;
    vel_rebote=80;
    while (vel_rebote>10)
        vel_vert+=2;
        if (vel_vert>60) vel_vert=60; end
        port_let.y+=vel_vert;
        if ((port_let.y>=1650) && (vel_vert>0))
            vel_rebote>>=1;
            vel_vert=-vel_rebote;
        end
        frame;
    end
    
    refresh_savegame_exists_file();
    //say(opt_mask[1]);
    /*for (cont=1;cont<=max_savefiles;cont++)
        say("fichero busqueda: save/data0"+itoa(cont)+".sav "+file_exists("save/data0"+itoa(cont)+".sav"));
        opt_mask[1]=opt_mask[1] || file_exists("save/data0"+itoa(cont)+".sav");
        say(opt_mask[1]);
    end*/
    //for (cont=1;cont<=max_savefiles;cont++) say(glob("save/*.*")); end
    opt_mask[1]=false;
    for (cont=0;cont<max_savefiles;cont++)
        opt_mask[1]=opt_mask[1] || savegame_exists_file[cont];
        //say(opt_mask[1]);
    end
    
    define_region(2,75,190,170,20);
    port_opt_id=portada_img(enem_grafs[0][cte_event],3,340,200,0);
    port_opt_id.region=2;
    
    while (port_opt_id.x>160)
        port_opt_id.x-=4;
        frame;
    end
    portada_flecha[0]=portada_flecha1(enem_grafs[0][cte_event],10,60,200);
    portada_flecha[1]=portada_flecha2(enem_grafs[0][cte_event],11,260,200);
    portada_flecha[0].graph=0;
    
    portada_salir=false;
    prota_control=true;
    repeat
        while (teclas[k_enter][2]==1) frame; end    //compas de espera a que se suelte el botn
        
        while (teclas[k_enter][2]!=1)
            if ((teclas[k_right][2]==1) && (opt_select<4))
                //while (port_opt_id.x>-20)
                while (port_opt_id.x>0)
                    port_opt_id.x-=5;
                    frame;
                end
                repeat
                    if (opt_select==4) opt_select=0; else opt_select++; end
                until (opt_mask[opt_select])
                //port_opt_id.x=340;
                port_opt_id.x=320;
                port_opt_id.graph=opt_select+3;
                if (opt_select==0) portada_flecha[0].graph=0; else portada_flecha[0].graph=10; end
                if (opt_select==4) portada_flecha[1].graph=0; else portada_flecha[1].graph=11; end
                while (port_opt_id.x>160)
                    port_opt_id.x-=5;
                    frame;
                end
            end
            if ((teclas[k_left][2]==1) && (opt_select>0))
                //while (port_opt_id.x<340)
                while (port_opt_id.x<320)
                    port_opt_id.x+=5;
                    frame;
                end
                repeat
                    if (opt_select==0) opt_select=4; else opt_select--; end
                until (opt_mask[opt_select])
                //port_opt_id.x=-20;
                port_opt_id.x=0;
                port_opt_id.graph=opt_select+3;
                if (opt_select==0) portada_flecha[0].graph=0; else portada_flecha[0].graph=10; end
                if (opt_select==4) portada_flecha[1].graph=0; else portada_flecha[1].graph=11; end
                while (port_opt_id.x<160)
                    port_opt_id.x+=5;
                    frame;
                end
            end
            frame;
        end
        
        switch (opt_select)
        case 0:
            signal(portada_flecha[0],s_freeze);
            signal(portada_flecha[1],s_freeze);
            
            graph=new_map(320,240,16);
            map_clear(file,graph,1);
            x=160;
            y=120;
            z=-99;
            for (alpha=0;alpha<100;alpha+=5) frame; end
            
            global_opt=0;
            port_menu=global_menu(0,2,"Easy (5 lives)","Medium (3 lives)","Hard (1 live)","","");
            while (exists(port_menu)) frame; end
            
            switch (global_opt)
            case 0: info_prota.vidas=5; end
            case 1: info_prota.vidas=3; end
            case 2: info_prota.vidas=1; end
            end //switch
            
            dificultad=global_opt;
            
            //say("preparando menu de carga");
            while (teclas[k_enter][2]==1) frame; end
            port_menu=select_file_menu(max_savefiles,false);
            while (exists(port_menu)) frame; end
            //say("fin menu carga");
            
            
            set_fps(20,cte_frameskip);
            level_song=0;
            fade(0,0,0,1);
            while (fading) frame; end
            unload_map(file,graph);
            set_fps(50,cte_frameskip);
            
            //inicializacion de datos
            load_default_gamedata(&game_global_sav,dificultad,info_prota.vidas);
            //load_filegame(&game_global_sav,3);
            load_actual_gamedata(&game_global_sav);
            //save_filegame(&game_global_sav,1);
            //armas_get[0]=true;
            //armas_get[1]=false;
            //armas_get[2]=false;
            //armas_get[3]=false;
            //init_level=0;
            //next_level=1;
            //next_sublevel=0;
            armas_select=0;
            portada_salir=true;
            
            global_mode=3;
        end
        case 1:
            signal(portada_flecha[0],s_freeze);
            signal(portada_flecha[1],s_freeze);
            
            graph=new_map(320,240,16);
            map_clear(file,graph,1);
            x=160;
            y=120;
            z=-99;
            for (alpha=0;alpha<100;alpha+=5) frame; end
            
            //say("preparando menu de carga");
            while (teclas[k_enter][2]==1) frame; end
            port_menu=select_file_menu(6,true);
            while (exists(port_menu)) frame; end
            //say("fin menu carga");
            
            if (global_opt!=0)
                
                set_fps(20,cte_frameskip);
                level_song=0;
                fade(0,0,0,1);
                while (fading) frame; end
                unload_map(file,graph);
                set_fps(50,cte_frameskip);
                
                //load_default_gamedata(&game_global_sav,dificultad,info_prota.vidas);
                load_filegame(&game_global_sav,savegame_pos);
                load_actual_gamedata(&game_global_sav);
                
                armas_select=0;
                portada_salir=true;
                global_mode=3;
            else
                for (alpha=100;alpha>0;alpha-=5) frame; end
                unload_map(file,graph);
                
                signal(portada_flecha[0],s_wakeup);
                signal(portada_flecha[1],s_wakeup);
            end
        end
        case 4:
            signal(portada_flecha[0],s_freeze);
            signal(portada_flecha[1],s_freeze);
            
            set_fps(20,cte_frameskip);
            level_song=0;
            fade(0,0,0,1);
            while (fading) frame; end
            portada_salir=true;
            global_mode=100;
        end
        end //switch
    until (portada_salir)
    //loop frame; end
    
    clear_screen();
    if (exists(port_opt_id)) signal(port_opt_id,s_kill); end
    if (exists(port_let)) signal(port_let,s_kill); end
    if (exists(portada_flecha[0])) signal(portada_flecha[0],s_kill); end
    if (exists(portada_flecha[1])) signal(portada_flecha[1],s_kill); end
    unload_fpg(enem_grafs[0][cte_event]);
    enem_grafs[1][cte_event]=true;
    signal(father,s_wakeup);
end

//************************************************************************************
//      CRDITOS
//************************************************************************************

process credits_img (x2,y,file,graph,alpha)
private
    int cont;
begin
    x=-320;
    cont=0;
    while (x<x2)
        x+=10;
        cont++;
        if ((cont==8) && (alpha>=150))
            credits_img(x2,y,file,graph,alpha-50);
        end
        frame;
    end
    frame(20000);
    while (x<330)
        x+=10;
        frame;
    end
end

process credits ()
private
    int temp;
begin
    enem_grafs[0][cte_event]=load_fpg("grafs/names.fpg");
    enem_grafs[1][cte_event]=true;
    
    clear_screen();
    fade(100,100,100,255);
    frame;
    
    //musica
    level_song=107;
    
    frame(20000);
    //dirigido por
    credits_img(30,100,enem_grafs[0][cte_event],1,255);
    frame(2500);
    temp=credits_img(20,140,enem_grafs[0][cte_event],9,255);
    while (exists(temp)) frame; end
    
    //programado por
    credits_img(30,100,enem_grafs[0][cte_event],2,255);
    frame(2500);
    temp=credits_img(20,140,enem_grafs[0][cte_event],9,255);
    while (exists(temp)) frame; end
    
    //musica por
    credits_img(30,100,enem_grafs[0][cte_event],3,255);
    frame(2500);
    temp=credits_img(20,140,enem_grafs[0][cte_event],10,255);
    while (exists(temp)) frame; end
    
    //efectos sonoros
    credits_img(30,100,enem_grafs[0][cte_event],4,255);
    frame(2500);
    credits_img(20,140,enem_grafs[0][cte_event],10,255);
    frame(1000);
    temp=credits_img(20,170,enem_grafs[0][cte_event],9,255);
    while (exists(temp)) frame; end
    
    //grficos por
    credits_img(30,100,enem_grafs[0][cte_event],5,255);
    frame(2500);
    temp=credits_img(20,140,enem_grafs[0][cte_event],9,255);
    while (exists(temp)) frame; end
    
    //diseo de niveles
    credits_img(30,100,enem_grafs[0][cte_event],6,255);
    frame(2500);
    temp=credits_img(20,140,enem_grafs[0][cte_event],9,255);
    while (exists(temp)) frame; end
    
    //programacin adicional
    credits_img(30,80,enem_grafs[0][cte_event],7,255);
    frame(2500);
    credits_img(20,120,enem_grafs[0][cte_event],11,255);
    frame(1000);
    credits_img(20,150,enem_grafs[0][cte_event],12,255);
    frame(1000);
    credits_img(20,180,enem_grafs[0][cte_event],13,255);
    frame(1000);
    temp=credits_img(20,210,enem_grafs[0][cte_event],14,255);
    while (exists(temp)) frame; end
    
    //gracias
    credits_img(30,80,enem_grafs[0][cte_event],8,255);
    frame(2500);
    credits_img(20,120,enem_grafs[0][cte_event],15,255);
    frame(1000);
    credits_img(20,150,enem_grafs[0][cte_event],14,255);
    frame(1000);
    credits_img(20,180,enem_grafs[0][cte_event],13,255);
    frame(1000);
    temp=credits_img(20,210,enem_grafs[0][cte_event],10,255);
    while (exists(temp)) frame; end
    
    //gracias
    credits_img(30,80,enem_grafs[0][cte_event],8,255);
    frame(2500);
    credits_img(20,120,enem_grafs[0][cte_event],12,255);
    frame(1000);
    credits_img(20,150,enem_grafs[0][cte_event],11,255);
    frame(1000);
    credits_img(20,180,enem_grafs[0][cte_event],16,255);
    frame(1000);
    temp=credits_img(20,210,enem_grafs[0][cte_event],17,255);
    while (exists(temp)) frame; end
    
    //final
    frame(10000);
    temp=portada_img(enem_grafs[0][cte_event],18,160,120,0);
    temp.alpha=0;
    //alpha_steps=64;
    for (temp.alpha=0;temp.alpha<255;temp.alpha++) frame; end
    //alpha_steps=16;
    frame(10000);
    
    put_screen(enem_grafs[0][cte_event],18);
    temp.resolution=10;
    temp.x*=10;
    temp.y*=10;
    //temp.flags=128;
    temp.graph=0;
    while (temp.size>25)
        temp.size--;
        temp.x+=(2700-temp.x)/75;
        temp.y+=(500-temp.y)/75;
        frame;
    end
    
    
    //debug
    frame(10000);
    
    set_fps(20,cte_frameskip);
    fade(0,0,0,1);
    while (fading) frame; end
    clear_screen();
    if (exists(temp)) signal(temp,s_kill); end
    set_fps(50,cte_frameskip);
    
    prota_control=1;
    unload_fpg(enem_grafs[0][cte_event]);
    enem_grafs[1][cte_event]=false;
    global_mode=0;
    signal(father,s_wakeup);
    frame;
end
