process prota_moto (x2,y2)
private
    //posicin
    int x3;             //temporal, aade resolucin
    int y3;             //temporal, aade resolucin
    
    int resolution3;    //define el tamao de cada pixel (evitar decimales)
    //variables temporales
    int temp_desp;      //indica hasta donde se desplazar el personaje
    int p_libre;        //indica si se puede avanzar en esa direccin (comprobacin de movimiento)
begin
    priority=-99;
    write_int(0,10,10,0,&p_dur[0][0]);
    write_int(0,10,20,0,&p_dur[0][1]);
    write_int(0,10,30,0,&p_dur[0][2]);
    write_int(0,30,10,0,&p_dur[1][0]);
    write_int(0,30,20,0,&p_dur[1][1]);
    write_int(0,30,30,0,&p_dur[1][2]);
    write_int(0,50,10,0,&p_dur[2][0]);
    write_int(0,50,20,0,&p_dur[2][1]);
    write_int(0,50,30,0,&p_dur[2][2]);

    write_int(0,100,10,0,&info_prota.vel_horiz);
    write_int(0,100,20,0,&info_prota.vel_vert);
    write_int(0,100,35,0,&p_dir);
    
    write_int(0,150,10,0,&info_prota.p_offsx);
    write_int(0,150,20,0,&info_prota.p_offsy);
    write_int(0,150,35,0,&info_prota.estado);
    
    write_int(0,200,10,0,&teclas[k_jump][2]);
    
    graph=1;
    //z=-100;
    z=1;
    
    //x3=100;
    //y3=1150;
    id_tscroll.camera_x=x2*id_tscroll.tmapa[0].ancho_tile;
    id_tscroll.camera_y=y2*id_tscroll.tmapa[0].alto_tile;
    
    info_prota.id_prota=id;
    resolution3=10;
    x3=id_tscroll.camera_x*resolution3;
    y3=id_tscroll.camera_y*resolution3;
    
    loop
        //esto es por si movemos al personaje externamente
        //x3=x2;
        //y3=y2;
        //say("frame");
        //localizamos la posicin actual
        info_prota.p_tilex= (x3/resolution3)/id_tscroll.tmapa[0].ancho_tile;
        info_prota.p_tiley= (y3/resolution3)/id_tscroll.tmapa[0].alto_tile;
        info_prota.p_offsx= (x3/resolution3)%id_tscroll.tmapa[0].ancho_tile;
        info_prota.p_offsy= (y3/resolution3)%id_tscroll.tmapa[0].alto_tile;
        //leemos durezas de su alrededor
        p_dur[0][0]=obtener_tile(&durezas,info_prota.p_tilex-1,info_prota.p_tiley-1,0);
        p_dur[1][0]=obtener_tile(&durezas,info_prota.p_tilex  ,info_prota.p_tiley-1,0);
        p_dur[2][0]=obtener_tile(&durezas,info_prota.p_tilex+1,info_prota.p_tiley-1,0);
        p_dur[0][1]=obtener_tile(&durezas,info_prota.p_tilex-1,info_prota.p_tiley  ,0);
        p_dur[1][1]=obtener_tile(&durezas,info_prota.p_tilex  ,info_prota.p_tiley  ,0);
        p_dur[2][1]=obtener_tile(&durezas,info_prota.p_tilex+1,info_prota.p_tiley  ,0);
        p_dur[0][2]=obtener_tile(&durezas,info_prota.p_tilex-1,info_prota.p_tiley+1,0);
        p_dur[1][2]=obtener_tile(&durezas,info_prota.p_tilex  ,info_prota.p_tiley+1,0);
        p_dur[2][2]=obtener_tile(&durezas,info_prota.p_tilex+1,info_prota.p_tiley+1,0);
        
        //reconocimiento de teclas
        //movimiento lateral
        if (teclas[k_right][2]>0)
            info_prota.vel_horiz+=cte_moto_acelerac;
            if (info_prota.vel_horiz>cte_moto_max_vel) info_prota.vel_horiz=cte_moto_max_vel; end
            //info_prota.vel_horiz=info_prota.vel_horiz;
        elsif (teclas[k_left][2]>0)
            info_prota.vel_horiz-=cte_moto_acelerac;
            if (info_prota.vel_horiz<-cte_moto_max_vel) info_prota.vel_horiz=-cte_moto_max_vel; end
            //info_prota.vel_horiz=info_prota.vel_horiz;
        else
            if (info_prota.vel_horiz>0)
                if (info_prota.vel_horiz<cte_moto_acelerac)
                    info_prota.vel_horiz=0;
                else
                    info_prota.vel_horiz-=cte_moto_acelerac;
                end
            elsif (info_prota.vel_horiz<0)
                if (info_prota.vel_horiz>-cte_moto_acelerac)
                    info_prota.vel_horiz=0;
                else
                    info_prota.vel_horiz+=cte_moto_acelerac;
                end
            end
        end
        //info_prota.vel_horiz=var_vel;
        //salto
        //test
        /*if (teclas[k_jump][2]==1)
            say("Estado: "+itoa(info_prota.estado)+" Cont salto: "+itoa(cont_salto));
            graph++;
            if (graph>4) graph=1; end
        end*/
        //say(teclas[k_jump][2]==1);
        
        switch (info_prota.estado)
        case 0,1:   //parado o andando
            if (teclas[k_jump][2]==1)       //si apretamos salto
                info_prota.estado=2;
                cont_salto=0;
                info_prota.vel_vert=-cte_moto_salto;        
            else                            //gravedad normal (quitar para debug)****************
                info_prota.estado=3;
                info_prota.vel_vert+=cte_moto_gravedad;
            end
        end
        case 2:     //saltando
            if (teclas[k_jump][2]>0)
                cont_salto++;
                if (cont_salto>=cte_moto_max_salto)
                    info_prota.estado=3;
                    info_prota.vel_vert+=cte_moto_gravedad;
                    cont_salto=0;
                else
                    info_prota.vel_vert=-cte_moto_salto;
                end
            else
                info_prota.estado=3;
                info_prota.vel_vert+=cte_moto_gravedad;
            end
        end
        case 3:     //cayendo
            info_prota.vel_vert+=cte_moto_gravedad;
            if (info_prota.vel_vert>cte_moto_max_gravedad) info_prota.vel_vert=cte_moto_max_gravedad; end
            if (teclas[k_down][2]>0) info_prota.vel_vert=0; info_prota.estado=0; end
        end
        end //switch
        
        //MOVIMIENTO ***********************************
        //Comprobamos cambio de tile
        /*p_dir=5;
        temp_desp=(info_prota.p_offsx*resolution3)+var_vel;
        if (temp_desp> (id_tscroll.tmapa[0].ancho_tile*resolution3)) p_dir++; end
        if (temp_desp< 0) p_dir--; end
        temp_desp=(info_prota.p_offsy*resolution3)+info_prota.vel_vert;
        if (temp_desp> (id_tscroll.tmapa[0].alto_tile*resolution3)) p_dir-=3; end
        if (temp_desp< 0) p_dir+=3; end*/
        //comprobamos si cambiamos de tile y en que direccion
        //***************************************************************
        info_prota.p_mover_h=0;
        if (((x3+info_prota.vel_horiz)/(id_tscroll.tmapa[0].ancho_tile*resolution3))!=info_prota.p_tilex)
           //comprobamos si pasamos a otro tile lateral y cuan lejos esta
           info_prota.p_mover_h=((x3+info_prota.vel_horiz)/(id_tscroll.tmapa[0].ancho_tile*resolution3))
                                -info_prota.p_tilex;
        end
        //write(0,630,10,2,p_mover_h);
        info_prota.p_mover_v=0;
        if (((y3+info_prota.vel_vert)/(id_tscroll.tmapa[0].alto_tile*resolution3))!=info_prota.p_tiley)
           //comprobamos si pasamos a otro tile vertical y cuan lejos esta
           info_prota.p_mover_v=((y3+info_prota.vel_vert)/(id_tscroll.tmapa[0].alto_tile*resolution3))
                                -info_prota.p_tiley;
        end
         //miramos en que direccion cambiamos
        p_dir=5;
        if (info_prota.p_mover_h>0) p_dir++; end
        if (info_prota.p_mover_h<0) p_dir--; end
        if (info_prota.p_mover_v>0) p_dir-=3; end      //hacia abajo
        if (info_prota.p_mover_v<0) p_dir+=3; end      //hacia arriba
        p_dir_ini=p_dir;
        
        //OJO CON LA RAMPAS TRASPASABLES, PONER CASILLA A CERO SI ESTAMOS**********temporalmente disabled
        //EN EL SUELO
        /*if ((p_dur[1][1]==27 || p_dur[1][1]==77) &&
           (info_prota.p_rely>((id_tscroll.tmapa[0].alto_tile-1)*resolution3)-info_prota.p_relx))
           p_dur[1][1]=0;
        end
        if ((p_dur[1][1]==30 || p_dur[1][1]==80) &&
           (info_prota.p_rely>((id_tscroll.tmapa[0].alto_tile-1)*resolution3)-(info_prota.p_relx/2)))
           p_dur[1][1]=0;
        end
        if ((p_dur[1][3]==31 || p_dur[1][3]==81) &&
           (info_prota.p_rely>(((id_tscroll.tmapa[0].alto_tile/2)-1)*resolution3)-(info_prota.p_relx/2)))
           p_dur[1][1]=0;
        end
        if ((p_dur[1][1]==26 || p_dur[1][1]==76) && info_prota.p_rely>info_prota.p_relx)
           p_dur[1][1]=0;
        end
        if ((p_dur[1][1]==28 || p_dur[1][1]==78) &&
           ((info_prota.p_rely>((id_tscroll.tmapa[0].alto_tile/2)-1)*resolution3)+info_prota.p_relx/2))
           p_dur[1][1]=0;
        end
        if ((p_dur[1][1]==29 || p_dur[1][1]==79) && info_prota.p_rely>info_prota.p_relx/2)
           p_dur[1][1]=0;
        end*/
        
        
                //Comprobamos si hay cambio
        if (info_prota.vel_horiz>0)  //movimiento a la derecha
        
            if (p_dir==3) //movim diagonal hacia abajo          //ARREGLAR: SE COME LAS ESQUINAS (DEBE DESPLAZARSE
                //say("p_dir=3");
                switch (p_dur[2][2])                            //MS ANTES DE CAER
                //casos en los que no se puede descender
                case 1,4,5,25,51,54,55,75,  //normales
                     105:                   //especiales (extra)
                    p_dir=6;
                    //info_prota.vel_vert=(15-info_prota.p_offsy)*resolution3;
                end
                //casos en los que SI
                default:
                    //comprobamos si el que hay a la derecha nos deja avanzar
                    switch (p_dur[2][1])
                    //casos en los que si se puede avanzar
                    case 0,4,25,50,54,75,                   //normales
                         26,28,29,32,34,76,78,79,82,84,     //extras
                         100,104,105,                       //especiales (extra)
                         150..255:                          //otras
                        p_libre=1;
                    end
                    //casos en los que, aunque libre, e avanza en otra dir
                    case 3,15,53,65,                        //normales
                         27,30,77,80:                       //extras
                        p_libre=2;
                    end
                    //casos en que no
                    default: p_libre=0; end
                    end //switch
                    
                    //ahora, p_libre indica
                    //0: no se puede avanzar.
                    //1: se puede avanzar.
                    //2: hay una rampa a la misma altura
                    switch (p_libre)
                    //no se puede avanzar
                    case 0:
                        info_prota.p_mover_h=0;
                        info_prota.vel_horiz=0;
                        x3+=(11-info_prota.p_offsx)*resolution3;
                        p_dir=2;
                    end
                    //si se puede
                    case 1:
                        info_prota.p_mover_v--;
                        info_prota.p_mover_h--;
                        //si el tile diagonal esta vacio podemos caer*******************************
                        switch (p_dur[2][2])
                        case 0,3,13,15,16,50,53,63,65,66,               //normales
                             27,28,30,31,32,33,34,77,78,80,81,82,83,84, //extras
                             100,104,                                   //especiales (extra)
                             150..255:                                  //otras
                            
                            //todo listo para caer... pero no si estamos sobre el borde de una caida
                            switch (p_dur[1][2])
                            case 1,3,4,5,16,25,51,53,54,55,66,75,       //normales
                                 27,31,77,81,                           //extras
                                 105:                                   //especiales (extra)
                                
                                //say("estamos a "+itoa((info_prota.p_offsx*resolution3)+info_prota.vel_horiz));
                                if (((info_prota.p_offsx*resolution3)+info_prota.vel_horiz) <= 
                                    ((15+4)*resolution3))
                                    
                                    //no podemos caer aun
                                    p_dir=6;
                                else
                                    //si podemos caer
                                    info_prota.estado=3;
                                    //actualizamos los tiles
                                    p_dur[0][0]=p_dur[1][1];
                                    p_dur[0][1]=p_dur[1][2];
                                    p_dur[0][2]=obtener_tile(&durezas,info_prota.p_tilex  ,info_prota.p_tiley+2,0);
                                    p_dur[1][0]=p_dur[2][1];
                                    p_dur[1][1]=p_dur[2][2];
                                    p_dur[1][2]=obtener_tile(&durezas,info_prota.p_tilex+1,info_prota.p_tiley+2,0);
                                    p_dur[2][0]=obtener_tile(&durezas,info_prota.p_tilex+2,info_prota.p_tiley  ,0);
                                    p_dur[2][1]=obtener_tile(&durezas,info_prota.p_tilex+2,info_prota.p_tiley+1,0);
                                    p_dur[2][2]=obtener_tile(&durezas,info_prota.p_tilex+2,info_prota.p_tiley+2,0);
                                end //if al borde
                            end
                            default:
                                info_prota.estado=3;
                                //actualizamos los tiles
                                p_dur[0][0]=p_dur[1][1];
                                p_dur[0][1]=p_dur[1][2];
                                p_dur[0][2]=obtener_tile(&durezas,info_prota.p_tilex  ,info_prota.p_tiley+2,0);
                                p_dur[1][0]=p_dur[2][1];
                                p_dur[1][1]=p_dur[2][2];
                                p_dur[1][2]=obtener_tile(&durezas,info_prota.p_tilex+1,info_prota.p_tiley+2,0);
                                p_dur[2][0]=obtener_tile(&durezas,info_prota.p_tilex+2,info_prota.p_tiley  ,0);
                                p_dur[2][1]=obtener_tile(&durezas,info_prota.p_tilex+2,info_prota.p_tiley+1,0);
                                p_dur[2][2]=obtener_tile(&durezas,info_prota.p_tilex+2,info_prota.p_tiley+2,0);
                            end
                            end //switch suelo
                        end
                        case 2,52:
                             //rampa: nos movemos y perdemos toda la velocidad, con esto se acaba el movimiento
                             //esto es mejor, ponemos una velocidad de la gravedad superior para traspasar la rampa, y luego nos recolocaremos
                             if (info_prota.estado!=2)
                                /*vel_vert=(info_prota.p_offsx*resolution3)+info_prota.vel_horiz-
                                            (id_tscroll.tmapa[0].ancho_tile*resolution3);*/
                                info_prota.vel_vert=info_prota.vel_horiz;
                             end
                             //actualizamos los tiles
                            p_dur[0][0]=p_dur[1][1];
                            p_dur[0][1]=p_dur[1][2];
                            p_dur[0][2]=obtener_tile(&durezas,info_prota.p_tilex  ,info_prota.p_tiley+2,0);
                            p_dur[1][0]=p_dur[2][1];
                            p_dur[1][1]=p_dur[2][2];
                            p_dur[1][2]=obtener_tile(&durezas,info_prota.p_tilex+1,info_prota.p_tiley+2,0);
                            p_dur[2][0]=obtener_tile(&durezas,info_prota.p_tilex+2,info_prota.p_tiley  ,0);
                            p_dur[2][1]=obtener_tile(&durezas,info_prota.p_tilex+2,info_prota.p_tiley+1,0);
                            p_dur[2][2]=obtener_tile(&durezas,info_prota.p_tilex+2,info_prota.p_tiley+2,0);
                        end
                        end
                        //actualizamos casilla actual
                        //lo hemos hecho antes, hay un caso especial que contemplar
                        
                    end
                    //hay una rampa
                    case 2:
                        p_dir=6;
                    end
                    end //switch
                end
                end //switch
            end //movimiento diagonal******
            
            if (p_dir==6)   //movimiento lateral
                //say("p_dir=6");
                
                switch (p_dur[2][1])
                //si permite el paso normal
                case 0,3,4,15,25,50,53,54,65,75,    //normales
                     26..32,34,76..82,84,           //extras
                     100,104,105,                   //especiales (extras)
                     150..255:                      //otras
                    //comprobamos la casilla actual, podramos estar en una rampa ascendente y dejarnos en
                    //un tile superior en lugar del tile de al lado
                    
                    switch (p_dur[1][1])
                    
                    //estamos en rampa o media rampa superior
                    case 3,16,53,66,                //normales
                         27,31,77,81:               //extras
                        //comprobamos el techo derecho. Aqui pueden pasar tres cosas que almacenaremos en p_libre
                        //0: No se permite el paso
                        //1: Se permite el paso, nos movemos lateralmente
                        //2: Se permite el paso PERO un tile nos obliga a permanecer en el superior
                        switch (p_dur[2][0])
                        //parte superior libre
                        case 0,25,50,75,                            //normales
                             26,28,29,31,32,34,76,78,79,81,82,84,   //extras
                             100,104,105,                           //especiales (extras)
                             150..255:                              //otras
                            p_libre=1;
                        end
                        //caso especial, hay una rampa que obliga a ir diagonal
                        case 3,15,53,65,            //normales
                             27,30,77,80:           //extras
                            p_libre=2;
                        end
                        //parte superior ocupada
                        default:
                            p_libre=0;
                        end
                        end //switch comprobando sig techo
                        
                        //caso especial: la siguiente casilla permite atravesarse en todas direcciones menos
                        //               hacia abajo
                        switch (p_dur[2][1])
                        case 25,75,105:             //extras
                            p_libre=2;
                        end
                        end //switch, caso especial tile derecho
                        //caso especial: no nos hemos movido lo suficiente a la derecha para caernos, nos
                        //               sujeta la esquina del grfico.
                        if ( ((x3+info_prota.vel_horiz) % (id_tscroll.tmapa[0].ancho_tile*resolution3)) < 
                             (4*resolution3) )
                            p_libre=2;
                        end
                        
                        //Y ACTUAMOS SEGUN ESTE MOVIMIENTO
                        switch (p_libre)
                        //no se puede avanzar
                        case 0:
                            info_prota.p_mover_h=0;
                            info_prota.vel_horiz=0;
                            x3+=(11-info_prota.p_offsx)*resolution3;
                        end
                        //si se puede avanzar
                        case 1:
                            info_prota.p_mover_h--;
         //prueba rara
                            info_prota.vel_vert-=((15-info_prota.p_offsx)*resolution3); //quitamos tanta velocidad 
                                                                                        //como pixels por subir
                            info_prota.estado=3;
                            //actualizamos casilla actual
                            p_dur[0][0]=p_dur[1][0];
                            p_dur[0][1]=p_dur[1][1];
                            p_dur[0][2]=p_dur[1][2];
                            p_dur[1][0]=p_dur[2][0];
                            p_dur[1][1]=p_dur[2][1];
                            p_dur[1][2]=p_dur[2][2];
                            p_dur[2][0]=obtener_tile(&durezas,info_prota.p_tilex+2,info_prota.p_tiley-1,0);
                            p_dur[2][1]=obtener_tile(&durezas,info_prota.p_tilex+2,info_prota.p_tiley  ,0);
                            p_dur[2][2]=obtener_tile(&durezas,info_prota.p_tilex+2,info_prota.p_tiley+1,0);
                        end
                        //se avanza, pero se sube al mismo tiempo
                        case 2:
                            info_prota.p_mover_h--;
                            info_prota.p_mover_v--;
         //prueba rara
                            info_prota.vel_vert-=(info_prota.p_offsy*resolution3)+10;
                            //actualizamos casilla actual
                            p_dur[0][0]=obtener_tile(&durezas,info_prota.p_tilex  ,info_prota.p_tiley-2,0);
                            p_dur[0][1]=p_dur[1][0];
                            p_dur[0][2]=p_dur[1][1];
                            p_dur[1][0]=obtener_tile(&durezas,info_prota.p_tilex+1,info_prota.p_tiley-2,0);
                            p_dur[1][1]=p_dur[2][0];
                            p_dur[1][2]=p_dur[2][1];
                            p_dur[2][0]=obtener_tile(&durezas,info_prota.p_tilex+2,info_prota.p_tiley-2,0);
                            p_dur[2][1]=obtener_tile(&durezas,info_prota.p_tilex+2,info_prota.p_tiley-1,0);
                            p_dur[2][2]=obtener_tile(&durezas,info_prota.p_tilex+2,info_prota.p_tiley  ,0);
                            //si avanzamos hasta rampa traspasable invertida, la atravesamos (la ponemos a cero)
                            switch (p_dur[1][1])
                            case 26,28,29,31,76,78,79,81:           //extras
                                p_dur[1][1]=0;
                            end
                            end //switch
                        end
                        end //switch direccin final de movimiento
                        
                    end //case rampa o media rampa superior
                    
                    //estamos en media rampa inferior
                    case 15,30,65,80:
                        //comprobamos si el techo nos deja avanzar
                        switch (p_dur[2][0])
                        //Si se puede
                        case 0,25,50,75,                    //normal (he eliminado las rampas de techo)
                             26..32,34,76..82,84,           //extras
                             100,104,105,                   //especiales (extras)
                             150..255:                      //otras
                            p_libre=1;
                        end
                        default:
                            p_libre=0;
                        end
                        end //switch comprobando sig techo
                        
                        //actuamos en consecuencia
                        switch (p_libre)
                        //no se puede
                        case 0:
                            info_prota.p_mover_h=0;
                            info_prota.vel_horiz=0;
                            x3+=(11-info_prota.p_offsx)*resolution3;
                            //no hay que actualizar casilla actual
                        end
                        //si se puede
                        case 1:
                            info_prota.p_mover_h--;
         //prueba rara
                            info_prota.vel_vert-=(info_prota.p_offsy-(id_tscroll.tmapa[0].ancho_tile/2));
                            //actualizamos casilla actual
                            p_dur[0][0]=p_dur[1][0];
                            p_dur[0][1]=p_dur[1][1];
                            p_dur[0][2]=p_dur[1][2];
                            p_dur[1][0]=p_dur[2][0];
                            p_dur[1][1]=p_dur[2][1];
                            p_dur[1][2]=p_dur[2][2];
                            p_dur[2][0]=obtener_tile(&durezas,info_prota.p_tilex+2,info_prota.p_tiley-1,0);
                            p_dur[2][1]=obtener_tile(&durezas,info_prota.p_tilex+2,info_prota.p_tiley  ,0);
                            p_dur[2][2]=obtener_tile(&durezas,info_prota.p_tilex+2,info_prota.p_tiley+1,0);
                            //si avanzamos hasta rampa traspasable invertida, la atravesamos (la ponemos a cero)
                            switch (p_dur[1][1])
                            case 26,29,76,79:           //extras
                                p_dur[1][1]=0;
                            end
                            end //switch
                        end
                        end
                    end //case media rampa inferior
                    
                    //estamos en media rampa superior descendente
                    case 14,29,64,79:
                        //comprobamos si el techo nos deja avanzar
                        switch (p_dur[2][0])
                        //Si se puede
                        case 0,25,50,75,                    //normal (he eliminado las rampas de techo)
                             26..32,34,76..82,84,           //extras
                             100,104,105,                   //especiales (extras)
                             150..255:                      //otras
                            p_libre=1;
                        end
                        default:
                            p_libre=0;
                        end
                        end //switch comprobando sig techo
                        
                        //actuamos en consecuencia
                        switch (p_libre)
                        //no se puede
                        case 0:
                            info_prota.p_mover_h=0;
                            info_prota.vel_horiz=0;
                            x3+=(11-info_prota.p_offsx)*resolution3;
                            //no hay que actualizar casilla actual
                        end
                        //si se puede
                        case 1:
                            info_prota.p_mover_h--;
                            //actualizamos casilla actual
                            p_dur[0][0]=p_dur[1][0];
                            p_dur[0][1]=p_dur[1][1];
                            p_dur[0][2]=p_dur[1][2];
                            p_dur[1][0]=p_dur[2][0];
                            p_dur[1][1]=p_dur[2][1];
                            p_dur[1][2]=p_dur[2][2];
                            p_dur[2][0]=obtener_tile(&durezas,info_prota.p_tilex+2,info_prota.p_tiley-1,0);
                            p_dur[2][1]=obtener_tile(&durezas,info_prota.p_tilex+2,info_prota.p_tiley  ,0);
                            p_dur[2][2]=obtener_tile(&durezas,info_prota.p_tilex+2,info_prota.p_tiley+1,0);
                            //si avanzamos hasta rampa traspasable invertida, la atravesamos (la ponemos a cero)
                            switch (p_dur[1][1])
                            case 26,29,76,79:           //extras
                                p_dur[1][1]=0;
                            end
                            end //switch
                        end
                        end
                    end //case media rampa superior descendente
                    
                    //normal, sin rampa
                    default:
                        //ya sabemos que la sig casilla est libre
                        //es posible que por culpa de la altura, el techo no nos deje pasar
                        switch (p_dur[2][0])
                        case 1,2,3,5,13,14,15,16,51,52,53,55,63,64,65,66,   //normales
                             33,83:                                         //extras
                            if (info_prota.p_offsy < 14)
                                p_libre=false;
                            else
                                p_libre=true;
                            end
                        end
                        default: p_libre=true; end
                        end //switch
                        
                        //actuamos en consecuencia
                        if (p_libre)
                            info_prota.p_mover_h--;
                            //venimos de caer en diagonal, hay que frenar la caida
                            if (p_dir_ini==3)
                                info_prota.p_mover_v=0;
                                info_prota.vel_vert=0;
                                info_prota.estado=0;
                            end
                            //actualizamos casilla actual
                            p_dur[0][0]=p_dur[1][0];
                            p_dur[0][1]=p_dur[1][1];
                            p_dur[0][2]=p_dur[1][2];
                            p_dur[1][0]=p_dur[2][0];
                            p_dur[1][1]=p_dur[2][1];
                            p_dur[1][2]=p_dur[2][2];
                            p_dur[2][0]=obtener_tile(&durezas,info_prota.p_tilex+2,info_prota.p_tiley-1,0);
                            p_dur[2][1]=obtener_tile(&durezas,info_prota.p_tilex+2,info_prota.p_tiley  ,0);
                            p_dur[2][2]=obtener_tile(&durezas,info_prota.p_tilex+2,info_prota.p_tiley+1,0);
                            //si avanzamos hasta rampa traspasable invertida, la atravesamos (la ponemos a cero)
                            switch (p_dur[1][1])
                            case 26,28,29,31,76,78,79,81:           //extras
                                p_dur[1][1]=0;
                            end
                            end //switch
                        else
                            info_prota.p_mover_h=0;
                            info_prota.vel_horiz=0;
                            x3+=(12-info_prota.p_offsx)*resolution3;
                            //no hay que actualizar casilla actual
                        end
                    end //case sin rampa
                    
                    end //switch estamos en rampa
                end //casilla lateral libre
                
                //no se permite el paso
                default:
                    //comprobamos si estamos en casilla con rampa
                    switch (p_dur[1][1])
                    
                    //rampa y media rampa superior
                    case 3,16,53,66,                //normales
                         27,31,77,81:               //extras
                        info_prota.p_mover_v=0;
                        info_prota.estado=0;
                        //comprobamos la casilla superior para ver si podemos avanzar en diagonal
         //prueba rara
                        info_prota.vel_vert-=(info_prota.p_offsy*resolution3)+20;
                        //info_prota.vel_vert=0;
                        //y3-=(info_prota.p_offsy+1)*resolution3;
                        //info_prota.offsy=-1;
                        p_dir=9;
                    end //rampa y media rampa superior
                    
                    //media rampa inferior y media rampa superior en descenso
                    case 15,30,65,80,14,29,64,79:
                        //caso especial, pues se podria avanzar si la sig casilla
                        //fuera media rampa superior normal (las traspasables se
                        //contemplaron antes)
                        switch (p_dur[2][1])
                        case 16,66:
                            info_prota.p_mover_h--;
         //prueba rara
                            info_prota.vel_vert=-(info_prota.vel_horiz-(info_prota.vel_horiz%2))/2;
                            //actualizamos casilla actual
                            p_dur[0][0]=p_dur[1][0];
                            p_dur[0][1]=p_dur[1][1];
                            p_dur[0][2]=p_dur[1][2];
                            p_dur[1][0]=p_dur[2][0];
                            p_dur[1][1]=p_dur[2][1];
                            p_dur[1][2]=p_dur[2][2];
                            p_dur[2][0]=obtener_tile(&durezas,info_prota.p_tilex+2,info_prota.p_tiley-1,0);
                            p_dur[2][1]=obtener_tile(&durezas,info_prota.p_tilex+2,info_prota.p_tiley  ,0);
                            p_dur[2][2]=obtener_tile(&durezas,info_prota.p_tilex+2,info_prota.p_tiley+1,0);
                        end
                        case 13,63:
                            info_prota.p_mover_h--;
         //prueba rara
                            info_prota.vel_vert+=(info_prota.vel_horiz/2);
                            //actualizamos casilla actual
                            p_dur[0][0]=p_dur[1][0];
                            p_dur[0][1]=p_dur[1][1];
                            p_dur[0][2]=p_dur[1][2];
                            p_dur[1][0]=p_dur[2][0];
                            p_dur[1][1]=p_dur[2][1];
                            p_dur[1][2]=p_dur[2][2];
                            p_dur[2][0]=obtener_tile(&durezas,info_prota.p_tilex+2,info_prota.p_tiley-1,0);
                            p_dur[2][1]=obtener_tile(&durezas,info_prota.p_tilex+2,info_prota.p_tiley  ,0);
                            p_dur[2][2]=obtener_tile(&durezas,info_prota.p_tilex+2,info_prota.p_tiley+1,0);
                        end
                        default:    //no podemos pasar
                            info_prota.p_mover_h--;
                            info_prota.vel_horiz=0;
                            x3+=(11-info_prota.p_offsx)*resolution3;
                            if (p_dir_ini==3)
                                p_dir=2;
                            end
                            //no hay que actualizar casilla actual
                        end
                        end //switch
                    end //media rampa inferior y media rampa superior en descenso
                    
                    //sin rampa
                    default:
                        info_prota.p_mover_h=0;
                        info_prota.vel_horiz=0;
                        x3+=(11-info_prota.p_offsx)*resolution3;
                        //no hay que actualizar casilla actual
                        //atencion, si ibamos en diagonal hacia abajo, es posible que aun nos podamos
                        //mover hacia abajo
                        if (p_dir_ini==3) p_dir=2; end
                    end //sin rampa
                    
                    end //switch estamos en rampa
                end //casilla lateral obstruida
                
                end //switch dureza lateral
            end //movimiento lateral*******
            
            if (p_dir==9)
                //say("p_dir=9");
                //comprobamos si la casilla est libre
                switch (p_dur[2][0])
                //casilla libre
                case 0,3,15,25,50,53,65,75,         //normal
                     26..32,34,76..82,84,           //extras
                     100,104,105,                   //especiales (extras)
                     150..255:                      //otras
                    p_libre=true;
                end
                //casilla ocupada
                default:
                    p_libre=false;
                end
                end //switch dureza diagonal
                
                //say(itoa(info_prota.vel_vert));
                
                if (p_libre)
                    info_prota.p_mover_v++;
                    info_prota.p_mover_h--;
                    //actualizamos casilla actual
                    p_dur[0][0]=obtener_tile(&durezas,info_prota.p_tilex  ,info_prota.p_tiley-2,0);
                    p_dur[0][1]=p_dur[1][0];
                    p_dur[0][2]=p_dur[1][1];
                    p_dur[1][0]=obtener_tile(&durezas,info_prota.p_tilex+1,info_prota.p_tiley-2,0);
                    p_dur[1][1]=p_dur[2][0];
                    p_dur[1][2]=p_dur[2][1];
                    p_dur[2][0]=obtener_tile(&durezas,info_prota.p_tilex+2,info_prota.p_tiley-2,0);
                    p_dur[2][1]=obtener_tile(&durezas,info_prota.p_tilex+2,info_prota.p_tiley-1,0);
                    p_dur[2][2]=obtener_tile(&durezas,info_prota.p_tilex+2,info_prota.p_tiley  ,0);
                    //si avanzamos hasta rampa traspasable invertida, la atravesamos (la ponemos a cero)
                    switch (p_dur[1][1])
                    case 26,28,29,31,76,78,79,81:           //extras
                        p_dur[1][1]=0;
                    end
                    end //switch
                else
                    info_prota.p_mover_h=0;
                    info_prota.vel_horiz=0;
                    x3+=(11-info_prota.p_offsx)*resolution3;
                    //no hay que actualizar casilla actual
                    p_dir=8;
                end
            end
        
        end //movimiento a la derecha
        
        //***************************************************************
        //***************************************************************
        
        if (info_prota.vel_horiz<0)  //movimiento a la izquierda
        
            if (p_dir==1) //movim diagonal hacia abajo
                //say("p_dir=1");
                switch (p_dur[0][2])
                //casos en los que no se puede descender
                case 1,4,5,25,51,54,55,75,  //normales
                     105:                   //especiales (extra)
                    p_dir=4;
                    //vel_vert=(15*resolution3)-(info_prota.p_offsy*resolution3);
                end
                //casos en los que SI
                default:
                    //comprobamos si el que hay a la derecha nos deja avanzar
                    switch (p_dur[0][1])
                    //casos en los que si se puede avanzar
                    case 0,5,25,50,55,75,                   //normales
                         27,30,31,32,33,77,80,81,82,83,     //extras
                         100,104,105,                       //especiales (extra)
                         150..255:                          //otras
                        p_libre=1;
                    end
                    //casos en los que, aunque libre, se avanza en otra dir
                    case 2,13,52,63,                        //normales
                         26,28,76,78:                       //extras
                        p_libre=2;
                    end
                    //casos en que no
                    default: p_libre=0; end
                    end //switch
                    
                    //ahora, p_libre indica
                    //0: no se puede avanzar.
                    //1: se puede avanzar.
                    //2: hay una rampa a la misma altura
                    switch (p_libre)
                    //no se puede avanzar
                    case 0:
                        info_prota.p_mover_h=0;
                        info_prota.vel_horiz=0;
                        x3+=(4-info_prota.p_offsx)*resolution3;
                        p_dir=2;
                    end
                    //si se puede
                    case 1:
                        info_prota.p_mover_v--;
                        info_prota.p_mover_h++;
                        //si el tile diagonal esta vacio podemos caer*******************************
                        switch (p_dur[0][2])
                        case 0,2,13,14,15,50,52,63,64,65,                   //normales
                             26,28,29,30,32,33,34,76,78,79,80,82,83,84,     //extras
                             100,104,                                       //especiales (extra)
                             150..255:                                      //otras
                            
                            //todo listo para caer... pero no si estamos sobre el borde de una caida
                            switch (p_dur[1][2])
                            case 1,2,4,5,14,25,51,52,54,55,64,75,       //normales
                                 26,29,76,79,                           //extras
                                 105:                                   //especiales (extra)
                                
                                if (((info_prota.p_offsx*resolution3)+info_prota.vel_horiz) >= 
                                    (-4*resolution3))
                                    //no podemos caer aun
                                    p_dir=4;
                                else
                                    //si podemos caer
                                    info_prota.estado=3;
                                    //actualizamos casilla actual
                                    p_dur[2][0]=p_dur[1][1];
                                    p_dur[2][1]=p_dur[1][2];
                                    p_dur[2][2]=obtener_tile(&durezas,info_prota.p_tilex  ,info_prota.p_tiley+2,0);
                                    p_dur[1][0]=p_dur[0][1];
                                    p_dur[1][1]=p_dur[0][2];
                                    p_dur[1][2]=obtener_tile(&durezas,info_prota.p_tilex-1,info_prota.p_tiley+2,0);
                                    p_dur[0][0]=obtener_tile(&durezas,info_prota.p_tilex-2,info_prota.p_tiley  ,0);
                                    p_dur[0][1]=obtener_tile(&durezas,info_prota.p_tilex-2,info_prota.p_tiley-1,0);
                                    p_dur[0][2]=obtener_tile(&durezas,info_prota.p_tilex-2,info_prota.p_tiley-2,0);
                                end //if al borde
                            end
                            default:
                                //si podemos caer
                                info_prota.estado=3;
                                //actualizamos casilla actual
                                p_dur[2][0]=p_dur[1][1];
                                p_dur[2][1]=p_dur[1][2];
                                p_dur[2][2]=obtener_tile(&durezas,info_prota.p_tilex  ,info_prota.p_tiley+2,0);
                                p_dur[1][0]=p_dur[0][1];
                                p_dur[1][1]=p_dur[0][2];
                                p_dur[1][2]=obtener_tile(&durezas,info_prota.p_tilex-1,info_prota.p_tiley+2,0);
                                p_dur[0][0]=obtener_tile(&durezas,info_prota.p_tilex-2,info_prota.p_tiley  ,0);
                                p_dur[0][1]=obtener_tile(&durezas,info_prota.p_tilex-2,info_prota.p_tiley-1,0);
                                p_dur[0][2]=obtener_tile(&durezas,info_prota.p_tilex-2,info_prota.p_tiley-2,0);
                            end
                            end //switch suelo
                        end
                        case 3,53:
                            //rampa: nos movemos y perdemos toda la velocidad, con esto se acaba el movimiento
                            //esto es mejor, ponemos una velocidad de la gravedad superior para traspasar la rampa, y luego nos recolocaremos
                            if (info_prota.estado!=2)
                               /*vel_vert=(info_prota.p_offsx*resolution3)+info_prota.vel_horiz-
                                           (id_tscroll.tmapa[0].ancho_tile*resolution3);*/
         //prueba rara
                               info_prota.vel_vert=-info_prota.vel_horiz;
                            end
                            //actualizamos casilla actual
                            p_dur[2][0]=p_dur[1][1];
                            p_dur[2][1]=p_dur[1][2];
                            p_dur[2][2]=obtener_tile(&durezas,info_prota.p_tilex  ,info_prota.p_tiley+2,0);
                            p_dur[1][0]=p_dur[0][1];
                            p_dur[1][1]=p_dur[0][2];
                            p_dur[1][2]=obtener_tile(&durezas,info_prota.p_tilex-1,info_prota.p_tiley+2,0);
                            p_dur[0][0]=obtener_tile(&durezas,info_prota.p_tilex-2,info_prota.p_tiley  ,0);
                            p_dur[0][1]=obtener_tile(&durezas,info_prota.p_tilex-2,info_prota.p_tiley-1,0);
                            p_dur[0][2]=obtener_tile(&durezas,info_prota.p_tilex-2,info_prota.p_tiley-2,0);
                        end
                        end
                        //actualizamos casilla actual           
                        //lo hemos hecho antes, hay un caso especial que contemplar
                    end
                    //hay una rampa
                    case 2:
                        p_dir=4;
                    end
                    end //switch
                end
                end //switch
            end //movimiento diagonal******
            
            if (p_dir==4)   //movimiento lateral
                //say("p_dir=4");
                switch (p_dur[0][1])            
                
                //si permite el paso normal
                case 0,2,5,13,25,50,52,52,63,75,    //normales
                     26..32,33,76..82,83,           //extras
                     100,104,105,                   //especiales (extras)
                     150..255:                      //otras
                    //comprobamos la casilla actual, podramos estar en una rampa ascendente y dejarnos en
                    //un tile superior en lugar del tile de al lado
                    
                    switch (p_dur[1][1])
                    
                    //estamos en rampa o media rampa superior
                    case 2,14,52,64,                //normales
                         26,29,76,79:               //extras
                        //comprobamos el techo izquierdo. Aqui pueden pasar tres cosas que almacenaremos en p_libre
                        //0: No se permite el paso
                        //1: Se permite el paso, nos movemos lateralmente
                        //2: Se permite el paso PERO un tile nos obliga a permanecer en el superior
                        switch (p_dur[0][0])
                        //parte superior libre
                        case 0,25,50,75,                            //normales
                             27,29,30,31,32,33,77,79,80,81,82,83,   //extras
                             100,104,105,                           //especiales (extras)
                             150..255:                          //otras
                            p_libre=1;
                        end
                        //caso especial, hay una rampa que obliga a ir diagonal
                        case 2,13,52,63,            //normales
                             26,28,76,78:           //extras
                            p_libre=2;
                        end
                        //parte superior ocupada
                        default:
                            p_libre=0;
                        end
                        end //switch comprobando sig techo
                        
                        //caso especial: la siguiente casilla permite atravesarse en todas direcciones menos
                        //               hacia abajo
                        switch (p_dur[0][1])
                        case 25,75,105:             //extras
                            p_libre=2;
                        end
                        end //switch, caso especial tile izquierdo
                        //caso especial: no nos hemos movido lo suficiente a la izquierda para caernos, nos
                        //               sujeta la esquina del grfico.
                        if ( ((x3+info_prota.vel_horiz) % (id_tscroll.tmapa[0].ancho_tile*resolution3)) > 
                             (11*resolution3) )
                            p_libre=2;
                        end
                        
                        //Y ACTUAMOS SEGUN ESTE MOVIMIENTO
                        switch (p_libre)
                        //no se puede avanzar
                        case 0:
                            info_prota.p_mover_h=0;
                            info_prota.vel_horiz=0;
                            x3+=(4-info_prota.p_offsx)*resolution3;
                        end
                        //si se puede avanzar
                        case 1:
                            info_prota.p_mover_h++;
         //prueba rara
                            info_prota.vel_vert-=(info_prota.p_offsx*resolution3);  //quitamos tanta velocidad 
                                                                                    //como pixels por subir
                            info_prota.estado=3;
                            //actualizamos casilla actual
                            p_dur[2][0]=p_dur[1][0];
                            p_dur[2][1]=p_dur[1][1];
                            p_dur[2][2]=p_dur[1][2];
                            p_dur[1][0]=p_dur[0][0];
                            p_dur[1][1]=p_dur[0][1];
                            p_dur[1][2]=p_dur[0][2];
                            p_dur[0][0]=obtener_tile(&durezas,info_prota.p_tilex-2,info_prota.p_tiley-1,0);
                            p_dur[0][1]=obtener_tile(&durezas,info_prota.p_tilex-2,info_prota.p_tiley  ,0);
                            p_dur[0][2]=obtener_tile(&durezas,info_prota.p_tilex-2,info_prota.p_tiley+1,0);
                        end
                        //se avanza, pero se sube al mismo tiempo
                        case 2:
                            info_prota.p_mover_h++;
                            info_prota.p_mover_v--;
         //prueba rara
                            info_prota.vel_vert-=(info_prota.p_offsy*resolution3)+10;
                            //actualizamos casilla actual
                            p_dur[2][0]=obtener_tile(&durezas,info_prota.p_tilex  ,info_prota.p_tiley-2,0);
                            p_dur[2][1]=p_dur[1][0];
                            p_dur[2][2]=p_dur[1][1];
                            p_dur[1][0]=obtener_tile(&durezas,info_prota.p_tilex-1,info_prota.p_tiley-2,0);
                            p_dur[1][1]=p_dur[0][0];
                            p_dur[1][2]=p_dur[0][1];
                            p_dur[0][0]=obtener_tile(&durezas,info_prota.p_tilex-2,info_prota.p_tiley-2,0);
                            p_dur[0][1]=obtener_tile(&durezas,info_prota.p_tilex-2,info_prota.p_tiley-1,0);
                            p_dur[0][2]=obtener_tile(&durezas,info_prota.p_tilex-2,info_prota.p_tiley  ,0);
                            //si avanzamos hasta rampa traspasable invertida, la atravesamos (la ponemos a cero)
                            switch (p_dur[1][1])
                            case 27,29,30,31,77,79,80,81:           //extras
                                p_dur[1][1]=0;
                            end
                            end //switch
                        end
                        end //switch direccin final de movimiento
                        
                    end //case rampa o media rampa superior
                                                                
                    //estamos en media rampa inferior
                    case 13,28,63,78:
                        //comprobamos si el techo nos deja avanzar
                        switch (p_dur[0][0])
                        //Si se puede
                        case 0,25,50,75,                    //normal (he eliminado las rampas de techo)
                             26..32,33,76..82,83,           //extras
                             100,104,105,                   //especiales (extras)
                             150..255:                      //otras
                            p_libre=1;
                        end
                        default:
                            p_libre=0;
                        end
                        end //switch comprobando sig techo
                        
                        //actuamos en consecuencia
                        switch (p_libre)
                        case 0:
                            info_prota.p_mover_h=0;
                            info_prota.vel_horiz=0;
                            x3+=(4-info_prota.p_offsx)*resolution3;
                            //no hay que actualizar casilla actual
                        end
                        case 1:
                            info_prota.p_mover_h++;
         //prueba rara
                            info_prota.vel_vert-=(info_prota.p_offsy-(id_tscroll.tmapa[0].ancho_tile/2));
                            //actualizamos casilla actual
                            p_dur[2][0]=p_dur[1][0];
                            p_dur[2][1]=p_dur[1][1];
                            p_dur[2][2]=p_dur[1][2];
                            p_dur[1][0]=p_dur[0][0];
                            p_dur[1][1]=p_dur[0][1];
                            p_dur[1][2]=p_dur[0][2];
                            p_dur[0][0]=obtener_tile(&durezas,info_prota.p_tilex-2,info_prota.p_tiley-1,0);
                            p_dur[0][1]=obtener_tile(&durezas,info_prota.p_tilex-2,info_prota.p_tiley  ,0);
                            p_dur[0][2]=obtener_tile(&durezas,info_prota.p_tilex-2,info_prota.p_tiley+1,0);
                            //si avanzamos hasta rampa traspasable invertida, la atravesamos (la ponemos a cero)
                            switch (p_dur[1][1])
                            case 27,31,77,81:           //extras
                                p_dur[1][1]=0;
                            end
                            end //switch
                        end
                        end
                    end //case media rampa inferior
                    
                    //estamos en media rampa superior descendente
                    case 16,31,66,81:
                        //comprobamos si el techo nos deja avanzar
                        switch (p_dur[0][0])
                        //Si se puede
                        case 0,25,50,75,                    //normal (he eliminado las rampas de techo)
                             26..32,33,76..82,83,           //extras
                             100,104,105,                   //especiales (extras)
                             150..255:                          //otras
                            p_libre=1;
                        end
                        default:
                            p_libre=0;
                        end
                        end //switch comprobando sig techo
                        
                        //actuamos en consecuencia
                        switch (p_libre)
                        //no se puede
                        case 0:
                            info_prota.vel_horiz=0;
                            x3+=(4-info_prota.p_offsx)*resolution3;
                            //no hay que actualizar casilla actual
                        end
                        //si se puede
                        case 1:
                            //actualizamos casilla actual
                            p_dur[2][0]=p_dur[1][0];
                            p_dur[2][1]=p_dur[1][1];
                            p_dur[2][2]=p_dur[1][2];
                            p_dur[1][0]=p_dur[0][0];
                            p_dur[1][1]=p_dur[0][1];
                            p_dur[1][2]=p_dur[0][2];
                            p_dur[0][0]=obtener_tile(&durezas,info_prota.p_tilex-2,info_prota.p_tiley-1,0);
                            p_dur[0][1]=obtener_tile(&durezas,info_prota.p_tilex-2,info_prota.p_tiley  ,0);
                            p_dur[0][2]=obtener_tile(&durezas,info_prota.p_tilex-2,info_prota.p_tiley+1,0);
                            //si avanzamos hasta rampa traspasable invertida, la atravesamos (la ponemos a cero)
                            switch (p_dur[1][1])
                            case 27,31,77,81:           //extras
                                p_dur[1][1]=0;
                            end
                            end //switch
                        end
                        end
                    end //case media rampa superior descendente
                    
                    //normal, sin rampa
                    default:
                        //ya sabemos que la sig casilla est libre
                        //es posible que por culpa de la altura, el techo no nos deje pasar
                        switch (p_dur[0][0])
                        case 1,2,3,4,13,14,15,16,51,52,53,54,63,64,65,66,   //normales
                             34,84:                                         //extras
                            if (info_prota.p_offsy < 14)
                                p_libre=false;
                            else
                                p_libre=true;
                            end
                        end
                        default: p_libre=true; end
                        end //switch
                        
                        //actuamos en consecuencia
                        if (p_libre)
                            info_prota.p_mover_h++;
                            if (p_dir_ini==1)
                                info_prota.p_mover_v=0;
                                info_prota.vel_vert=0;
                                info_prota.estado=0;
                            end
                            //actualizamos casilla actual
                            p_dur[2][0]=p_dur[1][0];
                            p_dur[2][1]=p_dur[1][1];
                            p_dur[2][2]=p_dur[1][2];
                            p_dur[1][0]=p_dur[0][0];
                            p_dur[1][1]=p_dur[0][1];
                            p_dur[1][2]=p_dur[0][2];
                            p_dur[0][0]=obtener_tile(&durezas,info_prota.p_tilex-2,info_prota.p_tiley-1,0);
                            p_dur[0][1]=obtener_tile(&durezas,info_prota.p_tilex-2,info_prota.p_tiley  ,0);
                            p_dur[0][2]=obtener_tile(&durezas,info_prota.p_tilex-2,info_prota.p_tiley+1,0);
                            //si avanzamos hasta rampa traspasable invertida, la atravesamos (la ponemos a cero)
                            switch (p_dur[1][1])
                            case 27,29,30,31,77,79,80,81:           //extras
                                p_dur[1][1]=0;
                            end
                            end //switch
                        else
                            info_prota.p_mover_h=0;
                            info_prota.vel_horiz=0;
                            x3+=(4-info_prota.p_offsx)*resolution3;
                            //no hay que actualizar casilla actual
                        end
                    end //case sin rampa
                    
                    end //switch estamos en rampa
                end //casilla lateral libre
                                                            
                //no se permite el paso
                default:
                    //comprobamos si estamos en casilla con rampa
                    switch (p_dur[1][1])
                    
                    //rampa y media rampa superior
                    case 2,14,52,64,                //normales
                         26,29,76,79:               //extras
                        info_prota.p_mover_v=0;
                        info_prota.estado=0;
                        //comprobamos la casilla superior para ver si podemos avanzar en diagonal
         //prueba rara
                        info_prota.vel_vert-=(info_prota.p_offsy*resolution3)+20;
                        p_dir=7;
                    end //rampa y media rampa superior
                    
                    //media rampa inferior y media rampa superior en descenso
                    case 13,28,63,78,16,31,66,81:
                        //caso especial, pues se podria avanzar si la sig casilla
                        //fuera media rampa superior normal (las traspasables se
                        //contemplaron antes)
                        switch (p_dur[0][1])
                        case 14,64:
                            info_prota.p_mover_h++;
         //prueba rara
                            info_prota.vel_vert=-(info_prota.vel_horiz-(info_prota.vel_horiz%2))/2;
                            //actualizamos casilla actual
                            p_dur[2][0]=p_dur[1][0];
                            p_dur[2][1]=p_dur[1][1];
                            p_dur[2][2]=p_dur[1][2];
                            p_dur[1][0]=p_dur[0][0];
                            p_dur[1][1]=p_dur[0][1];
                            p_dur[1][2]=p_dur[0][2];
                            p_dur[0][0]=obtener_tile(&durezas,info_prota.p_tilex-2,info_prota.p_tiley-1,0);
                            p_dur[0][1]=obtener_tile(&durezas,info_prota.p_tilex-2,info_prota.p_tiley  ,0);
                            p_dur[0][2]=obtener_tile(&durezas,info_prota.p_tilex-2,info_prota.p_tiley+1,0);
                        end
                        case 15,65:
                            info_prota.p_mover_h++;
         //prueba rara
                            info_prota.vel_vert+=(info_prota.vel_horiz/2);
                            //actualizamos casilla actual
                            p_dur[2][0]=p_dur[1][0];
                            p_dur[2][1]=p_dur[1][1];
                            p_dur[2][2]=p_dur[1][2];
                            p_dur[1][0]=p_dur[0][0];
                            p_dur[1][1]=p_dur[0][1];
                            p_dur[1][2]=p_dur[0][2];
                            p_dur[0][0]=obtener_tile(&durezas,info_prota.p_tilex-2,info_prota.p_tiley-1,0);
                            p_dur[0][1]=obtener_tile(&durezas,info_prota.p_tilex-2,info_prota.p_tiley  ,0);
                            p_dur[0][2]=obtener_tile(&durezas,info_prota.p_tilex-2,info_prota.p_tiley+1,0);
                        end
                        default:    //no podemos pasar
                            info_prota.p_mover_h=0;
                            info_prota.vel_horiz=0;
                            x3+=(4-info_prota.p_offsx)*resolution3;
                            if (p_dir_ini==1)
                                p_dir=2;
                            end
                            //no hay que actualizar casilla actual
                        end
                        end //switch
                    end //media rampa inferior y media rampa superior en descenso
                    
                    //sin rampa
                    default:
                        info_prota.p_mover_h=0;
                        info_prota.vel_horiz=0;
                        x3+=(4-info_prota.p_offsx)*resolution3;
                        //no hay que actualizar casilla actual
                        //atencion, si ibamos en diagonal hacia abajo, es posible que aun nos podamos
                        //mover hacia abajo
                        if (p_dir_ini==1) p_dir=2; end
                    end //sin rampa
                    
                    end //switch estamos en rampa
                end //casilla lateral obstruida
                
                end //switch dureza lateral
            end //movimiento lateral*******
            
            if (p_dir==7)
                //say("p_dir=7");
                //comprobamos si la casilla est libre
                switch (p_dur[0][0])
                //casilla libre
                case 0,2,13,25,50,52,63,75,         //normal
                     26..32,33,76..82,83,           //extras
                     100,104,105,                   //especiales (extras)
                     150..255:                          //otras
                    p_libre=true;
                end
                //casilla ocupada
                default:
                    p_libre=false;
                end
                end //switch dureza diagonal
                
                if (p_libre)
                    info_prota.p_mover_v++;
                    info_prota.p_mover_h++;
                    //actualizamos casilla actual
                    p_dur[2][0]=obtener_tile(&durezas,info_prota.p_tilex  ,info_prota.p_tiley-2,0);
                    p_dur[2][1]=p_dur[1][0];
                    p_dur[2][2]=p_dur[1][1];
                    p_dur[1][0]=obtener_tile(&durezas,info_prota.p_tilex-1,info_prota.p_tiley-2,0);
                    p_dur[1][1]=p_dur[0][0];
                    p_dur[1][2]=p_dur[0][1];
                    p_dur[0][0]=obtener_tile(&durezas,info_prota.p_tilex-2,info_prota.p_tiley-2,0);
                    p_dur[0][1]=obtener_tile(&durezas,info_prota.p_tilex-2,info_prota.p_tiley-1,0);
                    p_dur[0][2]=obtener_tile(&durezas,info_prota.p_tilex-2,info_prota.p_tiley  ,0);
                    //si avanzamos hasta rampa traspasable invertida, la atravesamos (la ponemos a cero)
                    switch (p_dur[1][1])
                    case 27,29,30,31,77,79,80,81:           //extras
                        p_dur[1][1]=0;
                    end
                    end //switch
                else
                    info_prota.p_mover_h=0;
                    info_prota.vel_horiz=0;
                    x3+=(4-info_prota.p_offsx)*resolution3;
                    //no hay que actualizar casilla actual
                    p_dir=8;
                end
            end
        
        end //movimiento a la derecha
        
        //******************************************************
        //******************************************************
        
        //movimientos verticales
        if (p_dir==2)    //movimiento hacia abajo
            switch (p_dur[1][2])
            //no se puede
            case 1,4,5,25,51,54,55,75,
                 105:                       //especial (extra) ********** CAMBIAR ********************************
                info_prota.p_mover_v=0;
                info_prota.vel_vert=0;
                y3+=(id_tscroll.tmapa[0].alto_tile-1-info_prota.p_offsy)*resolution3;
                if (info_prota.estado==3) info_prota.estado=0; end
            end //no se puede
            //si se puede
            default:
                //ATENCIN, puede que estemos tan abajo (por ejemplo, en el pico de una rampa) que parezca que
                //podemos bajar, as que, antes, hay que evitar esto
                switch (p_dur[1][1])
                //estamos en peligro de atravesar el suelo
                case 2,3,13,15,52,53,63,65:
                    p_libre=false;
                end
                //caso especial: rampas transpasables, debemos asegurarnos que no vamos por debajo
                case 26,76:
                    if (info_prota.p_offsy < info_prota.p_offsx)
                        p_libre=false;
                    else
                        p_libre=true;
                    end
                end
                case 27,77:
                    if (info_prota.p_offsy < (id_tscroll.tmapa[0].alto_tile-1-info_prota.p_offsx))
                        p_libre=false;
                    else
                        p_libre=true;
                    end
                end
                case 28,78:
                    if (info_prota.p_offsy < ((id_tscroll.tmapa[0].alto_tile/2)-1+(info_prota.p_offsx/2)) )
                        p_libre=false;
                    else
                        p_libre=true;
                    end
                end
                case 29,79:
                    if (info_prota.p_offsy < (info_prota.p_offsx/2) )
                        p_libre=false;
                    else
                        p_libre=true;
                    end
                end
                case 30,80:
                    if (info_prota.p_offsy < ((id_tscroll.tmapa[0].alto_tile-1)-
                        ((id_tscroll.tmapa[0].alto_tile/2)-1+(info_prota.p_offsx/2))) )
                        p_libre=false;
                    else
                        p_libre=true;
                    end
                end
                case 31,81:
                    if (info_prota.p_offsy < ((id_tscroll.tmapa[0].alto_tile-1)-(info_prota.p_offsx/2)) )
                        p_libre=false;
                    else
                        p_libre=true;
                    end
                end
                //no hay peligro
                default:
                    p_libre=true; 
                end
                end
                
                //ahora hay que mirar que no estemos pisando un borde de las casillas diagonales bajas
                if (p_libre)
                    //pegado a la izquierda
                    if (info_prota.p_offsx<4)
                        switch (p_dur[0][2])
                        case 1,3,4,5,16,25,51,53,54,55,66,75,           //normales
                             27,31,77,81:                               //extras
                            p_libre=false;
                        end
                        end //switch
                    end
                    //pegado a la derecha
                    if (info_prota.p_offsx>11)
                        switch (p_dur[2][2])
                        case 1,2,4,5,14,25,51,52,54,55,64,75,           //normales
                             26,29,76,79:                               //extras
                            p_libre=false;
                        end
                        end //switch
                    end
                end
                
                //y actuamos en consecuencia
                if (p_libre)
                    info_prota.p_mover_v--;
                    info_prota.estado=3;
                    //actualizamos casilla actual
                    p_dur[0][0]=p_dur[0][1];
                    p_dur[1][0]=p_dur[1][1];
                    p_dur[2][0]=p_dur[2][1];
                    p_dur[0][1]=p_dur[0][2];
                    p_dur[1][1]=p_dur[1][2];
                    p_dur[2][1]=p_dur[2][2];
                    p_dur[0][2]=obtener_tile(&durezas,info_prota.p_tilex-1,info_prota.p_tiley+2,0);
                    p_dur[1][2]=obtener_tile(&durezas,info_prota.p_tilex  ,info_prota.p_tiley+2,0);
                    p_dur[2][2]=obtener_tile(&durezas,info_prota.p_tilex+1,info_prota.p_tiley+2,0);
                    //limitamos movimientos laterales si el nuevo techo no nos deja avanzar
                    switch (p_dur[0][0])
                    case 1,2,3,4,13,14,15,16,51,52,53,54,63,64,65,66,   //normales
                         34,84:                                         //extras
                        if ((info_prota.vel_horiz < 0) && ((info_prota.p_offsx+info_prota.vel_horiz)<4))
                            info_prota.p_mover_h=0;
                            info_prota.vel_horiz=0;
                            x3+=(4-info_prota.p_offsx)*resolution3;
                        end
                    end
                    end //switch
                    switch (p_dur[2][0])
                    case 1,2,3,5,13,14,15,16,51,52,53,55,63,64,65,66,   //normales
                         33,83:                                         //extras
                        if ((info_prota.vel_horiz > 0) && ((info_prota.p_offsx+info_prota.vel_horiz)>11))
                            info_prota.p_mover_h=0;
                            info_prota.vel_horiz=0;
                            x3+=(11-info_prota.p_offsx)*resolution3;
                        end
                    end
                    end //switch
                else
                    info_prota.p_mover_v=0;
                    info_prota.estado=0;
                    info_prota.vel_vert=0;
                    y3+=(id_tscroll.tmapa[0].alto_tile-1-info_prota.p_offsy)*resolution3;
                end
                
            end //si se puede
            end //switch mirar tile abajo
        end //movimiento hacia abajo
        
        if (p_dir==8)       //movimiento hacia arriba
            //comprobamos la casilla superior
            switch (p_dur[1][0])
            //no se puede
            case 1,2,3,13,14,15,16,51,52,53,63,64,65,66,        //normales
                 32,82:                                         //extras
                p_libre=false;
            end //no se puede
            //se puede
            default:
                p_libre=true;
                //comprobando no chocarse con los bordes de las casillas diagonales
                if (info_prota.p_offsx < 4)
                    switch (p_dur[0][0])
                    case 1,2,3,4,13,14,15,16,51,52,53,54,63,64,65,66,   //normales
                         32,82:                                         //extras
                        p_libre=false;
                    end
                    end //switch
                end //pegado a la izquierda
                if (info_prota.p_offsx > 11)
                    switch (p_dur[2][0])
                    case 1,2,3,5,13,14,15,16,51,52,53,55,63,64,65,66,   //normales
                         32,82:                                         //extras
                        p_libre=false;
                    end
                    end //switch
                end //pegado a la derecha
            end
            end //switch mirar tile arriba
            
            //y actuamos en consecuencia
            if (p_libre)
                info_prota.p_mover_v++;
                //actualizamos casilla actual
                p_dur[0][2]=p_dur[0][1];
                p_dur[1][2]=p_dur[1][1];
                p_dur[2][2]=p_dur[2][1];
                p_dur[0][1]=p_dur[0][0];
                p_dur[1][1]=p_dur[1][0];
                p_dur[2][1]=p_dur[2][0];
                p_dur[0][0]=obtener_tile(&durezas,info_prota.p_tilex-1,info_prota.p_tiley-2,0);
                p_dur[1][0]=obtener_tile(&durezas,info_prota.p_tilex  ,info_prota.p_tiley-2,0);
                p_dur[2][0]=obtener_tile(&durezas,info_prota.p_tilex+1,info_prota.p_tiley-2,0);
            else
                info_prota.p_mover_v=0;
                info_prota.vel_vert=0;
                y3-=info_prota.p_offsy*resolution3;
            end
            
        end //movimiento hacia arriba
        
        //*********************************************************
        //  comprobacin tile actual
        //*********************************************************
        
        //p_dur indica los tiles actuales que rodean al personaje
        //info_prota.vel_vert e info_prota.vel_horiz indica las posiciones que nos podemos mover
        
        x3+=info_prota.vel_horiz;   //actualizamos posicin
        y3+=info_prota.vel_vert;
        
        info_prota.p_offsx= (x3/resolution3)%id_tscroll.tmapa[0].ancho_tile;
        info_prota.p_offsy= (y3/resolution3)%id_tscroll.tmapa[0].alto_tile;
        
        //say(itoa(info_prota.p_offsy));
        
        //y ahora nos movemos dentro del propio tile
        p_libre=true;
        switch (p_dur[1][1])
        //el tile est libre
        case 0,25,50,75,                    //normal
             33,34,83,84,                   //extras
             100,104,105,                   //especiales (extras)
             150..255:                      //otras
            
            p_libre=true;
            //comprobamos no chocarnos con una pared
            if (info_prota.p_offsx < 4)
                //pared
                switch (p_dur[0][1])
                //no se puede pasar
                case 1,3,4,16,51,53,54,66,              //normales
                     34,84:                             //extras
                    x3+=(4-info_prota.p_offsx)*resolution3;
                    info_prota.p_offsx+=(4-info_prota.p_offsx);
                    info_prota.vel_horiz=0;
                end //no se puede
                //no se puede si no estamos a una altura mnima (medias rampas)
                case 14,15,64,65:
                    if (info_prota.p_offsy > (id_tscroll.tmapa[0].alto_tile/2))
                        x3+=(4-info_prota.p_offsx)*resolution3;
                        info_prota.p_offsx+=(4-info_prota.p_offsx);
                        info_prota.vel_horiz=0;
                    end
                end //no se puede si n estamos a una altura mnima (medias rampas)
                end //switch
            end  //pared
            
                
            if (info_prota.p_offsx < 4)
                //esquina de un techo
                switch (p_dur[0][0])
                //no se puede subir
                case 1,2,3,4,13,14,15,16,51,52,53,54,63,64,65,66,   //normales
                     32,82:                                         //extras
                    if (info_prota.p_offsy < 14)
                        if (info_prota.vel_vert < 0) //TEST********
                            y3+=(14-info_prota.p_offsy)*resolution3;
                            info_prota.p_offsy+=(14-info_prota.p_offsy);
                            p_libre=false;
                        end
                        //podemos chocar con techo tambin si hemos saltado y nos desplazamos de lado
                        if ((info_prota.p_offsx-info_prota.vel_horiz) >= 4)
                            x3+=(4-info_prota.p_offsx)*resolution3;
                            info_prota.p_offsx+=(4-info_prota.p_offsx);
                            info_prota.vel_horiz=0;
                        end
                    end
                end
                end //switch
            end //esquina de un techo
                
            if (info_prota.p_offsx > 11)
                switch (p_dur[2][1])
                //no se puede pasar
                case 1,2,5,14,51,52,55,64,              //normales
                     33,83:                             //extras
                    x3-=(info_prota.p_offsx-11)*resolution3;
                    info_prota.p_offsx-=(info_prota.p_offsx-11);
                    info_prota.vel_horiz=0;
                end //no se puede
                //no se puede si no estamos a una altura mnima (medias rampas)
                case 13,16,63,66:
                    if (info_prota.p_offsy > (id_tscroll.tmapa[0].alto_tile/2))
                        x3-=(info_prota.p_offsx-11)*resolution3;
                        info_prota.p_offsx-=(info_prota.p_offsx-11);
                        info_prota.vel_horiz=0;
                    end
                end //no se puede si n estamos a una altura mnima (medias rampas)
                end //switch
            end //pared
            
            //esquina de un techo
            if (info_prota.p_offsx > 11)    
                switch (p_dur[2][0])
                //no se puede subir
                case 1,2,3,5,13,14,15,16,51,52,53,55,63,64,65,66,   //normales
                     32,82:                                         //extras
                    if (info_prota.p_offsy < 14)
                        if (info_prota.vel_vert < 0)
                            y3+=(14-info_prota.p_offsy)*resolution3;
                            info_prota.p_offsy+=(14-info_prota.p_offsy);
                            p_libre=false;
                        end
                        if ((info_prota.p_offsx-info_prota.vel_horiz) <= 11)
                            x3-=(info_prota.p_offsx-11)*resolution3;
                            info_prota.p_offsx-=(info_prota.p_offsx-11);
                            info_prota.vel_horiz=0;
                        end
                    end
                end
                end //switch
            end
            //p_libre=true;
            
            //segn el tipo de techo que tengamos, haremos una cosa u otra
            switch (p_dur[1][0])
            //techo liso
            case 1,2,3,13,14,15,16,51,52,53,63,64,65,66,
                 32,82:
                 
                if (info_prota.p_offsy < 14)
                    y3+=(14-info_prota.p_offsy)*resolution3;
                    p_libre=false;
                end
                
            end //techo liso
            //techo diagonal, parte baja a la derecha
            case 4,54:
                if (info_prota.p_offsy < (info_prota.p_offsx-2))
                    y3+=(info_prota.p_offsx-2-info_prota.p_offsy)*resolution3;
                    p_libre=false;
                end
            end //techo diagonal, parte baja a la derecha
            //techo diagonal, parte baja a la izquierda
            case 5,55:
                if (info_prota.p_offsy < (id_tscroll.tmapa[0].alto_tile-info_prota.p_offsx-2))
                    y3+=(id_tscroll.tmapa[0].alto_tile-info_prota.p_offsx-2-info_prota.p_offsy)*resolution3;
                    p_libre=false;
                end
            end //techo diagonal, parte baja a la izquierda
            end //switch techo
        end //casilla libre
        
        //rampa, parte alta a la izquierda
        case 2,52,                  //normales
             26,76:                 //extras
            
            //comprobamos no chocarnos con una pared
            if (info_prota.p_offsx < 4)
                switch (p_dur[0][0])    //miramos el superior
                //no se puede pasar (incluye medias rampas, para pasarlas tendramos que estar en otro tile)
                case 1,3,4,14,15,16,51,53,54,64,65,66,          //normales
                     34,84:                                     //extras
                    x3+=(4-info_prota.p_offsx)*resolution3;
                    info_prota.p_offsx+=(4-info_prota.p_offsx);
                    info_prota.vel_horiz=0;
                end //no se puede
                end //switch
            end
            if (info_prota.p_offsx > 11)
                switch (p_dur[2][1])
                //no se puede pasar
                case 1,2,5,14,51,52,55,64,              //normales
                     33,83:                             //extras
                    x3-=(info_prota.p_offsx-11)*resolution3;
                    info_prota.p_offsx-=(info_prota.p_offsx-11);
                    info_prota.vel_horiz=0;
                end //no se puede
                //no se puede si no estamos a una altura mnima (medias rampas)
                case 13,16,63,66:
                    if (info_prota.p_offsy > (id_tscroll.tmapa[0].alto_tile/2))
                        x3-=(info_prota.p_offsx-11)*resolution3;
                        info_prota.p_offsx-=(info_prota.p_offsx-11);
                        info_prota.vel_horiz=0;
                    end
                end //no se puede si n estamos a una altura mnima (medias rampas)
                end //switch
            end
            p_libre=true;
            
            //segn el tipo de techo que tengamos, haremos una cosa u otra
            switch (p_dur[1][0])
            //techo liso
            case 1,2,3,13,14,15,16,51,52,53,63,64,65,66,
                 32,82:
                //la distancia es menor hacia la izquierda, apenas podemos avanzar
                if (info_prota.p_offsx < 13)
                    x3+=(13-info_prota.p_offsx)*resolution3;
                    info_prota.vel_horiz=0;
                end
                if (info_prota.p_offsy < 14)
                    y3+=(14-info_prota.p_offsy)*resolution3;
                    p_libre=false;
                end
            end //techo liso
            //techo diagonal, parte derecha abajo
            case 4,54:
                //podemos estar a todo lo ancho del tile, pues la distancia es constante: un tile de altura
                if (info_prota.p_offsy < (info_prota.p_offsx-1))
                    y3+=((info_prota.p_offsx-1)-info_prota.p_offsy)*resolution3;
                    p_libre=false;
                end
            end //techo diagonal, parte derecha abajo
            //techo diagonal, parte izquierda abajo
            case 5,55:
                //podemos avanzar slo hasta casi la mitad, la distancia se cierra por momentos, aunque
                //inicialmente tenemos una altura de 2 tiles en la parte derecha
                if (info_prota.p_offsx < ((id_tscroll.tmapa[0].ancho_tile/2)-2))
                    x3+=(((id_tscroll.tmapa[0].ancho_tile/2)-2) - info_prota.p_offsx)*resolution3;
                    info_prota.vel_horiz=0;
                end
                if (info_prota.p_offsy < (id_tscroll.tmapa[0].alto_tile-1-info_prota.p_offsx))
                    y3+=((id_tscroll.tmapa[0].alto_tile-1-info_prota.p_offsx)-info_prota.p_offsy) * resolution3;
                    p_libre=false;
                end
            end //techo diagonal, parte izquierda abajo
            end //switch techo
            
            
            
            //da igual el tipo de techo que tengamos, no podemos atravesar el suelo
            if (info_prota.p_offsy >= info_prota.p_offsx)
            
                y3+=(info_prota.p_offsx - info_prota.p_offsy)*resolution3;
                if (info_prota.estado==3) info_prota.estado=0; end
                info_prota.p_mover_v=0;
                info_prota.vel_vert=0;
                //info_prota.vel_vert=abs(info_prota.vel_horiz)+cte_prota_acelerac;
            end
            
        end //est en rampa, parte alta a la izquierda
        
        //rampa, parte alta a la derecha
        case 3,53,                  //normales
             27,77:                 //extras
             
            //comprobamos no chocarnos con una pared
            if (info_prota.p_offsx < 4)
                switch (p_dur[0][1])
                //no se puede pasar
                case 1,3,4,16,51,53,54,66,              //normales
                     34,84:                             //extras
                    x3+=(4-info_prota.p_offsx)*resolution3;
                    info_prota.p_offsx+=(4-info_prota.p_offsx);
                    info_prota.vel_horiz=0;
                end //no se puede
                //no se puede si no estamos a una altura mnima (medias rampas)
                case 14,15,64,65:
                    if (info_prota.p_offsy > (id_tscroll.tmapa[0].alto_tile/2))
                        x3+=(4-info_prota.p_offsx)*resolution3;
                        info_prota.p_offsx+=(4-info_prota.p_offsx);
                        info_prota.vel_horiz=0;
                    end
                end //no se puede si n estamos a una altura mnima (medias rampas)
                end //switch
            end
            if (info_prota.p_offsx > 11)
                switch (p_dur[2][0])
                //no se puede pasar
                case 1,2,5,13,14,16,51,52,55,63,64,66,              //normales
                     33,83:                                         //extras
                    x3-=(info_prota.p_offsx-11)*resolution3;
                    info_prota.p_offsx-=(info_prota.p_offsx-11);
                    info_prota.vel_horiz=0;
                end //no se puede
                end //switch
            end
            p_libre=true;
            
            //segn el tipo de techo que tengamos, haremos una cosa u otra
            switch (p_dur[1][0])
            //techo liso
            case 1,2,3,13,14,15,16,51,52,53,63,64,65,66,
                 32,82:
                //la distancia es menor hacia la derecha, apenas podemos avanzar
                if (info_prota.p_offsx > 1)
                    x3-=(info_prota.p_offsx-1)*resolution3;
                    info_prota.vel_horiz=0;
                end
                if (info_prota.p_offsy < 14)
                    y3+=(15-info_prota.p_offsy)*resolution3;
                    p_libre=false;
                end
            end //techo liso
            //techo diagonal, parte derecha abajo
            case 4,54:
                //podemos avanzar slo hasta casi la mitad, la distancia se cierra por momentos, aunque
                //inicialmente tenemos una altura de 2 tiles en la parte derecha
                if (info_prota.p_offsx > ((id_tscroll.tmapa[0].ancho_tile/2)+2))
                    x3-=(info_prota.p_offsx-((id_tscroll.tmapa[0].ancho_tile/2)+2))*resolution3;
                    info_prota.vel_horiz=0;
                end
                if (info_prota.p_offsy < (info_prota.p_offsx-1))
                    y3+=((info_prota.p_offsx-1)-info_prota.p_offsy)*resolution3;
                    p_libre=false;
                end
            end //techo diagonal, parte derecha abajo
            //techo diagonal, parte izquierda abajo
            case 5,55:
                //podemos estar a todo lo ancho del tile, pues la distancia es constante: un tile de altura
                if (info_prota.p_offsy < (id_tscroll.tmapa[0].alto_tile-1-info_prota.p_offsx))
                    y3+=((id_tscroll.tmapa[0].alto_tile-1-info_prota.p_offsx)-info_prota.p_offsy) * resolution3;
                    p_libre=false;
                end
            end //techo diagonal, parte izquierda abajo
            end //switch techo
            
            //da igual el tipo de techo que tengamos, no podemos atravesar el suelo
            if (info_prota.p_offsy >= (id_tscroll.tmapa[0].alto_tile-1-info_prota.p_offsx))
                y3+=(id_tscroll.tmapa[0].alto_tile-1-info_prota.p_offsx - info_prota.p_offsy)*resolution3;
                if (info_prota.estado==3) info_prota.estado=0; end
                info_prota.p_mover_v=0;
                info_prota.vel_vert=0;
                //info_prota.vel_vert=abs(info_prota.vel_horiz)+cte_prota_acelerac;
            end
            
        end //est en rampa, parte alta a la derecha
        
        //media rampa baja, parte alta a la izquierda
        case 13,28,             //normales
             63,78:             //extras
             
            //comprobamos no chocarnos con una pared
            if (info_prota.p_offsx < 4)
                switch (p_dur[0][1])
                //no se puede pasar
                case 1,3,4,16,51,53,54,66,              //normales
                     34,84:                             //extras
                    x3+=(4-info_prota.p_offsx)*resolution3;
                    info_prota.p_offsx+=(4-info_prota.p_offsx);
                    info_prota.vel_horiz=0;
                end //no se puede
                end //switch tile lateral
                
                //miramos el tile superior
                switch (p_dur[0][0])
                //no se puede pasar
                case 1,3,4,14,15,16,61,63,64,65,66,     //normales
                     34,84:                             //extras
                    x3+=(4-info_prota.p_offsx)*resolution3;
                    info_prota.p_offsx+=(4-info_prota.p_offsx);
                    info_prota.vel_horiz=0;
                end //no se puede pasar
                end //switch
            end
            if (info_prota.p_offsx > 11)
                switch (p_dur[2][1])
                //no se puede pasar
                case 1,2,5,14,51,52,55,64,              //normales
                     33,83:                             //extras
                    x3-=(info_prota.p_offsx-11)*resolution3;
                    info_prota.p_offsx-=(info_prota.p_offsx-11);
                    info_prota.vel_horiz=0;
                end //no se puede
                //no se puede si no estamos a una altura mnima (medias rampas)
                case 13,16,63,66:
                    if (info_prota.p_offsy > (id_tscroll.tmapa[0].alto_tile/2))
                        x3-=(info_prota.p_offsx-11)*resolution3;
                        info_prota.p_offsx-=(info_prota.p_offsx-11);
                        info_prota.vel_horiz=0;
                    end
                end //no se puede si n estamos a una altura mnima (medias rampas)
                end //switch
            end
            p_libre=true;
             
            //segn el tipo de techo que tengamos, haremos una cosa u otra
            switch (p_dur[1][0])
            //techo liso
            case 1,2,3,13,14,15,16,51,52,53,63,64,65,66,
                 32,82:
                //la distancia es menor hacia la izquierda, apenas podemos avanzar
                if (info_prota.p_offsx < 12)
                    x3+=(12-info_prota.p_offsx)*resolution3;
                    info_prota.vel_horiz=0;
                end
                if (info_prota.p_offsy < 14)
                    y3+=(15-info_prota.p_offsy)*resolution3;
                    p_libre=false;
                end
            end //techo liso
            //techo diagonal, parte derecha abajo
            case 4,54:
                //podemos estar a todo lo ancho del tile, pues la distancia es casi constante: un tile de altura
                if (info_prota.p_offsy < (info_prota.p_offsx-1))
                    y3+=((info_prota.p_offsx-1)-info_prota.p_offsy)*resolution3;
                    p_libre=false;
                end
            end //techo diagonal, parte derecha abajo
            //techo diagonal, parte izquierda abajo
            case 5,55:
                //podemos avanzar slo hasta casi la mitad, la distancia se cierra por momentos, aunque
                //inicialmente tenemos una altura de 2 tiles en la parte derecha
                if (info_prota.p_offsx < ((id_tscroll.tmapa[0].ancho_tile/2)-4))
                    x3+=(((id_tscroll.tmapa[0].ancho_tile/2)-4) - info_prota.p_offsx)*resolution3;
                    info_prota.vel_horiz=0;
                end
                if (info_prota.p_offsy < (id_tscroll.tmapa[0].alto_tile-1-info_prota.p_offsx))
                    y3+=((id_tscroll.tmapa[0].alto_tile-1-info_prota.p_offsx)-info_prota.p_offsy) * resolution3;
                    p_libre=false;
                end
            end //techo diagonal, parte izquierda abajo
            end //switch techo
            
            //da igual el tipo de techo que tengamos, no podemos atravesar el suelo
            if (info_prota.p_offsy >= (((id_tscroll.tmapa[0].alto_tile/2)-1)+(info_prota.p_offsx/2)))
                y3+=((((id_tscroll.tmapa[0].alto_tile/2)-1)+(info_prota.p_offsx/2)) - info_prota.p_offsy)
                    *resolution3;
                if (info_prota.estado==3) info_prota.estado=0; end
                info_prota.p_mover_v=0;
                info_prota.vel_vert=0;
                //info_prota.vel_vert=(abs(info_prota.vel_horiz)+cte_prota_acelerac)/2;
            end
            
        end //media rampa baja, parte alta a la izquierda
        
        //media rampa baja, parte alta a la derecha
        case 15,65,                 //normales
             30,80:                 //extras
            
            //comprobamos no chocarnos con una pared
            if (info_prota.p_offsx < 4)
                switch (p_dur[0][1])
                //no se puede pasar
                case 1,3,4,16,51,53,54,66,              //normales
                     34,84:                             //extras
                    x3+=(4-info_prota.p_offsx)*resolution3;
                    info_prota.p_offsx+=(4-info_prota.p_offsx);
                    info_prota.vel_horiz=0;
                end //no se puede
                //no se puede si no estamos a una altura mnima (medias rampas)
                case 14,15,64,65:
                    if (info_prota.p_offsy > (id_tscroll.tmapa[0].alto_tile/2))
                        x3+=(4-info_prota.p_offsx)*resolution3;
                        info_prota.p_offsx+=(4-info_prota.p_offsx);
                        info_prota.vel_horiz=0;
                    end
                end //no se puede si n estamos a una altura mnima (medias rampas)
                end //switch
            end
            if (info_prota.p_offsx > 11)
                switch (p_dur[2][1])
                //no se puede pasar
                case 1,2,5,14,51,52,55,64,              //normales
                     33,83:                             //extras
                    x3-=(info_prota.p_offsx-11)*resolution3;
                    info_prota.p_offsx-=(info_prota.p_offsx-11);
                    info_prota.vel_horiz=0;
                end //no se puede
                end //switch
                
                //miramos el techo superior
                switch (p_dur[2][0])
                //no se puede pasar
                case 1,2,5,13,14,16,51,52,55,63,64,66,  //normales
                     33,83:                             //extras
                    x3-=(info_prota.p_offsx-11)*resolution3;
                    info_prota.p_offsx-=(info_prota.p_offsx-11);
                    info_prota.vel_horiz=0;
                end //no se puede pasar
                end //switch
            end
            p_libre=true;
            
            //segn el tipo de techo que tengamos, haremos una cosa u otra
            switch (p_dur[1][0])
            //techo liso
            case 1,2,3,13,14,15,16,51,52,53,63,64,65,66,
                 32,82:
                //la distancia es menor hacia la derecha, apenas podemos avanzar
                if (info_prota.p_offsx > 3)
                    x3-=(info_prota.p_offsx-3)*resolution3;
                    info_prota.vel_horiz=0;
                end
                if (info_prota.p_offsy < 14)
                    y3+=(15-info_prota.p_offsy)*resolution3;
                    p_libre=false;
                end
            end //techo liso
            //techo diagonal, parte derecha abajo
            case 4,54:
                //podemos avanzar slo hasta casi la mitad, la distancia se cierra por momentos, aunque
                //inicialmente tenemos una altura de 2 tiles en la parte derecha
                if (info_prota.p_offsx > ((id_tscroll.tmapa[0].ancho_tile/2)+4))
                    x3-=(info_prota.p_offsx-((id_tscroll.tmapa[0].ancho_tile/2)+4))*resolution3;
                    info_prota.vel_horiz=0;
                end
                if (info_prota.p_offsy < (info_prota.p_offsx-1))
                    y3+=((info_prota.p_offsx-1)-info_prota.p_offsy)*resolution3;
                    p_libre=false;
                end
            end //techo diagonal, parte derecha abajo
            //techo diagonal, parte izquierda abajo
            case 5,55:
                //podemos estar a todo lo ancho del tile, pues la distancia es constante: un tile de altura
                if (info_prota.p_offsy < (id_tscroll.tmapa[0].alto_tile-1-info_prota.p_offsx))
                    y3+=((id_tscroll.tmapa[0].alto_tile-1-info_prota.p_offsx)-info_prota.p_offsy) * resolution3;
                    p_libre=false;
                end
            end //techo diagonal, parte izquierda abajo
            end //switch techo
            
            //da igual el tipo de techo que tengamos, no podemos atravesar el suelo
            if (info_prota.p_offsy >= ((id_tscroll.tmapa[0].alto_tile-1)-(info_prota.p_offsx/2)))
                y3+=(((id_tscroll.tmapa[0].alto_tile-1)-(info_prota.p_offsx/2)) - info_prota.p_offsy)
                    *resolution3;
                if (info_prota.estado==3) info_prota.estado=0; end
                info_prota.p_mover_v=0;
                info_prota.vel_vert=0;
                //info_prota.vel_vert=(abs(info_prota.vel_horiz)+cte_prota_acelerac)/2;
            end
            
        end //est en media rampa baja, parte alta a la derecha
        
        //media rampa alta, parte alta a la izquierda
        case 14,64,                         //normales
             29,79:                         //extras
             
            //comprobamos no chocarnos con una pared
            if (info_prota.p_offsx < 4)
                switch (p_dur[0][0])
                //no se puede pasar
                case 1,3,4,14,15,16,51,53,54,64,65,66,              //normales
                     34,84:                                         //extras
                    x3+=(4-info_prota.p_offsx)*resolution3;
                    info_prota.p_offsx+=(4-info_prota.p_offsx);
                    info_prota.vel_horiz=0;
                end //no se puede
                end //switch
            end
            if (info_prota.p_offsx > 11)
                switch (p_dur[2][1])
                //no se puede pasar
                case 1,2,5,14,51,52,55,64,              //normales
                     33,83:                             //extras
                    x3-=(info_prota.p_offsx-11)*resolution3;
                    info_prota.p_offsx-=(info_prota.p_offsx-11);
                    info_prota.vel_horiz=0;
                end //no se puede
                end //switch
                
                //miramos el tile superior
                switch (p_dur[2][0])
                //no se puede pasar
                case 1,2,5,13,14,16,51,52,55,63,64,66,  //normales
                     33,83:                             //extras
                    x3-=(info_prota.p_offsx-11)*resolution3;
                    info_prota.p_offsx-=(info_prota.p_offsx-11);
                    info_prota.vel_horiz=0;
                end //no se puede pasar
                end //switch
            end
            p_libre=true;
             
            //segn el tipo de techo que tengamos, haremos una cosa u otra
            switch (p_dur[1][0])
            //techo liso
            case 1,2,3,13,14,15,16,51,52,53,63,64,65,66,
                 32,82:
                //imposible estar aqui, lo empujamos fuera
                if (info_prota.p_offsx < 15)
                    x3+=(15-info_prota.p_offsx)*resolution3;
                    info_prota.vel_horiz=0;
                end
            end //techo liso
            //techo diagonal, parte derecha abajo
            case 4,54:
                //dificil clculo. Se puede estar hasta poco ms all de la mitad, la distancia va 
                //desde un tile hasta medio tile
                if (info_prota.p_offsx > 4)
                    x3-=(info_prota.p_offsx - 4)*resolution3;
                    p_libre=false;
                end
                if (info_prota.p_offsy < (info_prota.p_offsx-1))
                    y3+=((info_prota.p_offsx-1)-info_prota.p_offsy)*resolution3;
                    p_libre=false;
                end
            end //techo diagonal, parte derecha abajo
            //techo diagonal, parte izquierda abajo
            case 5,55:
                //la distancia va desde cero hasta tile y medio
                if (info_prota.p_offsx < 11)
                    x3+= (11 - info_prota.p_offsx)*resolution3;
                    info_prota.vel_horiz=0;
                end
                if (info_prota.p_offsy < (id_tscroll.tmapa[0].alto_tile-1-info_prota.p_offsx))
                    y3+=((id_tscroll.tmapa[0].alto_tile-1-info_prota.p_offsx)-info_prota.p_offsy) * resolution3;
                    p_libre=false;
                end
            end //techo diagonal, parte izquierda abajo
            end //switch techo
            
            //da igual el tipo de techo que tengamos, no podemos atravesar el suelo
            if (info_prota.p_offsy >= (info_prota.p_offsx/2))
                y3+=((info_prota.p_offsx/2) - info_prota.p_offsy)*resolution3;
                if (info_prota.estado==3) info_prota.estado=0; end
                info_prota.p_mover_v=0;
                info_prota.vel_vert=0;
                //info_prota.vel_vert=(abs(info_prota.vel_horiz)+cte_prota_acelerac)/2;
            end
            
        end //media rampa alta, parte alta a la izquierda
        
        //media rampa alta, parte alta a la derecha
        case 16,66,                         //normales
             31,81:                         //extras
             
            //comprobamos no chocarnos con una pared
            if (info_prota.p_offsx < 4)
                switch (p_dur[0][1])
                //no se puede pasar
                case 1,3,4,16,51,53,54,66,              //normales
                     34,84:                             //extras
                    x3+=(4-info_prota.p_offsx)*resolution3;
                    info_prota.p_offsx+=(4-info_prota.p_offsx);
                    info_prota.vel_horiz=0;
                end //no se puede
                end //switch
                
                //miramos el tile superior
                switch (p_dur[0][0])
                //no se puede pasar
                case 1,3,4,14,15,16,51,53,54,64,65,     //normales
                     34,84:                             //extras
                    x3+=(4-info_prota.p_offsx)*resolution3;
                    info_prota.p_offsx+=(4-info_prota.p_offsx);
                    info_prota.vel_horiz=0;
                end //no se puede pasar
                end //switch
            end
            if (info_prota.p_offsx > 11)
                switch (p_dur[2][0])
                //no se puede pasar
                case 1,2,5,13,14,16,51,52,55,63,64,66,              //normales
                     33,83:                                         //extras
                    x3-=(info_prota.p_offsx-11)*resolution3;
                    info_prota.p_offsx-=(info_prota.p_offsx-11);
                    info_prota.vel_horiz=0;
                end //no se puede
                //no se puede si no estamos a una altura mnima (medias rampas)
                end //switch
            end
            p_libre=true;
             
            //segn el tipo de techo que tengamos, haremos una cosa u otra
            switch (p_dur[1][0])
            //techo liso
            case 1,2,3,13,14,15,16,51,52,53,63,64,65,66,
                 32,82:
                //imposible estar aqui, lo empujamos fuera
                if (info_prota.p_offsx >= 0)
                    x3-=(info_prota.p_offsx+1)*resolution3;
                    info_prota.vel_horiz=0;
                end
            end //techo liso
            //techo diagonal, parte derecha abajo
            case 4,54:
                //la distancia va desde tile y medio hasta cero
                if (info_prota.p_offsx > 5)
                    x3-= (info_prota.p_offsx - 5)*resolution3;
                    info_prota.vel_horiz=0;
                end
                
                if (info_prota.p_offsy < (info_prota.p_offsx-1))
                    y3+=((info_prota.p_offsx-1)-info_prota.p_offsy)*resolution3;
                    p_libre=false;
                end
            end //techo diagonal, parte derecha abajo
            //techo diagonal, parte izquierda abajo
            case 5,55:
                //dificil clculo. Se puede estar hasta poco ms all de la mitad, la distancia va 
                //desde un medio tile hasta un tile
                if (info_prota.p_offsx < 13)
                    x3+=(13 - info_prota.p_offsx)*resolution3;
                    p_libre=false;
                end
                if (info_prota.p_offsy < (id_tscroll.tmapa[0].alto_tile-1-info_prota.p_offsx))
                    y3+=((id_tscroll.tmapa[0].alto_tile-1-info_prota.p_offsx)-info_prota.p_offsy) * resolution3;
                    p_libre=false;
                end
            end //techo diagonal, parte izquierda abajo
            end //switch techo
            
            //da igual el tipo de techo que tengamos, no podemos atravesar el suelo
            if (info_prota.p_offsy >= ((id_tscroll.tmapa[0].alto_tile/2)-(info_prota.p_offsx/2)))
                y3+=(((id_tscroll.tmapa[0].alto_tile/2)-(info_prota.p_offsx/2)) - info_prota.p_offsy)
                     *resolution3;
                if (info_prota.estado==3) info_prota.estado=0; end
                info_prota.p_mover_v=0;
                info_prota.vel_vert=0;
                //info_prota.vel_vert=(abs(info_prota.vel_horiz)+cte_prota_acelerac)/2;
            end
        end //media rampa alta, parte alta a la izquierda
        
        //techo, parte baja a la derecha
        case 4,54:
            //si nos movemos lateralmente chocaremos con el techo, no debemos poder avanzar
            if ((info_prota.vel_horiz>0) && (info_prota.p_offsx>2))
                x3-=(info_prota.p_offsx-2)*resolution3;
                info_prota.p_offsx-=(info_prota.p_offsx-2);
                if (info_prota.vel_vert<0)
                    info_prota.vel_vert=0;
                    info_prota.estado=3;
                    info_prota.p_mover_v=0;
                end
            end
            //da igual la direccin en la que nos movamos, no podemos atravesar el techo
            if (info_prota.p_offsy < (id_tscroll.tmapa[0].alto_tile+info_prota.p_offsx-3))
                y3+=((id_tscroll.tmapa[0].alto_tile+info_prota.p_offsx-3)-info_prota.p_offsy)*resolution3;
                p_libre=false;
            end
        end //techo parte baja a la derecha
        
        //techo, parte baja a la izquierda
        case 5,55:
            //si nos movemos lateralmente chocaremos con el techo, no debemos poder avanzar
            if ((info_prota.vel_horiz<0) && (info_prota.p_offsx<14))
                x3+=(14-info_prota.p_offsx)*resolution3;
                info_prota.p_offsx+=(14-info_prota.p_offsx);
                if (info_prota.vel_vert<0)
                    info_prota.vel_vert=0;
                    info_prota.estado=3;
                    info_prota.p_mover_v=0;
                end
            end
            //da igual la direccin en la que nos movamos, no podemos atravesar el techo
            if (info_prota.p_offsy < ((2*id_tscroll.tmapa[0].alto_tile)-3-info_prota.p_offsx))
                y3+=(((2*id_tscroll.tmapa[0].alto_tile)-3-info_prota.p_offsx)-info_prota.p_offsy) * resolution3;
                p_libre=false;
            end
        end //techo parte baja a la izquierda
        
        end //switch propio tile
        
        //comprobamos choque contra el techo
        if (!p_libre)
            if (info_prota.vel_vert<0) info_prota.vel_vert=0; end
            if (info_prota.estado==2) 
                cont_salto=cte_moto_max_salto;
                info_prota.estado=3;
            end
            info_prota.p_mover_v=0;
        end
        
        //**********************************************
        //  Zona de daos
        //**********************************************
        if (info_prota.p_invencible>0) info_prota.p_invencible--; end
        
        //**********************************************
        //  Zona de animaciones
        //**********************************************
        if (info_prota.vel_horiz<0) flags=1; end
        if (info_prota.vel_horiz>0) flags=0; end
        
        switch (p_dur[1][1])
        case 2:
            angle=-45000;
            if ((flags & 1)==1) angle=-angle; end
        end
        case 3:
            angle=45000;
            if ((flags & 1)==1) angle=-angle; end
        end
        case 13,14:
            angle=-22500;
            if ((flags & 1)==1) angle=-angle; end
        end
        case 15,16:
            angle=22500;
            if ((flags & 1)==1) angle=-angle; end
        end
        default:
            if ((info_prota.estado==2) || (info_prota.estado==3))
                angle=22500;
            else
                angle=0;
            end
        end
        end //switch
        
        file=prota_file;
        graph=1;
        
        
        x2=x3/resolution3;
        y2=y3/resolution3;
        tscroll_get_screen_position(&id_tscroll,x2,y2,&x,&y);
        
        //parpadeo de invencible: cambia cada 4 frames, y comprobamos si es par (se ve) o impar (no se ve)
        //debe ser aqui, pues el disparo depende del grfico
        if ((info_prota.p_invencible & 4) == 4) graph=0; end
        
        frame;
    end
end
