function obtener_tile (t_mapa pointer ot_struct, int at_posx, int at_posy, int at_posz)
private
       int dato_a_devolver;
       int at_pos;
begin
     if ( (at_posx>=0) && (at_posx<[ot_struct].columnas) &&
          (at_posy>=0) && (at_posy<[ot_struct].filas) &&
          (at_posz>=0) && (at_posz<[ot_struct].capas) )

        at_pos=(at_posz*[ot_struct].columnas*[ot_struct].filas)+
               (at_posy*[ot_struct].columnas)+
               at_posx;
        switch ([ot_struct].tipo_dato)
        case 0:
             dato_a_devolver=[ot_struct].b_mapa[at_pos];
        end
        case 1:
             dato_a_devolver=[ot_struct].w_mapa[at_pos];
        end
        case 2:
             dato_a_devolver=[ot_struct].i_mapa[at_pos];
        end
        case 3:
             //at_posx=at_posx%[ts_struct].tmapa[0].columnas;
             //at_posy=at_posy%[ts_struct].tmapa[0].filas;
             if (map_exists([ot_struct].fpg_mapa,at_posz+1) == 0)
                dato_a_devolver=0;
             else
                 dato_a_devolver=map_get_pixel([ot_struct].fpg_mapa,at_posz+1,at_posx,at_posy);
             end
        end
        end
        //dato_a_devolver=1;
     else
         dato_a_devolver=0;
     end
     return (dato_a_devolver);
end

function modificar_tile (t_mapa pointer ot_struct, int at_posx, int at_posy, int at_posz, int at_valor)
private
       int dato_a_devolver;
       int at_pos;
begin
     if ( (at_posx>=0) && (at_posx<[ot_struct].columnas) &&
          (at_posy>=0) && (at_posy<[ot_struct].filas) &&
          (at_posz>=0) && (at_posz<[ot_struct].capas) )

        at_pos=(at_posz*[ot_struct].columnas*[ot_struct].filas)+
               (at_posy*[ot_struct].columnas)+
               at_posx;
        switch ([ot_struct].tipo_dato)
        case 0:
             [ot_struct].b_mapa[at_pos]= at_valor & 255;
        end
        case 1:
             [ot_struct].w_mapa[at_pos]= at_valor & 65535;
        end
        case 2:
             [ot_struct].i_mapa[at_pos]= at_valor;
        end
        case 3:
             //at_posx=at_posx%[ts_struct].tmapa[0].columnas;
             //at_posy=at_posy%[ts_struct].tmapa[0].filas;
             if (map_exists([ot_struct].fpg_mapa,at_posz+1) != 0)
                 map_put_pixel([ot_struct].fpg_mapa,at_posz+1,at_posx,at_posy,at_valor);
             end
        end
        end
        dato_a_devolver=1;
     else
         dato_a_devolver=0;
     end
     return (dato_a_devolver);
end
