PROGRAM Doggy;

include "tmapa.h";
include "tscroll.h";
include "jkey.h";

include "enemigos.h";
include "sound.h";
include "game.h";
include "savegame.h";

CONST
    cte_frameskip=0;
    
    k_up=0;
    k_down=1;
    k_left=2;
    k_right=3;
    k_jump=4;
    k_fire=5;
    k_next=6;
    k_previous=7;
    k_enter=8;
    k_esc=9;
    k_vol_up=10;
    k_vol_down=11;
    k_last=12;
    
LOCAL
    int energia;
    
GLOBAL
    
    //variables globales del programa
    global_mode;
    global_vol;
    global_opt;
    //variables de control del personaje
    string nombre_tecla;    //guarda el nombre de una tecla al pulsarla en la config
    teclas[k_last-1][2];    //almacena el codigo de la tecla asignada y cuanto lleva pulsada

include "load_tmap.inc";
include "tscroll.inc";
include "tmapa.inc";
include "jkey.inc";
include "generic.inc";

include "interface.inc";
include "signals.inc";
include "signals_event.inc";
include "savegame.inc";
include "game.inc";
include "prota.inc";
include "prota_moto.inc";
include "weapons.inc";
include "items.inc";
include "enemigos_weapons.inc";
include "enemigos.inc";
include "events.inc";

include "pregame.inc";

BEGIN
    //primera inicializacin
    set_fps(50,cte_frameskip);
    //set_fps(3,0);
    //fpsdebug();
    if (os_id<4)
        full_screen=false;
        scale_mode=scale_nofilter;
        inicia_teclas(0);
    else
        full_screen=true;
        inicia_teclas(1);
    end
    set_mode(320,240,16);
    
    prota_control=true;
    ctrl_teclas();
    musica();
    volume_control();
    
    //global_menu(1,"Continue","Exit","","","");
    //global_menu(2,"Easy (5 lives)","Medium (3 lives)","Hard (1 live)","","");
    
    //logos
    logos();
    signal(id,s_sleep);
    frame;
    //fade(100,100,100,255);
    //resto
    //global_mode=101; //test
    global_mode=0;
    loop
        switch (global_mode)
        case 0:     //MENU PRINCIPAL
            portada();
            signal(id,s_sleep);
            frame;
        end
        case 1:     //MENU CONFIGURACION TECLAS
        end
        case 2:     //MENU SELECCION NIVEL
        end
        case 3:     //JUEGO
            game();
            signal(id,s_sleep);
            frame;
            
            //global_mode=0;
        end
        case 4:     //CREDITOS
            credits();
            signal(id,s_sleep);
            frame;
        end
        case 100:   //SALIR
            //say("final");
            break;
        end
        case 101:
            prota_file=load_fpg("grafs/prota.fpg");
            armas_file=load_fpg("grafs/weapons.fpg");
            init_weapons();
            armas_select=1;
            enem_grafs[0]=load_fpg("grafs/blobo.fpg");
            item_grafs=load_fpg("grafs/items.fpg");
            //say("cargado "+itoa(prota_file));
            if (load_tmf("levels/CSal3.dur",&durezas))
            //if (load_tmf("../FenixLand/IFenix2.tmf",&durezas))
                start_tscroll(&id_tscroll,&durezas,0,0,0,320,240,4,4,16,16,0);
                id_tscroll.ts_file=load_fpg("levels/durezas.fpg");
                ts_actualiza_tiles(&id_tscroll);
                //id_tscroll.id_target=prota_moto();
                id_tscroll.id_target=prota(9,2);
                global_mode=100;
                while (teclas[k_esc][2]==0) frame; end
                
                unload_fpg(id_tscroll.ts_file);
                unload_fpg(prota_file);
            else
                say("no se encuentra el mapa");
                global_mode=100;
            end
        end
        end //switch
    end
    
    let_me_alone();
END

process fpsdebug ()
begin
    loop
        if (key(_f1)) set_fps(50,0); end
        if (key(_f2)) set_fps(3,0); end
        if (key(_f3)) set_fps(1,0); end
        
        if (key(_f5)) info_prota.p_energ--; refresh_interface_energy(); end
        if (key(_f6)) info_prota.p_energ++; refresh_interface_energy(); end
        if (teclas[k_previous][2]==1)
            //search_start_point(&nivel,&durezas,0,&x2,&y2);
            //shot_exp(x2,y2,5,10);
            shot_exp(x2,10,1,10);
        end
        //if (teclas[k_next][2]==1) shot_exp(x2,10,-1,10); end
        frame;
    end
end
