//******************************************************************************
//  PROCESO DE CONTROL DE TECLAS
//******************************************************************************
process ctrl_teclas ()
private
       cont;
begin
    priority=100;
    loop
        //say(itoa(joy_number()));
        if (joy_number())
            if (prota_control)
                if ( joy_getbutton(0,_jkey_up) ||
                     joy_getbutton(0,_jkey_upleft) ||
                     joy_getbutton(0,_jkey_upright)
                    )
                   teclas[k_up][2]++;
                else
                    teclas[k_up][2]=0;
                end
                if ( joy_getbutton(0,_jkey_down) ||
                     joy_getbutton(0,_jkey_downleft) ||
                     joy_getbutton(0,_jkey_downright)
                    )
                   teclas[k_down][2]++;
                else
                    teclas[k_down][2]=0;
                end
                if ( joy_getbutton(0,_jkey_left) ||
                     joy_getbutton(0,_jkey_upleft) ||
                     joy_getbutton(0,_jkey_downleft)
                    )
                   teclas[k_left][2]++;
                else
                    teclas[k_left][2]=0;
                end
                if ( joy_getbutton(0,_jkey_right) ||
                     joy_getbutton(0,_jkey_upright) ||
                     joy_getbutton(0,_jkey_downright)
                    )
                   teclas[k_right][2]++;
                else
                    teclas[k_right][2]=0;
                end
                    
                for (cont=4;cont<k_last;cont++)
                    if (joy_getbutton(0,teclas[cont][1]))
                        teclas[cont][2]++;
                    else
                        teclas[cont][2]=0;
                    end
                end
            else        //no se tiene control sobre el teclado
                for (cont=0;cont<k_enter;cont++)
                        teclas[cont][2]=0;
                end
                for (cont=k_enter;cont<k_last;cont++)
                    if (joy_getbutton(0,teclas[cont][1]))
                        teclas[cont][2]++;
                    else
                        teclas[cont][2]=0;
                    end
                end
            end
            
         else
            if (prota_control)
                for (cont=0;cont<k_last;cont++)
                    if (key(teclas[cont][0]))
                        teclas[cont][2]++;
                    else
                        teclas[cont][2]=0;
                    end
                end
            else
                for (cont=0;cont<k_enter;cont++)
                    teclas[cont][2]=0;
                end
                for (cont=k_enter;cont<k_last;cont++)
                    if (key(teclas[cont][0]))
                        teclas[cont][2]++;
                    else
                        teclas[cont][2]=0;
                    end
                end
            end
         end
         frame;
     end
end

/*process ctrl_teclas ()
private
       cont;
begin
    priority=-100;
     loop
         //say(itoa(joy_number()));
         if (joy_number())
            for (cont=0;cont<k_last;cont++)
                if (joy_getbutton(0,teclas[cont][1]))
                    teclas[cont][2]++;
                else
                    teclas[cont][2]=0;
                end
            end
         else
            for (cont=0;cont<k_last;cont++)
                if (key(teclas[cont][0]))
                    teclas[cont][2]++;
                else
                    teclas[cont][2]=0;
                end
            end
         end
         frame;
     end
end*/

process scan_code2 ()
private
       cont;
begin
     cont=0;
     if (joy_number())
        if (joy_getbutton(0,_jkey_up)) cont=_up; end
        if (joy_getbutton(0,_jkey_down)) cont=_down; end
        if (joy_getbutton(0,_jkey_left)) cont=_left; end
        if (joy_getbutton(0,_jkey_right)) cont=_right; end
        if (joy_getbutton(0,_jkey_a)) cont=_control; end
        if (joy_getbutton(0,_jkey_b)) cont=_alt; end
        if (joy_getbutton(0,_jkey_x)) cont=_x; end
        if (joy_getbutton(0,_jkey_y)) cont=_y; end
        if (joy_getbutton(0,_jkey_start)) cont=_enter; end
        if (joy_getbutton(0,_jkey_select)) cont=_space; end
     end
     
     if (key(_up)) cont=_up; end
     if (key(_down)) cont=_down; end
     if (key(_left)) cont=_left; end
     if (key(_right)) cont=_right; end
     if (key(_control)) cont=_control; end
     if (key(_alt)) cont=_alt; end
     if (key(_x)) cont=_x; end
     if (key(_y)) cont=_y; end
     if (key(_enter)) cont=_enter; end
     if (key(_space)) cont=_space; end

     return (cont);
end

//  CONFIGURACION DE TECLAS
//******************************************************************************
process inicia_teclas (k_sist)
begin
     switch (k_sist)
     case 0:          //version pc
          teclas[k_up][0]=_up;
          teclas[k_down][0]=_down;
          teclas[k_left][0]=_left;
          teclas[k_right][0]=_right;
          teclas[k_jump][0]=_z;                 //salto
          teclas[k_fire][0]=_x;                 //disparo
          teclas[k_previous][0]=_a;             //arma anterior
          teclas[k_next][0]=_s;                 //arma_siguiente
          teclas[k_enter][0]=_enter;            //pausa
          teclas[k_esc][0]=_esc;                //salir
          teclas[k_vol_up][0]=_c_plus;          //subir volumen
          teclas[k_vol_down][0]=_c_minus;       //bajar volumen
     end
     case 1:
          teclas[k_up][0]=_up;
          teclas[k_down][0]=_down;
          teclas[k_left][0]=_left;
          teclas[k_right][0]=_right;
          teclas[k_jump][0]=_z;                 //salto
          teclas[k_fire][0]=_x;                 //disparo
          teclas[k_previous][0]=_a;             //arma anterior
          teclas[k_next][0]=_s;                 //arma_siguiente
          teclas[k_enter][0]=_enter;            //pausa
          teclas[k_esc][0]=_esc;                //salir
          teclas[k_vol_up][0]=_c_plus;          //subir volumen
          teclas[k_vol_down][0]=_c_minus;       //bajar volumen
          
          teclas[k_up][1]=_jkey_up;
          teclas[k_down][1]=_jkey_down;
          teclas[k_left][1]=_jkey_left;
          teclas[k_right][1]=_jkey_right;
          teclas[k_jump][1]=_jkey_x;            //salto
          teclas[k_fire][1]=_jkey_a;            //disparo
          teclas[k_previous][1]=_jkey_l;        //arma anterior
          teclas[k_next][1]=_jkey_r;            //arma siguiente
          teclas[k_enter][1]=_jkey_start;       //pausa
          teclas[k_esc][1]=_jkey_select;        //salir
          teclas[k_vol_up][1]=_jkey_volup;          //subir volumen
          teclas[k_vol_down][1]=_jkey_voldown;       //bajar volumen
     end
     end
end

process key_to_string (cont)
begin
     switch (cont)
     case _esc: nombre_tecla="ESC"; end
     case _f1: nombre_tecla="F1"; end
     case _f2: nombre_tecla="F2"; end
     case _f3: nombre_tecla="F3"; end
     case _f4: nombre_tecla="F4"; end
     case _f5: nombre_tecla="F5"; end
     case _f6: nombre_tecla="F6"; end
     case _f7: nombre_tecla="F7"; end
     case _f8: nombre_tecla="F8"; end
     case _f9: nombre_tecla="F9"; end
     case _f10: nombre_tecla="F10"; end
     case _f11: nombre_tecla="F11"; end
     case _f12: nombre_tecla="F12"; end
     
     case _wave: nombre_tecla=""; end
     case _1: nombre_tecla="1"; end
     case _2: nombre_tecla="2"; end
     case _3: nombre_tecla="3"; end
     case _4: nombre_tecla="4"; end
     case _5: nombre_tecla="5"; end
     case _6: nombre_tecla="6"; end
     case _7: nombre_tecla="7"; end
     case _8: nombre_tecla="8"; end
     case _9: nombre_tecla="9"; end
     case _0: nombre_tecla="0"; end
     case _minus: nombre_tecla="?"; end
     case _plus: nombre_tecla=""; end
     
     case _backspace: nombre_tecla="<-"; end
     case _tab: nombre_tecla="TAB"; end
     case _q: nombre_tecla="Q"; end
     case _w: nombre_tecla="W"; end
     case _e: nombre_tecla="E"; end
     case _r: nombre_tecla="R"; end
     case _t: nombre_tecla="T"; end
     case _y: nombre_tecla="Y"; end
     case _u: nombre_tecla="U"; end
     case _i: nombre_tecla="I"; end
     case _o: nombre_tecla="O"; end
     case _p: nombre_tecla="P"; end
     case _l_bracket: nombre_tecla="["; end
     case _r_bracket: nombre_tecla="]"; end
     case _enter: nombre_tecla="ENTER"; end
     
     case _caps_lock: nombre_tecla="BLOQ MAYS"; end
     case _a: nombre_tecla="A"; end
     case _s: nombre_tecla="S"; end
     case _d: nombre_tecla="D"; end
     case _f: nombre_tecla="F"; end
     case _g: nombre_tecla="G"; end
     case _h: nombre_tecla="H"; end
     case _j: nombre_tecla="J"; end
     case _k: nombre_tecla="K"; end
     case _l: nombre_tecla="L"; end
     case _semicolon: nombre_tecla=""; end
     case _apostrophe: nombre_tecla=""; end
     case _backslash: nombre_tecla="<"; end
     
     case _l_shift: nombre_tecla="MAYS IZQU"; end
     case _z: nombre_tecla="Z"; end
     case _x: nombre_tecla="X"; end
     case _c: nombre_tecla="C"; end
     case _v: nombre_tecla="V"; end
     case _b: nombre_tecla="B"; end
     case _n: nombre_tecla="N"; end
     case _m: nombre_tecla="M"; end
     case _comma: nombre_tecla=","; end
     case _point: nombre_tecla="."; end
     case _slash: nombre_tecla="-"; end
     case _r_shift: nombre_tecla="MAYS DRCH"; end
     
     case _control: nombre_tecla="CONTROL"; end
     case _alt: nombre_tecla="ALT"; end
     case _space: nombre_tecla="ESPACIO"; end
     
     case _ins: nombre_tecla="INSERT"; end
     case _home: nombre_tecla="INICIO"; end
     case _pgup: nombre_tecla="RE. PAG."; end
     case _del: nombre_tecla="SUPR"; end
     case _end: nombre_tecla="FIN"; end
     case _pgdn: nombre_tecla="AV. PAG."; end
     
     case _up: nombre_tecla="ARRIBA"; end
     case _down: nombre_tecla="ABAJO"; end
     case _left: nombre_tecla="IZQUIERDA"; end
     case _right: nombre_tecla="DERECHA"; end
     
     case _c_backslash: nombre_tecla="NUM /"; end
     case _c_asterisk: nombre_tecla="NUM *"; end
     case _c_minus: nombre_tecla="NUM -"; end
     case _c_home: nombre_tecla="NUM 7"; end
     case _c_up: nombre_tecla="NUM 8"; end
     case _c_pgup: nombre_tecla="NUM 9"; end
     case _c_left: nombre_tecla="NUM 4"; end
     case _c_center: nombre_tecla="NUM 5"; end
     case _c_right: nombre_tecla="NUM 6"; end
     case _c_end: nombre_tecla="NUM 1"; end
     case _c_down: nombre_tecla="NUM 2"; end
     case _c_pgdn: nombre_tecla="NUM 3"; end
     case _c_ins: nombre_tecla="NUM 0"; end
     case _c_del: nombre_tecla="NUM ."; end
     case _c_plus: nombre_tecla="NUM +"; end
     case _c_enter: nombre_tecla="NUM ENTER"; end
     
     default: cont=-1; end
     end
     
     return (cont);
end
